********************************
* IDENTIFY NEW HIRES
* firmXmuni ID 
* month concept of hiring
* reference month: December    
********************************

clear all
set more off 
cap log close 

*open starting dataset 
gzuse ${dta}/datasetCO_start.dta.gz, clear

forvalues y = 2012/2018 {
	global y `y'
	gen on${y} = ym(year(data_inizio),month(data_inizio))<=ym(${y},12) & ym(year(data_fine),month(data_fine))>=ym(${y},12) // contract active in December of year $y
	bys id_lavoratore id_datorelavoro codcomunelavoro19: egen contratto_on${y}=max(on${y}) // expand at the triple (worker, firm, muni) level (1=at least one contract active in December of year $y)
} 

keep id_lavoratore id_datorelavoro codcomunelavoro19 contratto_on*
duplicates drop id_lavoratore id_datorelavoro codcomunelavoro19, force // keep one obs for the the triple (worker, firm, muni) level

* a worker is a new hire of firmXmuni in December of year $y if: 
* (a) they have at least a contract active in December of year $y; and
* (b) they had NO contract active in December of year $y-1

forvalues y = 2013/2018 {
	global y `y'
	global yp = ${y} - 1
	gen new_hire${y} = contratto_on${y} == 1 & contratto_on${yp} == 0
}

keep id_lavoratore id_datorelavoro codcomunelavoro19 new_hire*

reshape long new_hire, i(id_lavoratore id_datorelavoro codcomunelavoro19) j(anno)
keep if new_hire == 1 

gzsave ${dta}/new_hires_m12.dta.gz, replace 
