********************************
* IDENTIFY NEW HIRES
* firm ID 
* year concept of hiring 
********************************

clear all
set more off 
cap log close 


*open starting dataset 
gzuse ${dta}/datasetCO_start.dta.gz, clear

forvalues y = 2012/2018 {
	global y `y'
	gen on${y} = year(data_inizio)<=${y} & year(data_fine)>=${y} // contract active in year $y
	bys id_lavoratore id_datorelavoro: egen contratto_on${y}=max(on${y}) // expand at the couple (worker, firm) level (1=at least one contract active in year $y)
} 

keep id_lavoratore id_datorelavoro contratto_on*
duplicates drop id_lavoratore id_datorelavoro, force // keep one obs for the the couple (worker, firm) 

* a worker is a new hire of a firm in year $y if: 
* (a) they have at least a contract active in year $y; and
* (b) they had NO contract active in year $y-1

forvalues y = 2013/2018 {
	global y `y'
	global yp = ${y} - 1
	gen new_hire${y} = contratto_on${y} == 1 & contratto_on${yp} == 0
}

keep id_lavoratore id_datorelavoro new_hire*

reshape long new_hire, i(id_lavoratore id_datorelavoro) j(anno)
keep if new_hire == 1 

gzsave ${dta}/new_hires_y_firm.dta.gz, replace 
