********************************************
* GEN ALTERNATIVE IV (leave-one out HH)
* firmXmuni ID 
* year concept of hiring
********************************************


clear all 
set more off 
cap log close 


local g fuaX 
local l first 
local c 1 
local t 1 
   
   ** open the dataset with the HH index at the LLM level 
   use "${dta}/hh_index_contratto_`l'_`g'_tipo`c'_tenure`t'.dta", clear
   
   ** drop markets with missing occupation or geographical area 
   drop if mi(contratto_ID_occ_`l'_c) | mi(`g')
   
   ren anno year 
   egen long ct=group(contratto_ID_occ_`l'_c year)
   
   *alternative IV
   gen lnHHI=ln(hh_new_hire)
    
    egen total = total(lnHHI) if !mi(lnHHI), by(contratto_ID_occ_`l'_c year)
    egen count = count(lnHHI) if !mi(lnHHI), by(contratto_ID_occ_`l'_c year) 
        
    gen iv_l1o=(total - lnHHI)/(count-1)
    
    * check that is the same as that produced by rangestat 
    rangestat lnHHI, int(ct 0 0) excludeself 
    rename lnHHI_mean iv_l1o_alt
    gen diff = iv_l1o-iv_l1o_alt 
    sum diff 
    drop diff 
 
    save "${dta}/IV_hh_index_contratto_`l'_`g'_tipo`c'_tenure`t'L1O.dta", replace

 
