***************************************************
* GEN IV 
* firmXmuni ID 
* year concept of hiring
* HH BASED ON 2 DIGIT OCCUPATIONS
***************************************************

clear all 
set more off 
cap log close 


local l    first 
local g    fuaX 
local c    1 
local t    1
local dig  2 


  
   ** open the dataset with the HH index at the LLM level 
   use "${dta}/hh_index_contratto_`l'_`g'_tipo`c'_tenure`t'_occ${_dig}d.dta", clear

   * drop markets with missing occupation or geographical area 
   
   drop if mi(contratto_ID_occ_`l'_c) | mi(`geo')

  
   ren anno year
   egen long ct=group(contratto_ID_occ_`l'_c year)

   **gen IV
   gen ll1 = ln(1/Nfirms) // Nfirms is the number of hiring firms in the market 

   ***dwld rangestat from ssc
   rangestat ll1, int(ct 0 0) excludeself
   ren ll1_mean iv1
   
   ** check that this is equivalent to
   egen total = total(ll1) if !mi(ll1), by(contratto_ID_occ_`l'_c year)
   egen count = count(ll1) if !mi(ll1), by(contratto_ID_occ_`l'_c year)

   gen iv1_alt = (total - ll1)/(count - 1)
   gen diff = iv1-iv1_alt 
   sum diff 
   drop diff 
  
    
    save "${dta}/IV_hh_index_contratto_`l'_`g'_tipo`c'_tenure`t'_occ${_dig}d.dta", replace

