*********************************************
* 1. GEN ANAGRAFICA COMUNI 
* TUTTI I COMUNI ATTIVI PER ALMENO UN GIORNO 
* DAL 2008 IN POI
*********************************************

** caricare e salvare in formato .dta le anagrafiche dei comuni dal 2008 in poi

filelist, dir(${material}/Archivio-elenco-comuni-codici-e-denominazioni_Anni_2008-2010) pattern(*.xls) save(${material}/t0) replace 
filelist, dir(${material}/Archivio-elenco-comuni-codici-e-denominazioni_Anni_2016-2021) pattern(*.xls) save(${material}/t2) replace 
filelist, dir(${material}/Archivio-elenco-comuni-codici-e-denominazioni_Anni_2011-2015) pattern(*.xls) save(${material}/t1) replace 

forvalues x = 0/2 {
 use ${material}/t`x'.dta, clear 
 gen n = _n 
 qui sum n 
 local ub = `r(max)'
 save ${material}/t`x'.dta, replace 
  forvalues xx = 1/`ub' {
   use if n == `xx' using ${material}/t`x'.dta, clear
   gen temp = subinstr(filename, ".xls", "", .)
   gen l = length(temp)
   gen data = substr(temp,l-9,10)
   local data = data
   local d    = dirname 
   local f    = dirname + "/" + filename
   capture noisily import excel using `f', sheet("CODICI al `data'") clear firstrow
    if _rc ! = 0 {
    capture noisily import excel using `f', sheet("CODICI al_`data'") clear firstrow
    }
    if _rc != 0 {
    capture noisily import excel using `f', sheet("CODICI al  `data'") clear firstrow	
    } 
   if _rc != 0 {
    capture noisily import excel using `f', sheet("CODICI COMUNI 01012019") clear firstrow	
    } 
    if _rc != 0 {
    capture noisily import excel using `f', sheet("CODICI al 01012020") clear firstrow	
    } 
   if _rc != 0 {
    capture noisily import excel using `f', sheet("CODICI al 31_12_2016") clear firstrow	
    } 
    
   missings dropobs, force 
   
   gen data       = "`data'"
   gen data`data' = 1
   
   ds, has(type string)
   local var `r(varlist)'
   foreach v of local var {
    gen l = length(`v')
    qui sum l if l > 0
    global ll = `r(mean)'
    if ${ll} == 6 {
     rename `v' codice_comune_istat
    }
    drop l
   }
   
   ds, has(type string)
   local var `r(varlist)'
   foreach v of local var {
    gen temp = regexm(`v', "[A-Z]+[0-9]+[0-9]+[0-9]")
    qui sum temp, det 
    global ll = `r(p99)'
    if ${ll} == 1 {
     rename `v' codice_comune_belfiore
    }
    drop temp 
   }

   rename Sigla sigla_prov
   
   keep data* codice_comune_* sigla_prov
   
   save ${material}/codici_comuni_al_`data'.dta, replace
  }
}


**
filelist, dir(${material}/Archivio-elenco-comuni-codici-e-denominazioni_Anni_2008-2010) pattern(*.dta) save(${material}/t0) replace 
filelist, dir(${material}/Archivio-elenco-comuni-codici-e-denominazioni_Anni_2011-2015) pattern(*.dta) save(${material}/t1) replace 
filelist, dir(${material}/Archivio-elenco-comuni-codici-e-denominazioni_Anni_2016-2021) pattern(*.dta) save(${material}/t2) replace 

use           ${material}/t0.dta, clear 
append using  ${material}/t1.dta
append using  ${material}/t2.dta

gen n = _n 
qui sum n 
local ub = `r(max)'
save ${material}/t.dta, replace 

clear
forvalues x = 1/`ub' {
 preserve
 use if n == `x' using ${material}/t.dta, clear 
 local f = dirname + "/" + filename
 restore
 append using `f'
 }
 
 gen anno = real(substr(data,7,4))
 
 keep if anno >= 2008 & anno <= 2019
 
 duplicates drop codice_comune_istat codice_comune_belfiore, force // elenco di tutti i codici comune attivi per almeno un giorno dal 2008 al 2019
 replace codice_comune_belfiore = "NA" if codice_comune_belfiore == ""
 
 bys codice_comune_istat (codice_comune_belfiore): gen n=_n
 keep if n == 1
 drop n 
 
 keep codice_comune_istat codice_comune_belfiore
 
 save ${material}/elenco_cod_comune_istat_dal_2008_al_2019.dta, replace
 
 ** caricare e salvare in formato .dta l'elenco delle variazioni territoriali dal 1991 al 2019
 global subdir Variazioni amministrative e territoriali dal 1991 
 import excel "${material}/${subdir}/Variazioni_amministrative_territoriali_dal_01011991.xls", sheet("Variazioni ") firstrow clear
 destring Anno, replace
 keep if inrange(Anno,2008,2019)
 keep if inlist(Tipovariazione,"ES","AP")
 rename (CodiceComuneformatoalfanumeri CodicedelComuneassociatoalla) (codice_comune_vecchio codice_comune_nuovo)
 save ${material}/variazioni_territoriali_fino_al_2019.dta, replace
 
 
 **************************************************************
 * 2. ASSOCIARE OGNI CODICE COMUNE ISTAT AL CODICE COMUNE ISTAT
 *    IN VIGORE IL 31/12/19
 **************************************************************
 
 global subdir  Archivio-elenco-comuni-codici-e-denominazioni_Anni_2016-2021
 global data   31_12_2019

 use ${material}/elenco_cod_comune_istat_dal_2008_al_2019.dta, clear 
 drop if codice_comune_istat == ""
 merge 1:1 codice_comune_istat using ${material}/${subdir}/codici_comuni_al_${data}.dta, keepusing(codice_comune_istat)
 
 preserve
 keep if _merge == 1
 drop _merge
 rename codice_comune_istat codice_comune_vecchio
 keep codice_comune_vecchio codice_comune_belfiore
 merge 1:1 codice_comune_vecchio using ${material}/variazioni_territoriali_fino_al_2019.dta
 drop _merge 
 rename (codice_comune_vecchio codice_comune_nuovo) (codice_comune_istat codice_comune_istat2019)
 tempfile temp 
 save    `temp.dta', replace 
 restore 
 
 drop if _merge == 1
 drop    _merge 
 
 gen codice_comune_istat2019 = codice_comune_istat
 append using `temp.dta'
 
 preserve
 use ${material}/${subdir}/codici_comuni_al_${data}.dta, clear 
 rename * *2019
 tempfile temp2 
 save    `temp2.dta', replace 
 restore
 
 merge m:1 codice_comune_istat2019 using `temp2.dta'
 drop _merge 
 
 ** NB) nei casi di TipoVariazione == AP, il codice Istat cambia, mentre quello belfiore no.
 ** Ecco perchè ci sono casi in cui lo stesso codice belfiore è associato a diversi codice_istat
 duplicates tag codice_comune_belfiore if codice_comune_belfiore != "NA", gen(tag)
 tab Tipovariazione if tag > 0 & codice_comune_belfiore != "NA"
 
 ** per i comuni che sono cessati prima del 12, nei dataset Istat non è presente il codice belfiore
 ** poichè nei dataset CO la chiave di aggancio è il codice belfiore, occorre valorizzare questa variabile anche quando mancante 
 ** fonte: http://www.elesh.it/storiacomuni/storia_comune.asp?istat=110010

replace codice_comune_belfiore = "C965" if codice_comune_belfiore == "NA" & codice_comune_istat == "013076"
replace codice_comune_belfiore = "D986" if codice_comune_belfiore == "NA" & codice_comune_istat == "013108"
replace codice_comune_belfiore = "E151" if codice_comune_belfiore == "NA" & codice_comune_istat == "013112"
replace codice_comune_belfiore = "E658" if codice_comune_belfiore == "NA" & codice_comune_istat == "022107"
replace codice_comune_belfiore = "A901" if codice_comune_belfiore == "NA" & codice_comune_istat == "022016"
replace codice_comune_belfiore = "F286" if codice_comune_belfiore == "NA" & codice_comune_istat == "022119"
replace codice_comune_belfiore = "C944" if codice_comune_belfiore == "NA" & codice_comune_istat == "022065"
replace codice_comune_belfiore = "A839" if codice_comune_belfiore == "NA" & codice_comune_istat == "022014"
replace codice_comune_belfiore = "G644" if codice_comune_belfiore == "NA" & codice_comune_istat == "022141"
replace codice_comune_belfiore = "L163" if codice_comune_belfiore == "NA" & codice_comune_istat == "022198"
replace codice_comune_belfiore = "L162" if codice_comune_belfiore == "NA" & codice_comune_istat == "022197"
replace codice_comune_belfiore = "L044" if codice_comune_belfiore == "NA" & codice_comune_istat == "030115"
replace codice_comune_belfiore = "B545" if codice_comune_belfiore == "NA" & codice_comune_istat == "030017"
replace codice_comune_belfiore = "C080" if codice_comune_belfiore == "NA" & codice_comune_istat == "041011"
replace codice_comune_belfiore = "E838" if codice_comune_belfiore == "NA" & codice_comune_istat == "041024"
replace codice_comune_belfiore = "F137" if codice_comune_belfiore == "NA" & codice_comune_istat == "041039"
replace codice_comune_belfiore = "G433" if codice_comune_belfiore == "NA" & codice_comune_istat == "041042"
replace codice_comune_belfiore = "H949" if codice_comune_belfiore == "NA" & codice_comune_istat == "041053"
replace codice_comune_belfiore = "I201" if codice_comune_belfiore == "NA" & codice_comune_istat == "041055"
replace codice_comune_belfiore = "L034" if codice_comune_belfiore == "NA" & codice_comune_istat == "041063"
replace codice_comune_belfiore = "A087" if codice_comune_belfiore == "NA" & codice_comune_istat == "015003"
replace codice_comune_belfiore = "A096" if codice_comune_belfiore == "NA" & codice_comune_istat == "015004"
replace codice_comune_belfiore = "A159" if codice_comune_belfiore == "NA" & codice_comune_istat == "015006"
replace codice_comune_belfiore = "A376" if codice_comune_belfiore == "NA" & codice_comune_istat == "015008"
replace codice_comune_belfiore = "A668" if codice_comune_belfiore == "NA" & codice_comune_istat == "015013"
replace codice_comune_belfiore = "A759" if codice_comune_belfiore == "NA" & codice_comune_istat == "015017"
replace codice_comune_belfiore = "A802" if codice_comune_belfiore == "NA" & codice_comune_istat == "015018"
replace codice_comune_belfiore = "A818" if codice_comune_belfiore == "NA" & codice_comune_istat == "015021"
replace codice_comune_belfiore = "A849" if codice_comune_belfiore == "NA" & codice_comune_istat == "015023"
replace codice_comune_belfiore = "B105" if codice_comune_belfiore == "NA" & codice_comune_istat == "015030"
replace codice_comune_belfiore = "B187" if codice_comune_belfiore == "NA" & codice_comune_istat == "015033"
replace codice_comune_belfiore = "B212" if codice_comune_belfiore == "NA" & codice_comune_istat == "015034"
replace codice_comune_belfiore = "B272" if codice_comune_belfiore == "NA" & codice_comune_istat == "015037"
replace codice_comune_belfiore = "B501" if codice_comune_belfiore == "NA" & codice_comune_istat == "015045"
replace codice_comune_belfiore = "B729" if codice_comune_belfiore == "NA" & codice_comune_istat == "015048"
replace codice_comune_belfiore = "B798" if codice_comune_belfiore == "NA" & codice_comune_istat == "015049"
replace codice_comune_belfiore = "C395" if codice_comune_belfiore == "NA" & codice_comune_istat == "015068"
replace codice_comune_belfiore = "C512" if codice_comune_belfiore == "NA" & codice_comune_istat == "015069"
replace codice_comune_belfiore = "C566" if codice_comune_belfiore == "NA" & codice_comune_istat == "015075"
replace codice_comune_belfiore = "C820" if codice_comune_belfiore == "NA" & codice_comune_istat == "015080"
replace codice_comune_belfiore = "C952" if codice_comune_belfiore == "NA" & codice_comune_istat == "015084"
replace codice_comune_belfiore = "D038" if codice_comune_belfiore == "NA" & codice_comune_istat == "015092"
replace codice_comune_belfiore = "D286" if codice_comune_belfiore == "NA" & codice_comune_istat == "015100"
replace codice_comune_belfiore = "E063" if codice_comune_belfiore == "NA" & codice_comune_istat == "015107"
replace codice_comune_belfiore = "E504" if codice_comune_belfiore == "NA" & codice_comune_istat == "015117"
replace codice_comune_belfiore = "E550" if codice_comune_belfiore == "NA" & codice_comune_istat == "015120"
replace codice_comune_belfiore = "E591" if codice_comune_belfiore == "NA" & codice_comune_istat == "015121"
replace codice_comune_belfiore = "E617" if codice_comune_belfiore == "NA" & codice_comune_istat == "015123"
replace codice_comune_belfiore = "E786" if codice_comune_belfiore == "NA" & codice_comune_istat == "015129"
replace codice_comune_belfiore = "F078" if codice_comune_belfiore == "NA" & codice_comune_istat == "015138"
replace codice_comune_belfiore = "F165" if codice_comune_belfiore == "NA" & codice_comune_istat == "015145"
replace codice_comune_belfiore = "F247" if codice_comune_belfiore == "NA" & codice_comune_istat == "015147"
replace codice_comune_belfiore = "F704" if codice_comune_belfiore == "NA" & codice_comune_istat == "015149"
replace codice_comune_belfiore = "F797" if codice_comune_belfiore == "NA" & codice_comune_istat == "015152"
replace codice_comune_belfiore = "F944" if codice_comune_belfiore == "NA" & codice_comune_istat == "015156"
replace codice_comune_belfiore = "G116" if codice_comune_belfiore == "NA" & codice_comune_istat == "015161"
replace codice_comune_belfiore = "H233" if codice_comune_belfiore == "NA" & codice_comune_istat == "015180"
replace codice_comune_belfiore = "H537" if codice_comune_belfiore == "NA" & codice_comune_istat == "015187"
replace codice_comune_belfiore = "I625" if codice_comune_belfiore == "NA" & codice_comune_istat == "015208"
replace codice_comune_belfiore = "I709" if codice_comune_belfiore == "NA" & codice_comune_istat == "015212"
replace codice_comune_belfiore = "I878" if codice_comune_belfiore == "NA" & codice_comune_istat == "015216"
replace codice_comune_belfiore = "I998" if codice_comune_belfiore == "NA" & codice_comune_istat == "015217"
replace codice_comune_belfiore = "L434" if codice_comune_belfiore == "NA" & codice_comune_istat == "015223"
replace codice_comune_belfiore = "L511" if codice_comune_belfiore == "NA" & codice_comune_istat == "015227"
replace codice_comune_belfiore = "L677" if codice_comune_belfiore == "NA" & codice_comune_istat == "015231"
replace codice_comune_belfiore = "L704" if codice_comune_belfiore == "NA" & codice_comune_istat == "015232"
replace codice_comune_belfiore = "L709" if codice_comune_belfiore == "NA" & codice_comune_istat == "015233"
replace codice_comune_belfiore = "L744" if codice_comune_belfiore == "NA" & codice_comune_istat == "015234"
replace codice_comune_belfiore = "M017" if codice_comune_belfiore == "NA" & codice_comune_istat == "015239"
replace codice_comune_belfiore = "M052" if codice_comune_belfiore == "NA" & codice_comune_istat == "015241"
replace codice_comune_belfiore = "B289" if codice_comune_belfiore == "NA" & codice_comune_istat == "015039"
replace codice_comune_belfiore = "B671" if codice_comune_belfiore == "NA" & codice_comune_istat == "015047"
replace codice_comune_belfiore = "D019" if codice_comune_belfiore == "NA" & codice_comune_istat == "015088"
replace codice_comune_belfiore = "E530" if codice_comune_belfiore == "NA" & codice_comune_istat == "015119"
replace codice_comune_belfiore = "H529" if codice_comune_belfiore == "NA" & codice_comune_istat == "015186"
replace codice_comune_belfiore = "A233" if codice_comune_belfiore == "NA" & codice_comune_istat == "044003"
replace codice_comune_belfiore = "A252" if codice_comune_belfiore == "NA" & codice_comune_istat == "044004"
replace codice_comune_belfiore = "A760" if codice_comune_belfiore == "NA" & codice_comune_istat == "044008"
replace codice_comune_belfiore = "B534" if codice_comune_belfiore == "NA" & codice_comune_istat == "044009"
replace codice_comune_belfiore = "D477" if codice_comune_belfiore == "NA" & codice_comune_istat == "044018"
replace codice_comune_belfiore = "D542" if codice_comune_belfiore == "NA" & codice_comune_istat == "044019"
replace codice_comune_belfiore = "D760" if codice_comune_belfiore == "NA" & codice_comune_istat == "044022"
replace codice_comune_belfiore = "E208" if codice_comune_belfiore == "NA" & codice_comune_istat == "044024"
replace codice_comune_belfiore = "E447" if codice_comune_belfiore == "NA" & codice_comune_istat == "044025"
replace codice_comune_belfiore = "E807" if codice_comune_belfiore == "NA" & codice_comune_istat == "044026"
replace codice_comune_belfiore = "F021" if codice_comune_belfiore == "NA" & codice_comune_istat == "044028"
replace codice_comune_belfiore = "F379" if codice_comune_belfiore == "NA" & codice_comune_istat == "044030"
replace codice_comune_belfiore = "F428" if codice_comune_belfiore == "NA" & codice_comune_istat == "044033"
replace codice_comune_belfiore = "F493" if codice_comune_belfiore == "NA" & codice_comune_istat == "044035"
replace codice_comune_belfiore = "F509" if codice_comune_belfiore == "NA" & codice_comune_istat == "044037"
replace codice_comune_belfiore = "F517" if codice_comune_belfiore == "NA" & codice_comune_istat == "044039"
replace codice_comune_belfiore = "F520" if codice_comune_belfiore == "NA" & codice_comune_istat == "044040"
replace codice_comune_belfiore = "F522" if codice_comune_belfiore == "NA" & codice_comune_istat == "044041"
replace codice_comune_belfiore = "F536" if codice_comune_belfiore == "NA" & codice_comune_istat == "044042"
replace codice_comune_belfiore = "F549" if codice_comune_belfiore == "NA" & codice_comune_istat == "044043"
replace codice_comune_belfiore = "F599" if codice_comune_belfiore == "NA" & codice_comune_istat == "044046"
replace codice_comune_belfiore = "F614" if codice_comune_belfiore == "NA" & codice_comune_istat == "044047"
replace codice_comune_belfiore = "F626" if codice_comune_belfiore == "NA" & codice_comune_istat == "044048"
replace codice_comune_belfiore = "F653" if codice_comune_belfiore == "NA" & codice_comune_istat == "044049"
replace codice_comune_belfiore = "F664" if codice_comune_belfiore == "NA" & codice_comune_istat == "044050"
replace codice_comune_belfiore = "F665" if codice_comune_belfiore == "NA" & codice_comune_istat == "044051"
replace codice_comune_belfiore = "F697" if codice_comune_belfiore == "NA" & codice_comune_istat == "044052"
replace codice_comune_belfiore = "F722" if codice_comune_belfiore == "NA" & codice_comune_istat == "044053"
replace codice_comune_belfiore = "G137" if codice_comune_belfiore == "NA" & codice_comune_istat == "044055"
replace codice_comune_belfiore = "G403" if codice_comune_belfiore == "NA" & codice_comune_istat == "044057"
replace codice_comune_belfiore = "G516" if codice_comune_belfiore == "NA" & codice_comune_istat == "044058"
replace codice_comune_belfiore = "G873" if codice_comune_belfiore == "NA" & codice_comune_istat == "044059"
replace codice_comune_belfiore = "G920" if codice_comune_belfiore == "NA" & codice_comune_istat == "044060"
replace codice_comune_belfiore = "G921" if codice_comune_belfiore == "NA" & codice_comune_istat == "044061"
replace codice_comune_belfiore = "H182" if codice_comune_belfiore == "NA" & codice_comune_istat == "044062"
replace codice_comune_belfiore = "I315" if codice_comune_belfiore == "NA" & codice_comune_istat == "044067"
replace codice_comune_belfiore = "I324" if codice_comune_belfiore == "NA" & codice_comune_istat == "044068"
replace codice_comune_belfiore = "C070" if codice_comune_belfiore == "NA" & codice_comune_istat == "044069"
replace codice_comune_belfiore = "I774" if codice_comune_belfiore == "NA" & codice_comune_istat == "044070"
replace codice_comune_belfiore = "L279" if codice_comune_belfiore == "NA" & codice_comune_istat == "044072"
replace codice_comune_belfiore = "A285" if codice_comune_belfiore == "NA" & codice_comune_istat == "072005"
replace codice_comune_belfiore = "A669" if codice_comune_belfiore == "NA" & codice_comune_istat == "072007"
replace codice_comune_belfiore = "A883" if codice_comune_belfiore == "NA" & codice_comune_istat == "072009"
replace codice_comune_belfiore = "B619" if codice_comune_belfiore == "NA" & codice_comune_istat == "072013"
replace codice_comune_belfiore = "E946" if codice_comune_belfiore == "NA" & codice_comune_istat == "071030"
replace codice_comune_belfiore = "F220" if codice_comune_belfiore == "NA" & codice_comune_istat == "072026"
replace codice_comune_belfiore = "H839" if codice_comune_belfiore == "NA" & codice_comune_istat == "071045"
replace codice_comune_belfiore = "I907" if codice_comune_belfiore == "NA" & codice_comune_istat == "072042"
replace codice_comune_belfiore = "L328" if codice_comune_belfiore == "NA" & codice_comune_istat == "072045"
replace codice_comune_belfiore = "B915" if codice_comune_belfiore == "NA" & codice_comune_istat == "071057"

preserve
duplicates drop codice_comune_belfiore, force
keep codice_comune_belfiore codice_comune_belfiore2019 sigla_prov2019 
save ${material}/raccordo_comuni_codice_belfiore_al_311219.dta, replace
restore

keep codice_comune_* 
save ${material}/raccordo_comuni_codice_istat_al_311219.dta, replace

 
 
*********************************************************
* 3. ASSOCIARE OGNI CODICE BELFIORE CHE COMPARE NELLE CO
*    AL CODICE BELFIORE IN VIGORE AL 31/12/19
*********************************************************

* 3.1 creo elenco dei comuni sedi di lavoro (codcomunelavoro) che compaiono nelle CO 
**    NB: info sia dal dataset CO_SOMM sia dal dataset MISSIONI

gzuse ${dati}/CO_SOMM_II_2019_BDI.dta.gz, clear
keep if fonte == 1
bys codcomunelavoro: gen n = _n 
keep if n == 1
keep codcomunelavoro
tempfile t0 
save    `t0.dta', replace 

gzuse  ${dati}/MISSIONI_II_2019_BDI.dta.gz, clear
bys codcomunelavoro: gen n = _n 
keep if n == 1
keep codcomunelavoro
tempfile t1 
save    `t1.dta', replace 

use          `t0.dta'
append using `t1.dta'
bys codcomunelavoro: gen n = _n 
keep if n == 1
save ${material}/elenco_comuni_CO.dta, replace 

** 
use ${material}/elenco_comuni_CO.dta, clear 
gen i = substr(codcomunelavoro,1,1)
drop if i == "Z"
rename codcomunelavoro codice_comune_belfiore 
duplicates drop codice_comune_belfiore, force 
merge 1:1 codice_comune_belfiore using ${material}/raccordo_comuni_codice_belfiore_al_311219.dta, keepusing(codice_comune_belfiore*)
drop if _merge == 2
drop    _merge 

 /*Result                           # of obs.
    -----------------------------------------
    not matched                           269
        from master                       264  (_merge==1)
        from using                          5  (_merge==2)

    matched                             8,213  (_merge==3)
    -----------------------------------------
*/ 

** nel dataset CO ci sono 264 comuni con un codice belfiore inattivo da prima del 2008; 
** poichè le vintage dell'elenco dei comuni di fonte Istat partono dal 2008, per questi comuni
** occorre valorizzare il corrispondente codice belfiore attivo al 31-12-19 manualmente 
** fonte: http://www.elesh.it/storiacomuni/cercacomuni.asp

replace codice_comune_belfiore2019 = "B729" if codice_comune_belfiore == "A073"
replace codice_comune_belfiore2019 = "C933" if codice_comune_belfiore == "A142"
replace codice_comune_belfiore2019 = "L404" if codice_comune_belfiore == "A144" 
replace codice_comune_belfiore2019 = "A153" if codice_comune_belfiore == "A152"
replace codice_comune_belfiore2019 = "A496" if codice_comune_belfiore == "A156" 
replace codice_comune_belfiore2019 = "L003" if codice_comune_belfiore == "A174"
replace codice_comune_belfiore2019 = "A345" if codice_comune_belfiore == "A406" 
replace codice_comune_belfiore2019 = "B639" if codice_comune_belfiore == "A469"
replace codice_comune_belfiore2019 = "D383" if codice_comune_belfiore == "A500"
replace codice_comune_belfiore2019 = "L781" if codice_comune_belfiore == "A513"
replace codice_comune_belfiore2019 = "F205" if codice_comune_belfiore == "A545"
replace codice_comune_belfiore2019 = "M082" if codice_comune_belfiore == "A548"
replace codice_comune_belfiore2019 = "E415" if codice_comune_belfiore == "A623"
replace codice_comune_belfiore2019 = "F839" if codice_comune_belfiore == "A675"
replace codice_comune_belfiore2019 = "E062" if codice_comune_belfiore == "A695"
replace codice_comune_belfiore2019 = "A509" if codice_comune_belfiore == "A753"
replace codice_comune_belfiore2019 = "E819" if codice_comune_belfiore == "A860"
replace codice_comune_belfiore2019 = "F687" if codice_comune_belfiore == "A913"
replace codice_comune_belfiore2019 = "B368" if codice_comune_belfiore == "A939"
replace codice_comune_belfiore2019 = "D969" if codice_comune_belfiore == "A951"
replace codice_comune_belfiore2019 = "D845" if codice_comune_belfiore == "A974"
replace codice_comune_belfiore2019 = "D058" if codice_comune_belfiore == "B022"
replace codice_comune_belfiore2019 = "A944" if codice_comune_belfiore == "B027"
replace codice_comune_belfiore2019 = "G502" if codice_comune_belfiore == "B050"
replace codice_comune_belfiore2019 = "C408" if codice_comune_belfiore == "B053"
replace codice_comune_belfiore2019 = "H620" if codice_comune_belfiore == "B060"
replace codice_comune_belfiore2019 = "D969" if codice_comune_belfiore == "B066"
replace codice_comune_belfiore2019 = "B091" if codice_comune_belfiore == "B092"
replace codice_comune_belfiore2019 = "B091" if codice_comune_belfiore == "B093"
replace codice_comune_belfiore2019 = "B137" if codice_comune_belfiore == "B139"
replace codice_comune_belfiore2019 = "B191" if codice_comune_belfiore == "B190"
replace codice_comune_belfiore2019 = "E928" if codice_comune_belfiore == "B211"
replace codice_comune_belfiore2019 = "F205" if codice_comune_belfiore == "B233"
replace codice_comune_belfiore2019 = "B346" if codice_comune_belfiore == "B263"
replace codice_comune_belfiore2019 = "L736" if codice_comune_belfiore == "B273"
replace codice_comune_belfiore2019 = "I138" if codice_comune_belfiore == "B291"
replace codice_comune_belfiore2019 = "B326" if codice_comune_belfiore == "B325"
replace codice_comune_belfiore2019 = "L378" if codice_comune_belfiore == "B344"
replace codice_comune_belfiore2019 = "L950" if codice_comune_belfiore == "B438"
replace codice_comune_belfiore2019 = "A345" if codice_comune_belfiore == "B458"
replace codice_comune_belfiore2019 = "C933" if codice_comune_belfiore == "B475"
replace codice_comune_belfiore2019 = "G361" if codice_comune_belfiore == "B478"
replace codice_comune_belfiore2019 = "B567" if codice_comune_belfiore == "B568"  
replace codice_comune_belfiore2019 = "B653" if codice_comune_belfiore == "B652"
replace codice_comune_belfiore2019 = "B187" if codice_comune_belfiore == "B699"
replace codice_comune_belfiore2019 = "B703" if codice_comune_belfiore == "B702"
replace codice_comune_belfiore2019 = "A662" if codice_comune_belfiore == "B737"
replace codice_comune_belfiore2019 = "L919" if codice_comune_belfiore == "B751"
replace codice_comune_belfiore2019 = "B436" if codice_comune_belfiore == "B855"
replace codice_comune_belfiore2019 = "B881" if codice_comune_belfiore == "B874"
replace codice_comune_belfiore2019 = "B977" if codice_comune_belfiore == "B976"
replace codice_comune_belfiore2019 = "A940" if codice_comune_belfiore == "C017"
replace codice_comune_belfiore2019 = "D708" if codice_comune_belfiore == "C193"
replace codice_comune_belfiore2019 = "H224" if codice_comune_belfiore == "C355"
replace codice_comune_belfiore2019 = "A662" if codice_comune_belfiore == "C423"
replace codice_comune_belfiore2019 = "C457" if codice_comune_belfiore == "C454"
replace codice_comune_belfiore2019 = "F839" if codice_comune_belfiore == "C603"
replace codice_comune_belfiore2019 = "L736" if codice_comune_belfiore == "C647"
replace codice_comune_belfiore2019 = "D056" if codice_comune_belfiore == "C683"
replace codice_comune_belfiore2019 = "F063" if codice_comune_belfiore == "C687"
replace codice_comune_belfiore2019 = "L765" if codice_comune_belfiore == "C693"
replace codice_comune_belfiore2019 = "C707" if codice_comune_belfiore == "C706"
replace codice_comune_belfiore2019 = "L050" if codice_comune_belfiore == "C731"
replace codice_comune_belfiore2019 = "C933" if codice_comune_belfiore == "C762"
replace codice_comune_belfiore2019 = "C925" if codice_comune_belfiore == "C786"
replace codice_comune_belfiore2019 = "E333" if codice_comune_belfiore == "C798"
replace codice_comune_belfiore2019 = "C810" if codice_comune_belfiore == "C809"
replace codice_comune_belfiore2019 = "L378" if codice_comune_belfiore == "C822"
replace codice_comune_belfiore2019 = "D019" if codice_comune_belfiore == "C887"
replace codice_comune_belfiore2019 = "D058" if codice_comune_belfiore == "C898"
replace codice_comune_belfiore2019 = "C925" if codice_comune_belfiore == "C924"
replace codice_comune_belfiore2019 = "E530" if codice_comune_belfiore == "C981"
replace codice_comune_belfiore2019 = "D969" if codice_comune_belfiore == "D025"
replace codice_comune_belfiore2019 = "F205" if codice_comune_belfiore == "D035"
replace codice_comune_belfiore2019 = "D056" if codice_comune_belfiore == "D055"
replace codice_comune_belfiore2019 = "L380" if codice_comune_belfiore == "D098"
replace codice_comune_belfiore2019 = "E309" if codice_comune_belfiore == "D148"
replace codice_comune_belfiore2019 = "G062" if codice_comune_belfiore == "D191"
replace codice_comune_belfiore2019 = "L404" if codice_comune_belfiore == "D220"
replace codice_comune_belfiore2019 = "I964" if codice_comune_belfiore == "D252"
replace codice_comune_belfiore2019 = "G926" if codice_comune_belfiore == "D337"
replace codice_comune_belfiore2019 = "G113" if codice_comune_belfiore == "D342"
replace codice_comune_belfiore2019 = "G220" if codice_comune_belfiore == "D381"
replace codice_comune_belfiore2019 = "D383" if codice_comune_belfiore == "D382"
replace codice_comune_belfiore2019 = "L736" if codice_comune_belfiore == "D515"
replace codice_comune_belfiore2019 = "G006" if codice_comune_belfiore == "D517"
replace codice_comune_belfiore2019 = "L065" if codice_comune_belfiore == "D525"
replace codice_comune_belfiore2019 = "F205" if codice_comune_belfiore == "D580"
replace codice_comune_belfiore2019 = "C339" if codice_comune_belfiore == "D618"
replace codice_comune_belfiore2019 = "B157" if codice_comune_belfiore == "D658"
replace codice_comune_belfiore2019 = "H224" if codice_comune_belfiore == "D877"
replace codice_comune_belfiore2019 = "D612" if codice_comune_belfiore == "D887"
replace codice_comune_belfiore2019 = "F229" if codice_comune_belfiore == "D893"
replace codice_comune_belfiore2019 = "F874" if codice_comune_belfiore == "D914"
replace codice_comune_belfiore2019 = "L378" if codice_comune_belfiore == "D916"
replace codice_comune_belfiore2019 = "D951" if codice_comune_belfiore == "D950"
replace codice_comune_belfiore2019 = "G651" if codice_comune_belfiore == "D955"
replace codice_comune_belfiore2019 = "L720" if codice_comune_belfiore == "E046"
replace codice_comune_belfiore2019 = "C003" if codice_comune_belfiore == "E197"
replace codice_comune_belfiore2019 = "M082" if codice_comune_belfiore == "E211"
replace codice_comune_belfiore2019 = "I042" if codice_comune_belfiore == "E225"
replace codice_comune_belfiore2019 = "L746" if codice_comune_belfiore == "E303"
replace codice_comune_belfiore2019 = "E314" if codice_comune_belfiore == "E316"
replace codice_comune_belfiore2019 = "G452" if codice_comune_belfiore == "E331"
replace codice_comune_belfiore2019 = "F277" if codice_comune_belfiore == "E442"
replace codice_comune_belfiore2019 = "E496" if codice_comune_belfiore == "E495"
replace codice_comune_belfiore2019 = "E510" if codice_comune_belfiore == "E511"
replace codice_comune_belfiore2019 = "G686" if codice_comune_belfiore == "E595"
replace codice_comune_belfiore2019 = "G488" if codice_comune_belfiore == "E601"
replace codice_comune_belfiore2019 = "I964" if codice_comune_belfiore == "E653"
replace codice_comune_belfiore2019 = "M312" if codice_comune_belfiore == "E667"
replace codice_comune_belfiore2019 = "A662" if codice_comune_belfiore == "E697"
replace codice_comune_belfiore2019 = "H264" if codice_comune_belfiore == "E717"
replace codice_comune_belfiore2019 = "E098" if codice_comune_belfiore == "E720"
replace codice_comune_belfiore2019 = "H410" if codice_comune_belfiore == "E725"
replace codice_comune_belfiore2019 = "H282" if codice_comune_belfiore == "E728"
replace codice_comune_belfiore2019 = "E738" if codice_comune_belfiore == "E739"
replace codice_comune_belfiore2019 = "E738" if codice_comune_belfiore == "E740"
replace codice_comune_belfiore2019 = "E738" if codice_comune_belfiore == "E741"
replace codice_comune_belfiore2019 = "L312" if codice_comune_belfiore == "E792"
replace codice_comune_belfiore2019 = "E507" if codice_comune_belfiore == "E802"
replace codice_comune_belfiore2019 = "D918" if codice_comune_belfiore == "E823"
replace codice_comune_belfiore2019 = "E847" if codice_comune_belfiore == "E846"
replace codice_comune_belfiore2019 = "F728" if codice_comune_belfiore == "E898"
replace codice_comune_belfiore2019 = "E921" if codice_comune_belfiore == "E920"
replace codice_comune_belfiore2019 = "L682" if codice_comune_belfiore == "F018"
replace codice_comune_belfiore2019 = "L378" if codice_comune_belfiore == "F056"
replace codice_comune_belfiore2019 = "D532" if codice_comune_belfiore == "F128"
replace codice_comune_belfiore2019 = "A429" if codice_comune_belfiore == "F143"
replace codice_comune_belfiore2019 = "L736" if codice_comune_belfiore == "F159"
replace codice_comune_belfiore2019 = "D969" if codice_comune_belfiore == "F282"
replace codice_comune_belfiore2019 = "B157" if codice_comune_belfiore == "F321"
replace codice_comune_belfiore2019 = "I232" if codice_comune_belfiore == "F451"
replace codice_comune_belfiore2019 = "M379" if codice_comune_belfiore == "F554"
replace codice_comune_belfiore2019 = "C933" if codice_comune_belfiore == "F583"
replace codice_comune_belfiore2019 = "F646" if codice_comune_belfiore == "F647"
replace codice_comune_belfiore2019 = "L781" if codice_comune_belfiore == "F691"
replace codice_comune_belfiore2019 = "L682" if codice_comune_belfiore == "F742"
replace codice_comune_belfiore2019 = "M417" if codice_comune_belfiore == "F769"
replace codice_comune_belfiore2019 = "F205" if codice_comune_belfiore == "F796"
replace codice_comune_belfiore2019 = "L736" if codice_comune_belfiore == "F807"
replace codice_comune_belfiore2019 = "F205" if codice_comune_belfiore == "F827"
replace codice_comune_belfiore2019 = "D969" if codice_comune_belfiore == "F873"
replace codice_comune_belfiore2019 = "A246" if codice_comune_belfiore == "F875"
replace codice_comune_belfiore2019 = "M208" if codice_comune_belfiore == "F888"
replace codice_comune_belfiore2019 = "D058" if codice_comune_belfiore == "F896"
replace codice_comune_belfiore2019 = "E965" if codice_comune_belfiore == "F903"
replace codice_comune_belfiore2019 = "H612" if codice_comune_belfiore == "F936"
replace codice_comune_belfiore2019 = "I577" if codice_comune_belfiore == "F959"
replace codice_comune_belfiore2019 = "L812" if codice_comune_belfiore == "F971"
replace codice_comune_belfiore2019 = "A087" if codice_comune_belfiore == "G059"
replace codice_comune_belfiore2019 = "D142" if codice_comune_belfiore == "G060"
replace codice_comune_belfiore2019 = "M052" if codice_comune_belfiore == "G092"
replace codice_comune_belfiore2019 = "A345" if codice_comune_belfiore == "G231"
replace codice_comune_belfiore2019 = "E063" if codice_comune_belfiore == "G244"
replace codice_comune_belfiore2019 = "G220" if codice_comune_belfiore == "G265"
replace codice_comune_belfiore2019 = "F728" if codice_comune_belfiore == "G313"
replace codice_comune_belfiore2019 = "H264" if codice_comune_belfiore == "G360"
replace codice_comune_belfiore2019 = "H930" if codice_comune_belfiore == "G413"
replace codice_comune_belfiore2019 = "D969" if codice_comune_belfiore == "G414"
replace codice_comune_belfiore2019 = "H224" if codice_comune_belfiore == "G422"
replace codice_comune_belfiore2019 = "D612" if codice_comune_belfiore == "G423"
replace codice_comune_belfiore2019 = "L736" if codice_comune_belfiore == "G425"
replace codice_comune_belfiore2019 = "F532" if codice_comune_belfiore == "G490"
replace codice_comune_belfiore2019 = "F839" if codice_comune_belfiore == "G573"
replace codice_comune_belfiore2019 = "L117" if codice_comune_belfiore == "G595"
replace codice_comune_belfiore2019 = "G483" if codice_comune_belfiore == "G655"
replace codice_comune_belfiore2019 = "E333" if codice_comune_belfiore == "G668"
replace codice_comune_belfiore2019 = "B354" if codice_comune_belfiore == "G701"
replace codice_comune_belfiore2019 = "F839" if codice_comune_belfiore == "G706"
replace codice_comune_belfiore2019 = "D634" if codice_comune_belfiore == "G819"
replace codice_comune_belfiore2019 = "D969" if codice_comune_belfiore == "G841"
replace codice_comune_belfiore2019 = "F941" if codice_comune_belfiore == "G845"
replace codice_comune_belfiore2019 = "F839" if codice_comune_belfiore == "G863"
replace codice_comune_belfiore2019 = "D019" if codice_comune_belfiore == "G908"
replace codice_comune_belfiore2019 = "E526" if codice_comune_belfiore == "G928"
replace codice_comune_belfiore2019 = "L378" if codice_comune_belfiore == "G948"
replace codice_comune_belfiore2019 = "B914" if codice_comune_belfiore == "G952"
replace codice_comune_belfiore2019 = "D969" if codice_comune_belfiore == "G967"
replace codice_comune_belfiore2019 = "I696" if codice_comune_belfiore == "H031"
replace codice_comune_belfiore2019 = "A345" if codice_comune_belfiore == "H053"
replace codice_comune_belfiore2019 = "M359" if codice_comune_belfiore == "H066"
replace codice_comune_belfiore2019 = "D969" if codice_comune_belfiore == "H115"
replace codice_comune_belfiore2019 = "L781" if codice_comune_belfiore == "H133"
replace codice_comune_belfiore2019 = "H163" if codice_comune_belfiore == "H164"
replace codice_comune_belfiore2019 = "B220" if codice_comune_belfiore == "H167"
replace codice_comune_belfiore2019 = "L378" if codice_comune_belfiore == "H201"
replace codice_comune_belfiore2019 = "C933" if codice_comune_belfiore == "H208"
replace codice_comune_belfiore2019 = "H230" if codice_comune_belfiore == "H231"
replace codice_comune_belfiore2019 = "H230" if codice_comune_belfiore == "H232"
replace codice_comune_belfiore2019 = "F378" if codice_comune_belfiore == "H237"
replace codice_comune_belfiore2019 = "C536" if codice_comune_belfiore == "H309"
replace codice_comune_belfiore2019 = "D969" if codice_comune_belfiore == "H339"
replace codice_comune_belfiore2019 = "I813" if codice_comune_belfiore == "H351"
replace codice_comune_belfiore2019 = "D284" if codice_comune_belfiore == "H358"
replace codice_comune_belfiore2019 = "E063" if codice_comune_belfiore == "H368"
replace codice_comune_belfiore2019 = "H371" if codice_comune_belfiore == "H370"
replace codice_comune_belfiore2019 = "H477" if codice_comune_belfiore == "H476"
replace codice_comune_belfiore2019 = "A345" if codice_comune_belfiore == "H496"
replace codice_comune_belfiore2019 = "L378" if codice_comune_belfiore == "H504"
replace codice_comune_belfiore2019 = "G452" if codice_comune_belfiore == "H543"
replace codice_comune_belfiore2019 = "D141" if codice_comune_belfiore == "H611"
replace codice_comune_belfiore2019 = "D612" if codice_comune_belfiore == "H617"
replace codice_comune_belfiore2019 = "M052" if codice_comune_belfiore == "H636"
replace codice_comune_belfiore2019 = "D245" if codice_comune_belfiore == "H649"
replace codice_comune_belfiore2019 = "H224" if codice_comune_belfiore == "H709"
replace codice_comune_belfiore2019 = "M208" if codice_comune_belfiore == "H742"
replace codice_comune_belfiore2019 = "B212" if codice_comune_belfiore == "H813"
replace codice_comune_belfiore2019 = "D969" if codice_comune_belfiore == "H853"
replace codice_comune_belfiore2019 = "F839" if codice_comune_belfiore == "H908"
replace codice_comune_belfiore2019 = "D969" if codice_comune_belfiore == "H909"
replace codice_comune_belfiore2019 = "H930" if codice_comune_belfiore == "H927"
replace codice_comune_belfiore2019 = "B963" if codice_comune_belfiore == "H954"
replace codice_comune_belfiore2019 = "M082" if codice_comune_belfiore == "H995"
replace codice_comune_belfiore2019 = "L781" if codice_comune_belfiore == "I041"
replace codice_comune_belfiore2019 = "D323" if codice_comune_belfiore == "I069"
replace codice_comune_belfiore2019 = "F839" if codice_comune_belfiore == "I094"
replace codice_comune_belfiore2019 = "D969" if codice_comune_belfiore == "I134"
replace codice_comune_belfiore2019 = "B157" if codice_comune_belfiore == "I186"
replace codice_comune_belfiore2019 = "I217" if codice_comune_belfiore == "I218"
replace codice_comune_belfiore2019 = "A345" if codice_comune_belfiore == "I450"
replace codice_comune_belfiore2019 = "A984" if codice_comune_belfiore == "I456"
replace codice_comune_belfiore2019 = "F839" if codice_comune_belfiore == "I560"
replace codice_comune_belfiore2019 = "M089" if codice_comune_belfiore == "I664"
replace codice_comune_belfiore2019 = "A116" if codice_comune_belfiore == "I665"
replace codice_comune_belfiore2019 = "H930" if codice_comune_belfiore == "I691"
replace codice_comune_belfiore2019 = "D969" if codice_comune_belfiore == "I694"
replace codice_comune_belfiore2019 = "G113" if codice_comune_belfiore == "I731"
replace codice_comune_belfiore2019 = "F839" if codice_comune_belfiore == "I776"
replace codice_comune_belfiore2019 = "L378" if codice_comune_belfiore == "I834"
replace codice_comune_belfiore2019 = "I881" if codice_comune_belfiore == "I882"
replace codice_comune_belfiore2019 = "I998" if codice_comune_belfiore == "L001"
replace codice_comune_belfiore2019 = "C079" if codice_comune_belfiore == "L029"
replace codice_comune_belfiore2019 = "F260" if codice_comune_belfiore == "L068"
replace codice_comune_belfiore2019 = "H264" if codice_comune_belfiore == "L135"
replace codice_comune_belfiore2019 = "D058" if codice_comune_belfiore == "L170"
replace codice_comune_belfiore2019 = "E666" if codice_comune_belfiore == "L226"
replace codice_comune_belfiore2019 = "L312" if codice_comune_belfiore == "L311"
replace codice_comune_belfiore2019 = "G965" if codice_comune_belfiore == "L358"
replace codice_comune_belfiore2019 = "E847" if codice_comune_belfiore == "L481"
replace codice_comune_belfiore2019 = "L487" if codice_comune_belfiore == "L486"
replace codice_comune_belfiore2019 = "B157" if codice_comune_belfiore == "L495"
replace codice_comune_belfiore2019 = "L511" if codice_comune_belfiore == "L510"
replace codice_comune_belfiore2019 = "G888" if codice_comune_belfiore == "L610"
replace codice_comune_belfiore2019 = "F728" if codice_comune_belfiore == "L618"
replace codice_comune_belfiore2019 = "D600" if codice_comune_belfiore == "L684"
replace codice_comune_belfiore2019 = "L709" if codice_comune_belfiore == "L708"
replace codice_comune_belfiore2019 = "L682" if codice_comune_belfiore == "L714"
replace codice_comune_belfiore2019 = "L734" if codice_comune_belfiore == "L732"
replace codice_comune_belfiore2019 = "L792" if codice_comune_belfiore == "L791"
replace codice_comune_belfiore2019 = "D845" if codice_comune_belfiore == "L867"
replace codice_comune_belfiore2019 = "L378" if codice_comune_belfiore == "L895"
replace codice_comune_belfiore2019 = "G840" if codice_comune_belfiore == "L955"
replace codice_comune_belfiore2019 = "A818" if codice_comune_belfiore == "M001"
replace codice_comune_belfiore2019 = "M050" if codice_comune_belfiore == "M049"
replace codice_comune_belfiore2019 = "D969" if codice_comune_belfiore == "M129"
replace codice_comune_belfiore2019 = "L331" if codice_comune_belfiore == "M137"
replace codice_comune_belfiore2019 = "M150" if codice_comune_belfiore == "M151"
replace codice_comune_belfiore2019 = "L736" if codice_comune_belfiore == "M154"
replace codice_comune_belfiore2019 = "B910" if codice_comune_belfiore == "M191"
replace codice_comune_belfiore2019 = "A968" if codice_comune_belfiore == "M218"
replace codice_comune_belfiore2019 = "I683" if codice_comune_belfiore == "M224"
replace codice_comune_belfiore2019 = "C393" if codice_comune_belfiore == "M249"
replace codice_comune_belfiore2019 = "E958" if codice_comune_belfiore == "M299"

** now that all codice_comune_belfiore in the CO have the corresponding codice_comune_belfiore2019,
** I can merge the list of municipalities existing at 31/12/19, so that I retrieve the NUTS3 unit 
** THERE MUST NE NO OCCURRENCES OF _MERGE == 1 

preserve 
use ${material}/raccordo_comuni_codice_belfiore_al_311219.dta, clear 
duplicates drop codice_comune_belfiore2019, force 
keep codice_comune_belfiore2019 sigla_prov2019
tempfile t 
save    `t.dta', replace 
restore 

merge m:1 codice_comune_belfiore2019 using `t.dta', keepusing(sigla_prov2019)
drop if _merge == 2
drop    _merge 


save ${dta}/elenco_comuni_CO_raccordo2019.dta, replace 


** note: 
* A156: da questo comune nel 1870 si originano Aulla e Podenzana >> si sceglie comune con popolazione maggiore
* A469: da questo comune nel 1929 si originano Cantù e Cermenate >> si sceglie comune con popolazione maggiore 
* B568: da questo comune nel 1948 si originano Albaredo e Campospinoso, entrambi esistenti ad oggi >> si sceglie comune con popolazione maggiore
* C454: da questo comune nel 1947 si originano Cenate Sopra, Cenate Sotto e San Paolo d'Argon >> si sceglie comune con popolazione maggiore tra CSotto e Csopra
* D618: da questo comune nel 1925 si originano Catrocare e Terra del Sole, e Predappio >> si sceglie comune con popolazione maggiore 
* D887: da questo comune i territori vanno a diversi comuni: Bagno a Ripoli, Casellina e Torri, Impruneta, Firenze >> 
* si sceglie il comune con popolazione maggiore (Firenze)   
* E211: nel 28 alcuni territori sono andati a Viterbo, altri a Graffignano >> si sceglie comune con popolazione maggiore
* E442: da uqesto comune nel 1947 si originano Malvagna e Moio Alcantara >> si sceglie comune con popolazione maggiore
* F742: questo comune nel 1929 cede territori sia a Casciago sia a Varese >> si sceglie comune con popolazione maggiore 
* G423: nel 1865 questo comune cede territori a Fiesole, Firenze e Sesto >> si sceglie comune con popolazione maggiore
* G819: nel 1956 da questo comune si originano Flero e Poncarale >> si sceglie il comune con popolazione maggiore 
* H351: da questo comune nel 1970 si originano Medolago e Solza >> si sceglie il comune con popolazione maggiore 
* H617: nel 1865 questo comune cede territori a Fiesole e Firenze >> si sceglie il comune con popolazione maggiore
* I218: da questo comune nel 1957 si originano Orciano Pisano e Santa Luce >> si sceglie il comune con popolazione maggiore
* L732: da questo comune nel 1960 si originano Venegono Superiore e Venegono Inferiore >> si sceglie il comune con popolazione maggiore 
* M151: da questo comune nel 1951 si originano Valverde e Zavattarello >> si sceglie il comune con popolazione maggiore 










 
 
 
 
 
 
 
 
 
 
 
 
 
