*THIS CODE:

*[1] OPENS THE DATASET "RASUPD02" (AVAILABLE FROM STATISTICS DENMARK);
*[2] CREATES A VARIABLE TO IDENTIFY PEOPLE OF FOREIGN ORIGIN;
*[3] SAVES A DATASET WITH THE NEW VARIABLE TO BE USED LATER IN THE ANALYSIS (Nationality.dta).


clear 
use "rasupd02.dta"

global type ie_type 
global year rasupd02sourceyear

tab ie_type

keep pnr $type $year
gen Home = ($type == 1)
replace Home = . if $type == 9 | $type == .
gen Foreign = ($type != 1)
replace Foreign = . if $type == 9 | $type == .

duplicates drop pnr $type, force
duplicates report pnr

sort $year
by pnr, sort: gen counter = _n
by pnr, sort: egen mincounter = min(counter)
keep if counter == mincounter
drop counter mincounter $year

duplicates report pnr

destring pnr, replace 

sort pnr
save "Nationality.dta", replace

exit