cap log c
log using contractregressionArnold.log, replace




*CONTRACT REGRESSIONS ARNOLD (Table 2.22)

				* load data
					use precontract, clear


				* merging with appropriate presence/absence indicators the year before
					
						sort nninouv sircom sir an
						merge 1:1 nninouv sircom sir an using P1sircom
						drop if _m==2
						drop _m

					
					sort nninouv an
					merge m:1 nninouv an using P1
					drop if _m==2
					drop _m

					* new hire and employed the year before indicators
					ge Hire=(P1ysir!=1)
					ge Emp1y=(Hire*P1y==1)
					drop P1ysir
	
					* limit sample
					keep if Hire==1
	
					* merging with standard HHI data
					sort fuaX pcs year			
					merge m:1 fuaX pcs year using HHI\HHI1_HPsircomtfuaX_pcs41	
					keep if _m==3
					drop _m	
					
					*merging with instruments
					merge m:1 fuaX pcs year using HHI_IV\FIN_HHI1_HPsircomtfuaX_pcs41	
					drop if _m==2
					drop _m
					
					* merging Arnold's HHIs
					merge m:1 fuaX pcs year using HHI\HHI1_AsircomtfuaX_pcs41
					drop if _m==2
					drop _m
					* creating logHHI
					ge logHHI_A=log(HHI_A)
					

	
* regression
global fixed = "occ#geo firm#mun#an firm#nic ag educ ftpt sx Emp1y "

disp "perm  MODEL 1 Arnold HHI"
disp "IV"
ivreghdfe perm (logHHI_A=IV_mE), absorb($fixed)  cluster(cluster) 





cap log close





			
****
