cap log c
log using contractregressionShareOcc.log, replace


* BASELINE REGRESSION CONTROLLING FOR THE SHARE OF 4-DIGIT OCCUPATIONS AT THE NATIONAL LEVEL (Table 2.18)


				* load data
					use precontract, clear


				* merging with appropriate presence/absence indicators the year before
					
						sort nninouv sircom sir an
						merge 1:1 nninouv sircom sir an using P1sircom
						drop if _m==2
						drop _m

					
					sort nninouv an
					merge m:1 nninouv an using P1
					drop if _m==2
					drop _m

					* new hire and employed the year before indicators
					ge Hire=(P1ysir!=1)
					ge Emp1y=(Hire*P1y==1)
					drop P1ysir
	
					* limit sample
					keep if Hire==1
	
					* merge with HHIs
					sort fuaX pcs year			
					qui merge m:1 fuaX pcs year using HHI\HHI1_HPsircomtfuaX_pcs41	
					keep if _m==3
					drop _m	
					
					*generate logHHI
					ge logShare_E=log(Share_E)
					
					* merge with instruments
					qui merge m:1 fuaX pcs year using HHI_IV\FIN_HHI1_HPsircomtfuaX_pcs41	
					drop if _m==2
					drop _m	
					
					* merge with national occupational shares
					sort pcs year	
					qui merge m:1 pcs year using HHI\shpcs
					drop if _m==2
					drop _m
*
	
* regression
global fixed = "occ#geo firm#mun#an firm#nic ag educ ftpt sx Emp1y "

disp "perm  MODEL 1"
disp "IV"
ivreghdfe perm shpcs (logShare_E=IV_mH), absorb($fixed)  cluster(cluster) 





cap log close



			
****
