**** Universal data extraction, HHI construction and other.

********************************************************************************
***********************I- DATA extraction****************************************
********************************************************************************
cd "C:\Users\Public\Documents\Europe" // this is the location of all the programmes
set more off 


********************Data extraction********************************************


cap log c
log using dataextraction.log, replace

* 2009

cd ..
foreach year in 09 {
	clear 
	* save empty dataset
	gen year=`year' 
	save Europe\DADSInd`year',replace 
	
	* load data
	foreach region in 21 22 23 24 25 26 31 41 42 43 52 53 54 72 73 74 82 83 91 93 94 11aa 11bb 11cc 11dd { // there is one file per NUTS1 region (but 4 files for 11)
		saswrapper using "Europe\Code\DADSextraction20`year'.sas", post(`"%extraction(post`region');"') nodata clear // the location of the data are in "\\casd.fr\casdfs\Projets\MATRAVE\Data\DADS_DADS Postes_`year'"
		* MATRAVE is the name of our project
		* Other users must change the name "MATRAVE" into the name of their project
		use `year'post`region', clear 
		append using Europe\DADSInd`year'
		save Europe\DADSInd`year',replace 
		
		erase `year'post`region'.dta
	}
	

	rename *, lower // rename as lowercase
	
	duplicates drop ident_s siren nic, force // drop duplicates (matches of people who are resident in one region and work in another)
	
	drop if regexm(comt,"^97") //drop Outre-mer  
	drop if regexm(comt,"^99") //drop Outre-mer
	
	* recoding of some municipalities to their 2010 code
	merge m:1 comt using Europe\geodata\Id2010_communes 
	replace comt=co10 if _m==3  
	drop if _m==2 
	
	* drop unused variables
	drop secteur co10 _m
	compress
	
	* save data extraction
	save Europe\DADSInd`year',replace 
}
cd Europe

* 2010

cd ..
foreach year in 10 {
	clear 
	* save empty dataset
	gen year=`year' 
	save Europe\DADSInd`year',replace 
	* load data
	foreach region in 21 22 23 24 25 26 31 41 42 43 52 53 54 72 73 74 83 91 93 94 11aa 11bb 11cc 11dd 82a 82b { // there is one file per NUTS1 region (but 4 files for 11 & 2 files for 82)
		saswrapper using "Europe\Code\DADSextraction20`year'.sas", post(`"%extraction(post`region');"') nodata clear // the location of the data are in "\\casd.fr\casdfs\Projets\MATRAVE\Data\DADS_DADS Postes_`year'"
		* MATRAVE is the name of our project
		* Other users must change the name "MATRAVE" into the name of their project
		use `year'post`region', clear 
		append using Europe\DADSInd`year'
		save Europe\DADSInd`year',replace 
		
		erase `year'post`region'.dta
	}
	
	rename *, lower	// rename as lowercase
	duplicates drop ident_s siren nic, force // drop duplicates (matches of people who are resident in one region and work in another)
	
	drop if regexm(comt,"^97") //drop Outre-mer  
	drop if regexm(comt,"^99") //drop Outre-mer
	
	* recoding of some municipalities to their 2010 code
	merge m:1 comt using Europe\geodata\Id2010_communes 
	replace comt=co10 if _m==3  
	drop if _m==2 
	
	* drop unused variables
	drop secteur co10 _m
	compress
	
	* save data extraction
	save Europe\DADSInd`year',replace 
}
cd Europe

*2011 
cd ..
foreach year in 11 {
	clear 
	*save empty dataset
	gen year=`year' 
	save Europe\DADSInd`year',replace 
	* load data
	foreach region in 11 21 22 23 24 25 26 31 41 42 43 52 53 54 72 73 74 82 83 91 93 94  { // there is one file per NUTS1 region
		saswrapper using "Europe\Code\DADSextraction20`year'.sas", post(`"%extraction(post`region');"') nodata clear // the location of the data are in "\\casd.fr\casdfs\Projets\MATRAVE\Data\DADS_DADS Postes_`year'"
		* MATRAVE is the name of our project
		* Other users must change the name "MATRAVE" into the name of their project
		use `year'post`region', clear 
		append using Europe\DADSInd`year'
		save Europe\DADSInd`year',replace 
		
		erase `year'post`region'.dta
	}
	
	rename *, lower	// rename as lowercase
	duplicates drop ident_s siren nic, force // drop duplicates (matches of people who are resident in one region and work in another)
	
	drop if regexm(comt,"^97") //drop Outre-mer  
	drop if regexm(comt,"^99") //drop Outre-mer
	
	* recoding of some municipalities to their 2010 code
	merge m:1 comt using Europe\geodata\Id2010_communes 
	replace comt=co10 if _m==3  
	drop if _m==2 
	
	* drop unused variables
	drop secteur co10 _m
	compress
	
	* save data extraction
	save Europe\DADSInd`year',replace 
}

cd Europe

* 2012 & 2013
cd ..
foreach year in 12 13 {
	clear 
	*save empty dataset
	gen year=`year' 
	save Europe\DADSInd`year',replace 
	* load data
	foreach region in 21 22 23 24 25 26 31 41 42 43 52 53 54 72 73 74 82 82 83 91 93 94  { // there is one file per NUTS1 region
		saswrapper using "Europe\Code\DADSextraction20`year'.sas", post(`"%extraction(post`region');"') nodata clear // the location of the data are in "\\casd.fr\casdfs\Projets\MATRAVE\Data\DADS_DADS Postes_`year'"
		* MATRAVE is the name of our project
		* Other users must change the name "MATRAVE" into the name of their project
		use `year'post`region', clear 
		append using Europe\DADSInd`year'
		save Europe\DADSInd`year',replace 
		
		erase `year'post`region'.dta
	}
	
	foreach region in 75 77 78 91 92 93 94 95 { // For Ile de France (11), there is one file per NUTS3 region
		saswrapper using "Europe\Code\DADSextraction120`year'.sas", post(`"%extraction(post`region');"') nodata clear // the location of the data are in "\\casd.fr\casdfs\Projets\MATRAVE\Data\DADS_DADS Postes_`year'"
		* MATRAVE is the name of our project
		* Other users must change the name "MATRAVE" into the name of their project
		use `year'post`region', clear 
		append using Europe\DADSInd`year'
		save Europe\DADSInd`year',replace 
		
		erase `year'post`region'.dta
	}
	
	rename *, lower	// rename as lowercase
	duplicates drop ident_s siren nic, force // drop duplicates (matches of people who are resident in one region and work in another)
	
	drop if regexm(comt,"^97") //drop Outre-mer  
	drop if regexm(comt,"^99") //drop Outre-mer
	
	* recoding of some municipalities to their 2010 code
	merge m:1 comt using Europe\geodata\Id2010_communes 
	replace comt=co10 if _m==3  
	drop if _m==2 
	
	* drop unused variables
	drop secteur co10 _m
	compress
	
	* save data extraction
	save Europe\DADSInd`year',replace 
}
cd Europe

* 2014 & 2015
cd ..
foreach year in 14 15 {
	* load data
	if `year'==14 {
		saswrapper using "Europe\Code\DADSextraction20`year'.sas", post(`"%extraction(post20`year'_prov);"') nodata clear // the location of the data are in "\\casd.fr\casdfs\Projets\MATRAVE\Data\DADS_DADS Postes_`year'"
		* MATRAVE is the name of our project
		* Other users must change the name "MATRAVE" into the name of their project
	}
		if `year'==15 {
		saswrapper using "Europe\Code\DADSextraction20`year'.sas", post(`"%extraction(postes20`year'_prov);"') nodata clear // the location of the data are in "\\casd.fr\casdfs\Projets\MATRAVE\Data\DADS_DADS Postes_`year'"
		* MATRAVE is the name of our project
		* Other users must change the name "MATRAVE" into the name of their project
	}

	use file, clear 
	rename *, lower	// rename as lowercase
	duplicates drop ident_s siren nic, force // drop duplicates (matches of people who are resident in one region and work in another)
	
	drop if regexm(comt,"^97") //drop Outre-mer  
	drop if regexm(comt,"^99") //drop Outre-mer
	
	* recoding of some municipalities to their 2010 code
	merge m:1 comt using Europe\geodata\Id2010_communes 
	replace comt=co10 if _m==3  
	drop if _m==2 
	
	* drop unused variables
	drop secteur co10 _m
	compress
	
	* save data extraction
	save Europe\DADSInd`year',replace 
erase file.dta
}

cd Europe

* 2016 & 2017

cd ..
foreach year in 16 17 {
	clear 
	* create empty dataset
	gen year=`year' 
	save Europe\DADSInd`year', replace 
	* load data
	foreach region in 24 27 28 32 44 52 53 75 76 84 93 94  { // there is one file per NUTS1 region
		saswrapper using "Europe\Code\DADSextraction20`year'.sas", post(`"%extraction(post`region');"') nodata clear // the location of the data are in "\\casd.fr\casdfs\Projets\MATRAVE\Data\DADS_DADS Postes_`year'"
		* MATRAVE is the name of our project
		* Other users must change the name "MATRAVE" into the name of their project
		use `year'post`region', clear 
		append using Europe\DADSInd`year'
		save Europe\DADSInd`year',replace 
		
		erase `year'post`region'.dta
	}
	
	foreach region in 75 77 78 91 92 93 94 95 { // For Ile de France (11), there is one file per NUTS3 region
		saswrapper using "Europe\Code\DADSextraction120`year'.sas", post(`"%extraction(post`region');"') nodata clear // the location of the data are in "\\casd.fr\casdfs\Projets\MATRAVE\Data\DADS_DADS Postes_`year'"
		* MATRAVE is the name of our project
		* Other users must change the name "MATRAVE" into the name of their project
		use `year'post`region', clear 
		append using Europe\DADSInd`year'
		save Europe\DADSInd`year',replace 
		
		erase `year'post`region'.dta
	}
	
	rename *, lower	// rename as lowercase
	duplicates drop ident_s siren nic, force // drop duplicates (matches of people who are resident in one region and work in another)
	
	drop if regexm(comt,"^97") //drop Outre-mer  
	drop if regexm(comt,"^99") //drop Outre-mer
	
	* recoding of some municipalities to their 2010 code
	merge m:1 comt using Europe\geodata\Id2010_communes 
	replace comt=co10 if _m==3  
	drop if _m==2 
	
	* drop unused variables
	drop secteur co10 _m
	
	* rename full-time equivalent variable
	cap ren eqtp etp
	compress
	
	* save data extraction
	save Europe\DADSInd`year',replace 
	
}
cd Europe


cap log c

log using mergefua.log, replace

***** Merging with data on cantons (French-specific) and data on FUAs 
* comt is the merging variable

foreach year in 09 10 11 12 13 14 15 16 17 {

use DADSInd`year'.dta, clear

* drop household as employers
cap tostring(domempl), replace
drop if domempl=="7"
drop if substr(siren,1,1)=="P"
	
*ge comt_or=comt

*pre-merging reassignment of the codes of Paris, Lyon and Marseille, which refer to intra-municipality divisions (country-specific, obviously)
replace comt="76108" if comt=="76095"
	replace comt="75056" if regexm(comt,"^751")
	replace comt="13055" if regexm(comt,"^132")
	replace comt="69123" if regexm(comt,"^6938")
* dropping residual Outre-mer
	drop if regexm(comt,"^98")
*drop empty municipalities
	drop if comt==""
*drop public adminsitration with no municipality	
	drop if substr(comt,3,3)=="000"
	drop if comt=="40529"&nic==comt
	drop if comt=="29603"&nic==comt
	drop if comt=="33998"&nic==comt
	drop if comt=="57998"&nic==comt
	drop if comt=="92902"&nic==comt
	drop if siren=="662043116" /* office national des forets */
	drop if siren=="160020012" /* MONNAIE */
	drop if siren=="110068012" /* ministere ecologie */

	
	

* recoding old municipalities and errors
	replace comt="05139" if comt=="05002"	
	replace comt="05132" if comt=="05020"	
	replace comt="05139" if comt=="05042"	
	replace comt="05132" if comt=="05067"	
	replace comt="05139" if comt=="05138"	
	replace comt="28361" if comt=="28042"	
	replace comt="49042" if comt=="49199"	
	replace comt="49018" if comt=="49213"	
	replace comt="49018" if comt=="49245"	
	replace comt="49018" if comt=="49303"	
	replace comt="49018" if comt=="49372"	
	replace comt="49018" if comt=="49380"	
	replace comt="59183" if comt=="59248"	
	replace comt="59183" if comt=="59540"	
	replace comt="69248" if comt=="69025"	
	replace comt="69248" if comt=="69041"	
	replace comt="69248" if comt=="69128"	
	replace comt="69248" if comt=="69129"	
	replace comt="69208" if comt=="69144"	
	replace comt="79030" if comt=="79353"	
	replace comt="79242" if comt=="79356"	
	replace comt="88176" if comt=="88282"	
	replace comt="2A041" if comt=="20041"
	replace comt="2A090" if comt=="20090"
	replace comt="2A200" if comt=="20200"
	replace comt="2B250" if comt=="20250"
	replace comt="33439" if comt=="33620"
	replace comt="69296" if comt=="69360"
	replace comt="69292" if comt=="69580"
	replace comt="69238" if comt=="69590"
	replace comt="84035" if comt=="84300"
	replace comt="92063" if comt=="92500"
	replace comt="06004" if comt=="06604"

	cap replace comt="83042" if siren=="449401249"&nic=="00031"
	
	
* merging with cantons/FUAs	
sort comt
merge m:1 comt using geodata\interdata\mergedMunicipalitiesOtherFUAs
* drop unmatched municipalities (municipalities where there are no job posts, normally)

drop if _m==2
tab comt if _m==1
drop _m
* drop (now) useless vars
drop Nameoffunctionalurbanarea Namemunicipality

* generate firmXepci identifier (FRA specific)
ren EPCI epci
	ge l=length(epci)
	replace epci="0000000"+epci if l==2
	drop l	
gen sirepci=epci+siren
* generate firmXlau1 identifier (FRA specific)
gen sirlau1=lau1+siren
* generate firmXmunicipality identifier
gen sircomt=comt+siren

* making numeric the variable of presence in the year
if `year'==16|`year'==17 {
	destring ind_3112, replace
	destring ind_3112_1, replace
	}

compress
save DADSpostes`year'.dta, replace
}

cap log c


clear


log using hhi.log, replace

*****Computing the main HHIs ************************************************
* the following big loop construct HHIs for each year for
* each different category of hiring (1: year concept; 2: month/year concept)
* each different type of firm identifiers (firm, firmXcanton, firmXmunicipality, firmXepci)
* each different type of geographical areas 

* each combination of parameters yields a separate file containing HHIs by occupation, geographical area and year
* employment HHIs, the total number of workers and new hires (of the occupationXgeo area couple) and the number of hiring and employing firms are also computed

* reminder of the key variables from the dataset mergedMunicipalitiesFUAs.dta (that are used here):
* dep: NUTS3 regions
* fua1: OECD FUAs
* fuaX: Extended FUAs (OECD FUAS + remaining part of NUTS3 regions with at least 70% of municipalities that are not part of a FUA)


cap mkdir HHI // create subfolder to store HHI datasets

***** Opening the necessary loops
* looping over type of employers
local aggregateL  sircomt siren sirepci sirlau1 
foreach aggregate of loc aggregateL {	
	* looping over geo areas (fua1 will be created from fuaX)
	local zoneL fuaX  dep  
		if "`aggregate'"=="sirepci"|"`aggregate'"=="sirlau1"|"`aggregate'"=="siren" {
			local zoneL fuaX // dep computed only for employers = firmXmunicipality
			}
		foreach zone of loc zoneL {		
		* setting the number of types of HHI given employer identifiers and type of geographical area	
		*HHI1: year concept, HHI2: month/year concept: 2 only for fuaX and sircomt

			global maxtype = 1	
				if "`zone'"=="fuaX"&"`aggregate'"=="sircomt" {
				global maxtype = 2
			}
			
			* looping over HHI types
			foreach x of numlist 1/$maxtype {

					clear
					* create an empty dataset
					gen year=""
					save HHI\HHI`x'_HP`aggregate'`zone'_pcs41, replace 
					
					* looping over years
					foreach year in 10 11 12 13 14 15 16 17 {

					disp `x'
					disp "`zone'"
					disp "`aggregate'"
					disp   "`year'"
					
					***** Part I: compute aggregates at the `zone'XpcsXyear (geo area by occupation by year) level
					use DADSpostes`year',clear 
					
					*drop interns
					drop if typ_emploi=="S"
					drop if typ_emploi=="I"
				
					*keep nbhours>0
					keep if nbheur>0

					* headcount: compute number of workers that are present in the last day of the year (useful as standardised indicator of size of each labour market)
					gen headcount=(ind_3112==1) 
					
					
					**** define new hires
					**** only if at least 1 month of tenure
					*** first step: construct indicators of presence and absence in the same plant for the current and the previous year
					if `x'==1 {
					* construction of the indicators for presence in the current year and absence in the previous year 
						ge P0 = (ind_3112!=.)&duree>=30
						ge A1 = (ind_3112_1==.)
					}
					if `x'==2 {
					* construction of the indicators for presence in November of the current year and absence in November of the previous year 
					* for workers with shift pay, the refernce month is December instead of November
						ge P0 = (datdeb<=301&datfin>=301&datdeb!=.&datfin!=.&duree>=30)
						ge A1 = (datdeb_1>330|datfin_1<301|ind_3112_1==.)
					}
				
					*** second step: construct indicators of absence in the firm for the previous year (according to the different definitions in cases 1, 2 and 3 - see just above)
					egen minA1 = min(A1), by(ident_s `aggregate')
					
					*** third step: effectively define new hires
					gen Hire = (P0==1&minA1==1)
							disp `x' "  2" /* this is just a counter to check the advancement of the loop */

					*keep industries
					keep if (substr(apet, 1, 2)>="05"&substr(apet, 1, 2)<="82")|substr(apet, 1, 2)=="90"| ///
						substr(apet, 1, 2)>="92"&substr(apet, 1, 2)<="96"
							
	
					* cleanup occupation data (there are also few observations with incomplete assignment to an occupation that must be dropped)
					replace pcs=upper(pcs)
					keep if strlen(pcs)==4 
					keep if regexm(pcs,"^[0-9][0-9][0-9][A-Z]") // ensure consistent PCS-ESE occupations
					replace pcs=substr(pcs,1,4) 
					drop if mi(pcs) 	
					
					* collapsing at the local labour market level
					collapse (sum) Z_E=Hire headcount Z_P0=P0, by(`zone' pcs)
									
					sort `zone' pcs
					* creating a temporary file for aggregate variables
					save DADS_P_pcs4, replace 

						***** Part II: compute new hires at the employerXyear level
	

					use DADSPostes`year',clear 
						
					*drop interns
					drop if typ_emploi=="S"
					drop if typ_emploi=="I"
					
					*keep nbhours>0
					keep if nbheur>0


					**** define new hires (as above)
					**** only at least 1 month of tenure
					*** first step: construct indicators of presence and absence in the same plant for the current and the previous year
					if `x'==1 {
					* construction of the indicators for presence in the current year and absence in the previous year 
						ge P0 = (ind_3112!=.)&duree>=30
						ge A1 = (ind_3112_1==.)
					}
					if `x'==2 {
					* construction of the indicators for presence in November of the current year and absence in November of the previous year 
					* for workers with shift pay, the refernce month is December instead of November
						ge P0 = (datdeb<=301&datfin>=301&datdeb!=.&datfin!=.&duree>=30)
						ge A1 = (datdeb_1>330|datfin_1<301|ind_3112_1==.)
					}


					*** second step: construct indicators of absence in the firm for the previous year (different definitions in cases 1, 2 and 3 - see just above)
					** this is the only line that would be modified if transfer are included (next loop)
						egen minA1 = min(A1), by(ident_s `aggregate')
					*** third step: effectively define new hires
						gen Hire = (P0==1&minA1==1)
							disp `x' "  3"  /* this is just a counter to check the advancement of the loop */
	
					*keep industries
					keep if (substr(apet, 1, 2)>="05"&substr(apet, 1, 2)<="82")|substr(apet, 1, 2)=="90"| ///
						substr(apet, 1, 2)>="92"&substr(apet, 1, 2)<="96"


	
					* cleanup occupation data (there are also few observations with incomplete assignment to an occupation that must be dropped)
					replace pcs=upper(pcs)
					keep if strlen(pcs)==4 
					keep if regexm(pcs,"^[0-9][0-9][0-9][A-Z]") // ensure consistent PCS-ESE occupations
					replace pcs=substr(pcs,1,4) 
					drop if mi(pcs) 							
						
					* collapse at the firm level
						collapse (sum) Hire P0, by(`aggregate' `zone' pcs)

					* merge with local labour market aggregates
						merge m:1 `zone' pcs using DADS_P_pcs4

					* squared shares of new hires	
						gen Share_E=(Hire/Z_E)^2
					* squared shares of employment	
						gen EmpH=(P0/Z_P0)^2
						
					* drop further errors in the occupation and geographical area variables, if any
						drop if pcs=="."
						drop if `zone'==""

					* set a counter of the number of hiring firms	
						gen nb_Dm=1 if Hire!=.&Hire!=0
					* set a counter for employing firms	
						ge nb_E=1 if P0!=.&P0!=0
					* aggregating at the LLM level and setting a year counter
					ge Hmax=sqrt(Share_E) // will be used to compute the largest market share in terms of hiring
					ge Emax=sqrt(EmpH) // will be used to compute the largest market share in terms of employees
				collapse (sum) nb_Dm nb_E Share_E EmpH (mean) Z_E headcount Z_P0 (max) Hmax Emax , by(`zone' pcs)

						gen year="`year'"
						
					* append to previous years, if any
						append using HHI\HHI`x'_HP`aggregate'`zone'_pcs41
					* saving
						drop if year=="" // here we drop the fictitious row created in the empty dataset
						

					label var Share_E "HHI based on hiring"
					label var EmpH "HHI based on employment"
					label var Z_E "total number of new hires of the LLM (den. of Shares for the HHI)"
					label var Z_P0 "total number of employees of the LLM (den. of Shares for the HHI)"
					label var headcount "total worker headcounts in the LLM (last day of the year)"
					label var nb_Dm "number of firms which hires in the LLM"
					label var nb_E "number of firms with employees in the LLM"
					label var Hmax "largest market share in terms of hiring in the LLM"
					label var nb_E "largest market share in terms of employees in the LLM"
										
						
						save HHI\HHI`x'_HP`aggregate'`zone'_pcs41, replace 
				}
		}
	
}
}



***** HHI by functional urban area (fua1)

cap log c					
clear

log using Fua1.log, replace


* creating fua1 and fua2 files
***** Opening the necessary loops
* looping over type of employers

use HHI\HHI1_HPsircomtfuaX_pcs41, clear
sort fuaX
merge m:1 fuaX using geodata\interdata\nested_fua
drop if _m==2
drop _m
drop if fua1==""
save HHI\HHI1_HPsircomtfua1_pcs41, replace




* occupational shares in the whole country

cap log c					
clear
log using share.log, replace

* we use the stats from the file containing the HHI at the NUTS3 level because it contains a partition of the whole country
use HHI\HHI1_HPsircomtdep_pcs41, clear
collapse (sum) Z_E, by(pcs year)
egen tot=sum(Z_E), by(year)
ge shpcs=Z_E/tot

keep pcs year shpcs
sort pcs year
save HHI\shpcs, replace


cap log c					
clear


*STATS ON CONCENTRATION
log using statsHHI.log, replace
*log using statsHHI_BBC.log, replace


* STANDARDISED CHARTS (these are common for all countries)

* MONTH-YEAR VS YEAR CONCEPT CHARTS (Figure 1.3)
* load HHIs
* year concept
use HHI\HHI1_HPsircomtfuaX_pcs41, clear
foreach x of varlist nb_Dm Share_E Z_E Z_P0 headcount {
	ren `x' `x'1
	}

* month-year concept	
qui merge 1:1 fuaX pcs year using HHI\HHI2_HPsircomtfuaX_pcs41
drop _m
foreach x of varlist nb_Dm Share_E Z_E Z_P0 headcount {
	ren `x' `x'2
	}

tab year	

foreach x of varlist Share* {
	ge log`x'=log(`x')
	replace `x'=. if `x'==0
	}

* these global variable has been created to facilitate exchange of codes across country teams 	
global logHHI1 logShare_E1 // varname of the log HHI year concept
global logHHI2 logShare_E2 // varname of the log HHI month/year concept
global Hires Z_E1 // varname of the variable containing the number of new hires per cell (year concept)
global Countryname "France" // country

** here the chart is produced (Figure 1.3)
cap mkdir HHI\Figures
label var $logHHI1 "log HHI year"
label var $logHHI2 "log HHI month/year"
twoway scatter $logHHI2 $logHHI1, msize(tiny) title($Countryname)
graph export "HHI\Figures\HHI1HHI2_$Countryname.png", replace

* regression and correlation coefficient
regr $logHHI2 $logHHI1 [pw=$Hires]
pwcorr $logHHI2 $logHHI1 [aw=$Hires]

* FIRM VS FIRMxMUNICIPALITY IDENTIFIERS CHARTS (Figure 1.1)
* load HHIs
* firmXmunicipality based
use HHI\HHI1_HPsircomtfuaX_pcs41, clear
foreach x of varlist nb_Dm Share_E Z_E Z_P0 headcount {
	ren `x' `x'M
	}
	
* firm based
qui merge 1:1 fuaX pcs year using HHI\HHI1_HPsirenfuaX_pcs41
drop _m
foreach x of varlist nb_Dm Share_E Z_E Z_P0 headcount {
	ren `x' `x'T
	}

tab year	

foreach x of varlist Share* {
	ge log`x'=log(`x')
	replace `x'=. if `x'==0
	}

* these global variable has been created to facilitate exchange of codes across country teams 		
global logHHIf logShare_ET // varname of the log HHI year using firm identifiers
global logHHIfm logShare_EM // varname of the log HHI using firmXmun ids.
global Hires Z_ET // varname of the variable containing the number of new hires per cell
global Countryname "France" // country

** here the chart is produced (Figure 1.3)
label var $logHHIf "log HHI (based on firm identifiers)"
label var $logHHIfm "log HHI (based on firmXmunicipality identifiers)"
twoway scatter $logHHIfm $logHHIf, msize(tiny) title($Countryname)
graph export "HHI\Figures\HHIfmHHIf_$Countryname.png", replace

* regression and correlation coefficient
regr $logHHIfm $logHHIf [pw=$Hires]	
pwcorr $logHHIfm $logHHIf [aw=$Hires]	


	
* TABLE 1 & FOOTNOTE
* HHI statistics

local aggregateL siren sircomt

			foreach aggregate of loc aggregateL {	
disp in ye "`aggregate'"
			
* comparing hiring 
use HHI\HHI1_HP`aggregate'fuaX_pcs41, clear

foreach x of varlist nb_Dm Share_E Z_E Z_P0 headcount {
	ren `x' `x'1
	}
	


foreach x of varlist Share* {
	ge log`x'=log(`x')
	replace `x'=. if `x'==0
	}

*** Table 1 & footnote
disp "Distribution of HHI, `aggregate' identifier"
sum Share_E`x' [w=Z_E`x'] if Share_E`x'!=0&Share_E`x'!=., detail

*** Time series evolution
disp "Time series of HHI, `aggregate' identifier"
if "`aggregate'"=="sircomt" {
table year [w=Z_E`x'] if Share_E`x'!=0&Share_E`x'!=., /// 
		c(mean Share_E`x' p25 Share_E`x' median Share_E`x' p75 Share_E`x' p90 Share_E`x')
}


}

***** charts concerning intercommunalities and cantons (Figure 1.2)
***** This part adapts the same segment of code as used for the standardaside charts above

* load HHIs
use HHI\HHI1_HPsircomtfuaX_pcs41, clear
foreach x of varlist nb_Dm Share_E Z_E Z_P0 headcount {
	ren `x' `x'1
	}
	

qui merge 1:1 fuaX pcs year using HHI\HHI1_HPsirepcifuaX_pcs41
drop _m
foreach x of varlist nb_Dm Share_E Z_E Z_P0 headcount {
	ren `x' `x'2
	}


qui merge 1:1 fuaX pcs year using HHI\HHI1_HPsirlau1fuaX_pcs41
drop _m
foreach x of varlist nb_Dm Share_E Z_E Z_P0 headcount {
	ren `x' `x'3
	}	
	
 	
tab year	

foreach x of varlist Share* {
	ge log`x'=log(`x')
	replace `x'=. if `x'==0
	}

* use the same global macros as above	
global logHHI1 logShare_E1 
global logHHI2 logShare_E2 
global logHHI3 logShare_E3 
global Hires Z_E1 
global Countryname "France" 

label var $logHHI1 "log HHI (based on firmXmunicipality identifiers)"
label var $logHHI2 "log HHI (based on firmXintercommunality identifiers)"
label var $logHHI3 "log HHI (based on firmXcanton identifiers)"

* charts
twoway scatter $logHHI2 $logHHI1, msize(tiny) title("Firm X Intercommunality identifiers")
graph export "HHI\Figures\HHI1_Intercommunality.png", replace // Panel A

twoway scatter $logHHI3 $logHHI1, msize(tiny) title("Firm X Canton identifiers")
graph export "HHI\Figures\HHI1_Cantons.png", replace // Panel B

* compute regression coefficients and r-squared
disp "Firm X Intercommunality identifiers"
regr $logHHI2 $logHHI1 [pw=$Hires]
disp "Firm X Canton identifiers"
regr $logHHI3 $logHHI1 [pw=$Hires]

cap log c
clear 



** CONSTRUCTION OF INSTRUMENTS
clear
cap log c


log using IVconstruction.log,replace 

* create a directory for the IVs
cap mkdir HHI_IV

* looping over type of employers
local aggregateL  sircomt siren sirepci sirlau1 
foreach aggregate of loc aggregateL {	
	* looping over geo areas (fua1 will be created from fuaX)
	local zoneL fuaX  dep  fua1
		if "`aggregate'"=="sirepci"|"`aggregate'"=="sirlau1"|"`aggregate'"=="siren" {
			local zoneL fuaX // dep and fua1 computed only for employers = firmXmunicipality
			}
			foreach zone of loc zoneL {		

				* create an empty dataset
				clear		
				ge pi=.
				save HHI_IV\FIN_HHI1_HP`aggregate'`zone'_pcs41, replace 
		
				use HHI\HHI1_HP`aggregate'`zone'_pcs41, clear //HHI database
		
				* looping over geographical areas
				levelsof `zone', loc(listzone) 
			  	foreach geo of loc listzone {				

					disp "`geo'"
					
					use HHI\HHI1_HP`aggregate'`zone'_pcs41, clear //HHI database

						drop if `zone'=="`geo'"  // drop own geo area	

					*
					ge IV_mH=log(1/nb_Dm) //log 1/N hiring firms
					ge IV_mE=log(1/nb_E) //log 1/N employing firms
					ge IV_S=log(Share_E) // log HHI
									
					collapse IV_* , by(pcs year) // by collapsing we take the average over all the remaining geo area
								
					ge `zone'="`geo'"
	
					append using HHI_IV\FIN_HHI1_HP`aggregate'`zone'_pcs41
					
					cap drop pi
					compress
					sort `zone' pcs year				
					save  HHI_IV\FIN_HHI1_HP`aggregate'`zone'_pcs41, replace 
					
					}
		}
		}


clear
cap log c

********** 2/3-DIGIT HHIs
log using hhi23.log, replace

***** Looping over the number of digits
foreach d of numlist 2/3 {
					disp `d'

					clear
					* create an empty dataset
					gen year=""
					save HHI\HHI1_HPsircomtfuaX_pcs`d'1, replace 
					
					* looping over years
					foreach year in 10 11 12 13 14 15 16 17 {

					disp "`d'"
					disp "`year'"
					
					***** Part I: compute aggregates at the fuaXXpcsXyear (geo area by occupation by year) level
					use DADSpostes`year',clear 
					
					*drop interns
					drop if typ_emploi=="S"
					drop if typ_emploi=="I"
				
					*keep nbhours>0
					keep if nbheur>0

					* headcount: compute number of workers that are present in the last day of the year (useful as standardised indicator of size of each labour market)
					gen headcount=(ind_3112==1) 
					
					
					**** define new hires
					**** only if at least 1 month of tenure
					*** first step: construct indicators of presence and absence in the same plant for the current and the previous year
		
					* construction of the indicators for presence in the current year and absence in the previous year 
						ge P0 = (ind_3112!=.)&duree>=30
						ge A1 = (ind_3112_1==.)
					
				
					*** second step: construct indicators of absence in the firm for the previous year (according to the different definitions in cases 1, 2 and 3 - see just above)
					egen minA1 = min(A1), by(ident_s sircomt)
					
					*** third step: effectively define new hires
					gen Hire = (P0==1&minA1==1)
							disp "  2" /* this is just a counter to check the advancement of the loop */

					*keep industries
					keep if (substr(apet, 1, 2)>="05"&substr(apet, 1, 2)<="82")|substr(apet, 1, 2)=="90"| ///
						substr(apet, 1, 2)>="92"&substr(apet, 1, 2)<="96"
							
	
					* cleanup occupation data (there are also few observations with incomplete assignment to an occupation that must be dropped)
					replace pcs=upper(pcs)
					keep if strlen(pcs)==4 
					keep if regexm(pcs,"^[0-9][0-9][0-9][A-Z]") // ensure consistent PCS-ESE occupations
					replace pcs=substr(pcs,1,`d')  // set the right number of digits
					drop if mi(pcs) 	
					
					* collapsing at the local labour market level
					collapse (sum) Z_E=Hire headcount Z_P0=P0, by(fuaX pcs)
									
					sort fuaX pcs
					* creating a temporary file for aggregate variables
					save DADS_P_pcs`d', replace 

						***** Part II: compute new hires at the employerXyear level
	

					use DADSPostes`year',clear 
						
					*drop interns
					drop if typ_emploi=="S"
					drop if typ_emploi=="I"
					
					*keep nbhours>0
					keep if nbheur>0


					**** define new hires (as above)
					**** only at least 1 month of tenure
					*** first step: construct indicators of presence and absence in the same plant for the current and the previous year
					* construction of the indicators for presence in the current year and absence in the previous year 
						ge P0 = (ind_3112!=.)&duree>=30
						ge A1 = (ind_3112_1==.)


					*** second step: construct indicators of absence in the firm for the previous year (different definitions in cases 1, 2 and 3 - see just above)
					** this is the only line that would be modified if transfer are included (next loop)
						egen minA1 = min(A1), by(ident_s sircomt)
					*** third step: effectively define new hires
						gen Hire = (P0==1&minA1==1)
							disp "  3"  /* this is just a counter to check the advancement of the loop */
	
					*keep industries
					keep if (substr(apet, 1, 2)>="05"&substr(apet, 1, 2)<="82")|substr(apet, 1, 2)=="90"| ///
						substr(apet, 1, 2)>="92"&substr(apet, 1, 2)<="96"


	
					* cleanup occupation data (there are also few observations with incomplete assignment to an occupation that must be dropped)
					replace pcs=upper(pcs)
					keep if strlen(pcs)==4 
					keep if regexm(pcs,"^[0-9][0-9][0-9][A-Z]") // ensure consistent PCS-ESE occupations
					replace pcs=substr(pcs,1,`d')  // set the right number of digits
					drop if mi(pcs) 											
					
					* collapse at the firm level
						collapse (sum) Hire P0, by(sircomt fuaX pcs)

					* merge with local labour market aggregates
						merge m:1 fuaX pcs using DADS_P_pcs`d'

					* squared shares of new hires	
						gen Share_E=(Hire/Z_E)^2
					* squared shares of employment	
						gen EmpH=(P0/Z_P0)^2
						
					* drop further errors in the occupation and geographical area variables, if any
						drop if pcs=="."
						drop if fuaX==""

					* set a counter of the number of hiring firms	
						gen nb_Dm=1 if Hire!=.&Hire!=0
					* set a counter for employing firms	
						ge nb_E=1 if P0!=.&P0!=0
					* aggregating at the LLM level and setting a year counter
					ge Hmax=sqrt(Share_E) // will be used to compute the largest market share in terms of hiring
					ge Emax=sqrt(EmpH) // will be used to compute the largest market share in terms of employees
				collapse (sum) nb_Dm nb_E Share_E EmpH (mean) Z_E headcount Z_P0 (max) Hmax Emax , by(fuaX pcs)

						gen year="`year'"
						
					* append to previous years, if any
						append using HHI\HHI1_HPsircomtfuaX_pcs`d'1
					* saving
						drop if year=="" // here we drop the fictitious row created in the empty dataset
						

					label var Share_E "HHI based on hiring"
					label var EmpH "HHI based on employment"
					label var Z_E "total number of new hires of the LLM (den. of Shares for the HHI)"
					label var Z_P0 "total number of employees of the LLM (den. of Shares for the HHI)"
					label var headcount "total worker headcounts in the LLM (last day of the year)"
					label var nb_Dm "number of firms which hires in the LLM"
					label var nb_E "number of firms with employees in the LLM"
					label var Hmax "largest market share in terms of hiring in the LLM"
					label var nb_E "largest market share in terms of employees in the LLM"
										
						
						save HHI\HHI1_HPsircomtfuaX_pcs`d'1, replace 
				}
		}
	


** CONSTRUCTION OF INSTRUMENTS 2/3 DIGITS

***** Looping over the number of digits
foreach d of numlist 2/3 {
				disp `d'

				* create an empty dataset
				clear		
				ge pi=.
				save HHI_IV\FIN_HHI1_HPsircomtfuaX_pcs`d'1, replace 
		
				use HHI\HHI1_HPsircomtfuaX_pcs`d'1, clear //HHI database
		
				* looping over geographical areas
				levelsof fuaX, loc(listzone) 
			  	foreach geo of loc listzone {				

					disp "`geo'"
					
					use HHI\HHI1_HPsircomtfuaX_pcs`d'1, clear //HHI database

						drop if fuaX=="`geo'"  // drop own geo area	

					*
					ge IV_mH=log(1/nb_Dm) //log 1/N hiring firms
					ge IV_mE=log(1/nb_E) //log 1/N employing firms
					ge IV_S=log(Share_E) // log HHI
									
					collapse IV_* , by(pcs year) // by collapsing we take the average over all the remaining geo area
								
					ge fuaX="`geo'"
	
					append using HHI_IV\FIN_HHI1_HPsircomtfuaX_pcs`d'1
					
					cap drop pi
					compress
					sort fuaX pcs year				
					save  HHI_IV\FIN_HHI1_HPsircomtfuaX_pcs`d'1, replace 
					
					}
		}
	


clear
cap log c

