

clear
cap log c
log using WageRegressionsInteractions.log, replace

*BASELINE WAGE REGRESSIONS 4-DIGIT OCCUPATIONS; Interactions (Charts 1-4 + Table 5)  


					* load data
					use prewage, clear
					* drop useless vars
					drop ce entsir ancsir
					

					* limiting sample to fulltimers
						keep if ftpt==1
					
					* merging with appropriate presence/absence indicators the year before
						sort nninouv sircom sir an
						merge 1:1 nninouv sircom sir an using P1sircom
						drop if _m==2
						drop _m
					
					drop P1m
					sort nninouv an
					merge m:1 nninouv an using P1
					drop if _m==2
					drop _m

					* new hire and employed the year before indicators
					ge Hire=(P1ysir!=1)
					ge Emp1y=(Hire*P1y==1)
					drop P1*
					
					* merging with HHI data
					sort fuaX pcs year			
					merge m:1 fuaX pcs year using HHI\HHI1_HPsircomtfuaX_pcs41	
					keep if _m==3
					drop _m	
					*creating logs
					ge logShare_E=log(Share_E)
					
					*merging with instruments
					merge m:1 fuaX pcs year using HHI_IV\FIN_HHI1_HPsircomtfuaX_pcs41	
					drop if _m==2
					drop _m


* create variables for interactions
* place of birth					
ge nai=(depnai=="99") if depnai!="00"&depnai!=""
ge nai0=1-nai	

*education
ge educ1=(educ==1)
ge educ2=(educ==2)
ge educ3=(educ==3)
ge educ4=(educ==.)	
ge educ23=educ2+educ3	

*age
ge duage=(age<=24&age!=.)		

*gender
destring sx, replace


* create interaction variables (including for new hires and incumbents)
	foreach rr of varlist logShare_E IV_mH {
	ge `rr'nai=`rr'*nai
	ge `rr'nai0=`rr'*nai0
	ge `rr'educ1=`rr'*educ1
	ge `rr'educ23=`rr'*educ23
		ge `rr'Y=`rr'*duage
		ge `rr'O=`rr'*(1-duage)
		ge `rr'M=`rr'*sx
		ge `rr'W=`rr'*(1-sx)
		ge `rr'H=`rr'*Hire
		ge `rr'S=`rr'*(1-Hire)	
	}

global fixed = "id occ#geo firm#mun#an firm#nic age ftpt Hire Emp1y "


*1 birthplace (Figure 3)
	
disp "IV standardHHI dwage  MODEL 1"
	ivreghdfe dwage nai (logShare_Enai logShare_Enai0 = IV_mHnai IV_mHnai0), absorb($fixed)  cluster(cluster) 
	
*2 Education (Figure 4)
	
disp "IV standardHHI dwage  MODEL 1"
	ivreghdfe dwage educ1 (logShare_Eeduc1 logShare_Eeduc23 =IV_mHeduc1 IV_mHeduc23) if educ!=., absorb($fixed)  cluster(cluster) 	

*3 age (Figure 2)
disp "IV standardHHI dwage  MODEL 1"
	ivreghdfe dwage (logShare_EY logShare_EO =IV_mHY IV_mHO), absorb($fixed)  cluster(cluster) 

*4 gender (Figure 1)
disp "IV standardHHI dwage  MODEL 1"
	ivreghdfe dwage (logShare_EM logShare_EW =IV_mHM IV_mHW), absorb($fixed)  cluster(cluster) 
	
*5 newhires / incumbents (Table 5)
disp "IV standardHHI dwage  MODEL 1"
	ivreghdfe dwage (logShare_EH logShare_ES =IV_mHH IV_mHS), absorb($fixed)  cluster(cluster) 
	
	


cap log close
clear
	
