


*** 1.6 PREPARATION OF BEH DATA: ADDITIONAL WORKER VARIABLES ***



*** 1.6.1 EMPLOYED IN YEAR BEFORE + HIRED ON FIXED-TERM CONTRACT IN YEAR BEFORE


use "$orig\BeH\015163_BeH_1019_V1.dta", clear

keep ieb_fall_id beh_befristung


tab beh_befristung, m

rename beh_befristung permanent

recode permanent  (-9=.) (-5=.) (1=1) (2=0)

label variable permanent "Permanent Contract (0=No, 1=Yes)"

label define permanent  0 "0 No"  1 "1 Yes"
label values permanent permanent

tab permanent, m

save "$data\Fixedterm_1019.dta", replace






use "$data\LMC_1019_V3.dta", clear // load dataset from HHI construction which contains all available spells

keep betnr prs_id year ieb_fall_id start end type week_52 month_12 year_01

sort ieb_fall_id

merge 1:1 ieb_fall_id using "$data\inflow_week_52.dta", keepusing(hire_week_52)
drop if _merge==2
drop _merge

merge 1:1 ieb_fall_id using "$data\inflow_month_12.dta", keepusing(hire_month_12)
drop if _merge==2
drop _merge

merge 1:1 ieb_fall_id using "$data\inflow_year_01.dta", keepusing(hire_year_01)
drop if _merge==2
drop _merge

merge 1:1 ieb_fall_id using "$data\Fixedterm_1019.dta", keepusing(permanent)
drop if _merge==2
drop _merge




sort prs_id year

label define hire_perm 0 "0 No" 1 "1 Yes"
label define hire_temp 0 "0 No" 1 "1 Yes"

local flow week_52 month_12 year_01

foreach x of local flow {

	gen hire_`x'_perm = .
	replace hire_`x'_perm = . if hire_`x'==. // hire not defined
	replace hire_`x'_perm = . if hire_`x'==0 // no hire
	replace hire_`x'_perm = 0 if hire_`x'==1 & permanent==0 // hire on fixed-term contract
	replace hire_`x'_perm = 1 if hire_`x'==1 & permanent==1 // hire on permanent contract
	
	label variable hire_`x'_perm "Hire with Permanent Contract (0=No, 1=Yes)"
	
	label values hire_`x'_perm hire_perm
	
	
	
	gen hire_`x'_temp = .
	replace hire_`x'_temp = . if hire_`x'==. // hire not defined
	replace hire_`x'_temp = . if hire_`x'==0 // no hire
	replace hire_`x'_temp = 1 if hire_`x'==1 & permanent==0 // hire on fixed-term contract
	replace hire_`x'_temp = 0 if hire_`x'==1 & permanent==1 // hire on permanent contract
	
	label variable hire_`x'_temp "Hire with Temporary Contract (0=No, 1=Yes)"
	
	label values hire_`x'_temp hire_temp
	
	
	
	
	
}

drop permanent



collapse (sum) week_52 month_12 year_01 hire_week_52_perm hire_month_12_perm hire_year_01_perm hire_week_52_temp hire_month_12_temp hire_year_01_temp, by(prs_id year)

sort prs_id year


by prs_id: gen n = _n
by prs_id: gen N = _N


label define employment_last 0 "0 No" 1 "1 Yes"



local flow week_52 month_12 year_01

foreach x of local flow {

	gen employment_last_`x' = .
	by prs_id: replace employment_last_`x' = 0 if n==1
	by prs_id: replace employment_last_`x' = 0 if n>1 & year[_n-1]+1!=year[_n]
	by prs_id: replace employment_last_`x' = 0 if n>1 & year[_n-1]+1==year[_n] & `x'[_n-1]==0
	by prs_id: replace employment_last_`x' = 1 if n>1 & year[_n-1]+1==year[_n] & `x'[_n-1]>=1 
	replace employment_last_`x' = . if year==2010


	label values employment_last_`x' employment_last

	label variable employment_last_`x' "Employed in Last Year (0=No, 1=Yes)"


	tab employment_last_`x', m
	tab year employment_last_`x', m
	tab year employment_last_`x', m nofreq row


}




label define hire_perm_last 0 "0 No" 1 "1 Yes"

local flow week_52 month_12 year_01

foreach x of local flow {


	gen hire_perm_last_`x' = .
	by prs_id: replace hire_perm_last_`x' = 0 if n==1
	by prs_id: replace hire_perm_last_`x' = 0 if n>1 & year[_n-1]+1!=year[_n]
	by prs_id: replace hire_perm_last_`x' = 0 if n>1 & year[_n-1]+1==year[_n] & hire_`x'_perm[_n-1]==0
	by prs_id: replace hire_perm_last_`x' = 1 if n>1 & year[_n-1]+1==year[_n] & hire_`x'_perm[_n-1]>=1 
	replace hire_perm_last_`x' = . if year==2010


	label values hire_perm_last_`x' hire_perm_last

	label variable hire_perm_last_`x' "Hire on Permanent Contract in Last Year (0=No, 1=Yes)"


	tab hire_perm_last_`x', m
	tab year hire_perm_last_`x', m
	tab year hire_perm_last_`x', m nofreq row

	
	
	gen hire_temp_last_`x' = .
	by prs_id: replace hire_temp_last_`x' = 0 if n==1
	by prs_id: replace hire_temp_last_`x' = 0 if n>1 & year[_n-1]+1!=year[_n]
	by prs_id: replace hire_temp_last_`x' = 0 if n>1 & year[_n-1]+1==year[_n] & hire_`x'_temp[_n-1]==0
	by prs_id: replace hire_temp_last_`x' = 1 if n>1 & year[_n-1]+1==year[_n] & hire_`x'_temp[_n-1]>=1 
	replace hire_temp_last_`x' = . if year==2010


	label values hire_temp_last_`x' hire_perm_last

	label variable hire_temp_last_`x' "Hire on Temporary Contract in Last Year (0=No, 1=Yes)"


	tab hire_temp_last_`x', m
	tab year hire_temp_last_`x', m
	tab year hire_temp_last_`x', m nofreq row
	
	
	
	
	
	

}

keep prs_id year employment_last_* hire_perm_last_* hire_temp_last_*

keep if year>=2012 & year<=2018


save "$data\LH_Year_Before_1218.dta", replace










*** 1.6.2 DEFINE BEH EXTRACT FOR DIM DEPARTMENT ***


*not necessary 

*reason: STATA self-service from DIM is used



*** 1.6.3 LOAD DATASET ***


*see 1.2.2 / STATA Self-Service




*** 1.6.4 CLEAN DATASET ***


*see 1.2.3 / STATA Self-Service





*** 1.6.5 ANALOGOUS DATA ADJUSTMENTS TO ESTABLISHMENT HISTORY PANEL (EXCL. WAGE IMPUTATION) ***


use "$orig\BeH\015163_BeH_1019_V1.dta", clear

	/*
	preserve 
	
	
	keep betnr year wz08_kons_num
	
	order betnr year
	sort betnr year
		
		
	*WZ08-5 industries (839 subclasses)

	rename wz08_kons_num wz08_5_imp

	recode wz08_5_imp (-9=.) (-8=.) (-7=.) (-6=.) (-5=.)

	quietly do "$prog\WZ08-5.do"
	label values wz08_5_imp wz08_5
	format %50.0f wz08_5_imp



	*WZ08-4 industries (615 classes)

	gen wz08_4_imp = floor(wz08_5_imp/10)

	quietly do "$prog\WZ08-4.do"
	label values wz08_4_imp wz08_4
	format %50.0f wz08_4_imp



	*WZ08-3 industries (272 groups)

	gen wz08_3_imp = floor(wz08_4_imp/10) 

	quietly do "$prog\WZ08-3.do"
	label values wz08_3_imp wz08_3
	format %50.0f wz08_3_imp
	
	keep if year>=2012 & year<=2018
	duplicates drop

	label variable wz08_5_imp "Industrial Subclass (WZ08-5)"
	label variable wz08_4_imp "Industrial Class (WZ08-4)"
	label variable wz08_3_imp "Industrial Group (WZ08-3)"
	
	save "$data\WZ.dta", replace
	
	
	restore
	*/


*** (A) IMPUTATION OF EDUCATION VARIABLE ***


*source: Ganzer et al. (2020, p.15)

*note: must be done before episode splitting is undone and irrelevant employment spells are deleted

*imputation of education variable by means of Thomsen et al. (2018)
*has already been implemented in variable "beh_ausbildung_imp"


tab beh_ausbildung, m // there are missing values
count if ( beh_ausbildung==-9 |beh_ausbildung==-5 | beh_ausbildung== 7 | beh_ausbildung==9 ) // 217,402,186 observations are missing

tab beh_ausbildung_imp, m // imputation from Thomsen et al. (2018)
count if beh_ausbildung_imp==-7 // 32,321,511 observations are only missing anymore

*drop beh_ausbildung



*** (B) UNDO EPISODE SPLITTING ***

*source: Antoni et al. (2016, p.27)

*irrelevant as data do not feature episode splitting




*** (C) CONSIDERATION OF RELEVANT EMPLOYMENT SPELLS ***

*only consider the following employment relationships:
*101,102,103,105,106,109,112,113,114,118,119,120,121,122,140,141,142,143,144,149,201,202,203,205,209,999,YYY
*source: Ganzer et al. (2020, p.13 & 111f)

tab beh_pers_gr, m

keep if beh_pers_gr == 101 |  beh_pers_gr == 102 | beh_pers_gr == 103 | beh_pers_gr == 105 | /// 
        beh_pers_gr == 106 |  beh_pers_gr == 109 | beh_pers_gr == 112 | beh_pers_gr == 113 | /// 
        beh_pers_gr == 114 |  beh_pers_gr == 118 | beh_pers_gr == 119 | beh_pers_gr == 120 | /// 
        beh_pers_gr == 121 |  beh_pers_gr == 122 | beh_pers_gr == 140 | beh_pers_gr == 141 | ///
		beh_pers_gr == 142 |  beh_pers_gr == 143 | beh_pers_gr == 144 | beh_pers_gr == 149 | ///
		beh_pers_gr == 201 |  beh_pers_gr == 203 | beh_pers_gr == 205 | beh_pers_gr == 209 | /// 
		beh_pers_gr == 299 |  beh_pers_gr == 999 | beh_pers_gr == -8  // drop all notifications with irrelevant employment status

		
		


gen contract = .
replace contract = 1 if (beh_pers_gr==101 | beh_pers_gr==113 | beh_pers_gr==114 | beh_pers_gr==140 | beh_pers_gr==143) // regular employment
replace contract = 2 if (beh_pers_gr==109 | beh_pers_gr==209) // marginal employment
replace contract = 3 if (beh_pers_gr==102 | beh_pers_gr==121 | beh_pers_gr==122 | beh_pers_gr==141 | beh_pers_gr==144) // apprenticeship
replace contract = 4 if (beh_pers_gr==103 | beh_pers_gr==142) // partial retirement
replace contract = 5 if (beh_pers_gr==105 | beh_pers_gr==106 | beh_pers_gr==112 | beh_pers_gr==118 | beh_pers_gr==119 | beh_pers_gr==120 | beh_pers_gr==149 | beh_pers_gr==201 | beh_pers_gr==203 | beh_pers_gr==205 | beh_pers_gr==999 | beh_pers_gr==-8) // other employment

label define contract 1 "1 Regular Employment" 2 "2 Marginal Employment" 3 "3 Apprenticeship" 4 "4 Partial Retirement" 5 "5 Other Employment" 
label values contract


drop beh_pers_gr


*** (D) IMPUTATION FOR PART-TIME VARIABLE ***


*source: Ganzer et al. (2020, p.16)

*imputation of part-time variable by means of Thomsen/Ludsteck (2016)
*has already been implemented in variable "berufstellg_imp_num"


tab berufstellg, m	
count if ( berufstellg==-9 | berufstellg==-7 | berufstellg==-5 | berufstellg==5 | berufstellg==6 ) // ... observations are missing

tab berufstellg_imp_num, m // imputation from Ludsteck/Thomsen (2016) --> this variable includes only imputed values

replace berufstellg=20 if berufstellg_imp_num==20
replace berufstellg=21 if berufstellg_imp_num==21

drop berufstellg_imp_num
rename berufstellg berufstellg_imp_num

tab berufstellg_imp_num, m
count if ( berufstellg_imp_num==-9 | berufstellg_imp_num==-5 | berufstellg_imp_num==-5 | berufstellg_imp_num==5 | berufstellg_imp_num==6) // ... observations are only missing anymore


gen parttime_imp = .
replace parttime_imp = 0 if ( berufstellg_imp_num==0  | berufstellg_imp_num==1  | berufstellg_imp_num==2  | berufstellg_imp_num==3  | berufstellg_imp_num==4 |  berufstellg_imp_num==7 | berufstellg_imp_num==20 )
replace parttime_imp = 1 if ( berufstellg_imp_num==8  | berufstellg_imp_num==9  | berufstellg_imp_num==21 )
replace parttime_imp = . if ( berufstellg_imp_num==-9 | berufstellg_imp_num==-8 | berufstellg_imp_num==-7 | berufstellg_imp_num==-6 | berufstellg_imp_num==-5 | berufstellg_imp_num==5 | berufstellg_imp_num==6 )

label variable parttime_imp "Part-Time Employment (0=No, 1=Yes)"

tab parttime_imp, m		
tab year parttime_imp, m

drop berufstellg_imp_num





*** (E) DELETION OF OBSERVATIONS WITH ZERO WAGES ***


*delete observations with zero wages
*source: Ganzer et al. (2020, p.13)

count if beh_tag_entg==0 // ...
drop if beh_tag_entg==0


*additional adjustment (not in BHP):

count if beh_tag_entg==. // ...
drop if beh_tag_entg==.



*** (F) CONVERSION TO EURO ***


*note: variable "beh_tag_entg" is already expressed in Euro for all years
*source: Grießemer (2019, p. 35 & 78)
*no need for conversion

*note: variable "beh_entg" is expressed in DM for years before 1999
*source: Grießemer (2019, p. 35 & 69)
*must be converted

tab year whrng_knz, m

replace beh_entgelt = beh_entgelt / 1.95583 if year<1999

drop whrng_knz






*** (G) ADDITION OF SPECIAL PAYMENTS ***


*add special payments (holiday pay, christmas bonus) to spell for regular employment
*source: Ganzer et al. (2020, p.14)

*manual addition of special payment only necessary when wage imputation is done manually (and not by FDZ)


*problem: unclear which spell the special payments should be attributed to (as we do not restrict on one person-establishment-year triple in calculation of HHI)



drop if beh_abg==54






*** (H) EXTRACT REFERENCE DATE INFORMATION FROM SPELL DATA ***

*deletion does not make sense here --> keep all spells for application of different hiring concepts later on


*extract reference date information for firm-specific closing date of the respective years
*source: Ganzer et al. (2020, p.17)

*generate variable for reference date

gen date = mdy(12, 31, year) // 31 Dec of each year
format date %tdDD_Mon_CCYY

label variable date "Reference Date"


*extract spells that comprise 31 Dec of respective year

keep if beh_beg_dat<=date & beh_end_dat>=date 



*** (I) DELETE MULTIPLE PERSON-ESTABLISHMENT RELATIONSHIPS WITHIN ONE YEAR ***



order betnr prs_id year
sort betnr prs_id year

by betnr prs_id year: gen N = _N 
tab N, m // about 10% of all spells are affected
drop N



*note: spells with same occupation, region and type --> it does not matter for HHI computation which duplicate is dropped (0.08% of spells)

*duplicates report betnr year prs_id contract nuts07_3 fua nuts07_3_fua isco08_4_imp, force // without "ieb_fall_id"



*delete multiple employment relationships between person and a certain establishment within one year
*source: Ganzer et al. (2020, p.17)	


*delete multiple person-firm combinations within one year

sort betnr prs_id year ieb_fall_id // ensure stable sorting with "ieb_fall_id" for reproducability 
by betnr prs_id year: gen multi = _N
tab multi, m


*1st step: 
*delete marginal employment, if there is simultaneous non-marginal employment and marginal employment

egen nonmarginal = sum(contract!=2), by (betnr prs_id year)
tab nonmarginal, m

gen drop1 = ( contract==2 & multi>=2 & nonmarginal>=1 )
drop if drop1==1 // 9,469,995
drop multi

by betnr prs_id year: gen multi = _N
tab multi, m




*2nd step: 
*if there is only non-marginal employment or marginal employment
*choose observation with highest value for "beh_tag_entgelt"
*when there is a tie:
*choose observation with highest value for "beh_dauer"


sort betnr prs_id year ieb_fall_id // ensure stable sorting with "ieb_fall_id" for reproducability 
by betnr prs_id year: egen rank_w = rank(-beh_tag_entg) // no missing rank values because of missing values
replace rank_w=999999999 if beh_tag_entg==. // impute rank of missing values by very large rank number
by betnr prs_id year: egen rank_d = rank(-beh_dauer) // no missing rank values because of missing values

order betnr prs_id year multi rank_w beh_tag_entg rank_d beh_dauer
sort betnr prs_id year rank_w rank_d ieb_fall_id // ensure stable sorting with "ieb_fall_id" for reproducability 

by betnr prs_id year: gen rank = _n
order betnr prs_id year rank
sort betnr prs_id year rank ieb_fall_id // ensure stable sorting with "ieb_fall_id" for reproducability 

gen drop2 = ( rank!=1 )

drop if drop2==1 // 45,277,127 
drop multi

by betnr prs_id year: gen multi = _N
tab multi, m

drop rank* multi nonmarginal drop1 drop2 



*delete unneeded variables



keep prs_id year betnr ieb_fall_id /// 
	 beh_beg_dat beh_end_dat beh_dauer date ///
	 beh_tag_entg /// 
	 beh_arbstd ///
	 contract parttime_imp /// 
	 geb_dat sex_id beh_staat ///
	 beh_an_ueberlass beh_befristung /// 
	 beh_ausbildung beh_ausbildung_imp ///
	 wz08_kons_num /// 
	 beh_beruf_kldb10_num /// beh_beruf_num 
	 e_krs_schl_ao_akt_num e_gem_schl_ao_akt_num ///
	 e_krs_schl_wo_akt_num e_gem_schl_wo_akt_num /// 	
	 ow_knz
	    		
keep if year>=2012 & year<=2018				
				
*duplicates drop



save "$data\BeH_1218_V2.dta", replace
use "$data\BeH_1218_V2.dta", clear







*** 1.6.6 PREPARATION OF BEH VARIABLES ***





*** (B) START DATE

rename beh_beg_dat start

*tab start, m	

label variable start "Start Date of Spell"

format start %tdDD_Mon_CCYY



*** (C) END DATE


rename beh_end_dat end

*tab end, m	

label variable end "End Date of Spell"

format end %tdDD_Mon_CCYY






			
*** (D) SPELL DURATION

rename beh_dauer duration

tab duration, m

label variable duration "Spell Duration (in Days)"





*** (E) WORKING TIME INDICATOR

tab parttime_imp, m	

label variable parttime_imp "Part-Time Employment (0=No, 1=Yes)"

label define parttime 0 "0 No" 1 "1 Yes"
label values parttime parttime


*** (F) EMPLOYMENT TYPE


gen type = .
replace type = 1 if contract==1 & parttime_imp==0 // regular employment: full-time
replace type = 2 if contract==1 & parttime_imp==1 // regular employment: part-time
replace type = 3 if contract==2 // marginal employment
replace type = 4 if contract==3 // apprenticeship
replace type = 5 if contract==4 // partial retirement
replace type = 6 if contract==5 & parttime_imp==0 // other employment: full-time
replace type = 7 if contract==5 & parttime_imp==1 // other employment: part-time


label variable type "Type of Employment"

label define type 1 "1 Regular Employment: FT" 2 "2 Regular Employment: PT" 3 "3 Marginal Employment" 4 "4 Apprenticeship" 5 "5 Partial Retirement"  6 "6 Other Employment: FT"  7 "7 Other Employment: PT"
label values type type


tab type, m

tab type parttime_imp, m

drop contract			
			
			
* create aggregates 

gen all = 1
gen reg = ( type==1 | type==2 ) 
gen mar = ( type==3 )
gen app = ( type==4 )
gen ret = ( type==5 )
gen oth = ( type==6 | type==7 )  
gen regoth = ( reg==1 | oth==1 )
gen regft = ( reg==1 & parttime_imp==0  )
gen regothft = ( regoth==1 & parttime_imp==0 )
gen regothpt = ( regoth==1 & parttime_imp==1 )


label variable all "Employment (0=No, 1=Yes)"
label variable reg "Regular Employment (0=No, 1=Yes)"
label variable mar "Marginal Employment (0=No, 1=Yes)"
label variable app "Apprenticeship (0=No, 1=Yes)"
label variable ret "Partial Retirement (0=No, 1=Yes)"
label variable oth "Other Employment (0=No, 1=Yes)"
label variable regoth "Regular/Other Employment (0=No, 1=Yes)"
label variable regft "Regular FT Employment (0=No, 1=Yes)"
label variable regothft "Regular/Other FT Employment (0=No, 1=Yes)"
label variable regothpt "Regular/Other PT Employment (0=No, 1=Yes)"


label define reg 0 "0 No" 1 "1 Yes"
label values reg reg

label define mar 0 "0 No" 1 "1 Yes"
label values mar mar

label define app 0 "0 No" 1 "1 Yes"
label values app app

label define ret 0 "0 No" 1 "1 Yes"
label values ret ret

label define oth 0 "0 No" 1 "1 Yes"
label values oth oth

label define regoth 0 "0 No" 1 "1 Yes"
label values regoth regoth

label define regft 0 "0 No" 1 "1 Yes"
label values regft regft

label define regothft 0 "0 No" 1 "1 Yes"
label values regothft regothft

label define regothpt 0 "0 No" 1 "1 Yes"
label values regothpt regothpt

		
		
*** (G) GENDER


tab sex_id, m  // there are no missing values
recode sex_id (1=0) (2=1)

rename sex_id female

label variable female "Female (0=No, 1=Yes)"

label define female 0 "0 No" 1 "1 Yes" 
label values female female

tab female, m



*** (H) AGE 


format geb_dat %tdD_m_CY

gen age = round((date - geb_dat)/365.25, 0.01)

label variable age "Age (in Years)"

format %15.1f age

sum age





*** (I) EDUCATION


tab beh_ausbildung, m

di (2331943 + 87690465 ) / 257037896 



tab beh_ausbildung_imp, m

gen educ_imp = .
replace educ_imp = 0 if (beh_ausbildung_imp==-7) // unknown education
replace educ_imp = 1 if (beh_ausbildung_imp==0 | beh_ausbildung_imp==1 | beh_ausbildung_imp==3) // low education
replace educ_imp = 2 if (beh_ausbildung_imp==2 | beh_ausbildung_imp==4) // medium education
replace educ_imp = 3 if (beh_ausbildung_imp==5 | beh_ausbildung_imp==6) // high education

tab educ_imp, m

label variable educ_imp "Professional Education"

label define educ 0 "0 Unknown Education" 1 "1 Low Education" 2 "2 Medium Education" 3 "3 High Education" 

label values educ educ



gen educ2_imp = .
replace educ2_imp = 0 if (beh_ausbildung_imp==-7) // unknown education
replace educ2_imp = 1 if (beh_ausbildung_imp==0 | beh_ausbildung_imp==1 ) // less than upper secondary education
replace educ2_imp = 2 if (beh_ausbildung_imp==2 | beh_ausbildung_imp==3 | beh_ausbildung_imp==4) // upper secondary education
replace educ2_imp = 3 if (beh_ausbildung_imp==5 | beh_ausbildung_imp==6) // more than upper secondary education

tab educ2_imp, m

label variable educ2_imp "ISCED Education"

label define educ2 0 "0 Unknown Education" 1 "1 Less Than Upper Secondary Education" 2 "2 Upper Secondary Education" 3 "3 More Than Upper Secondary Education" 

label values educ2 educ2





drop beh_ausbildung




*tab year educ_imp, m 
*tab year educ_imp, m row nofreq
*tab year educ_imp if regothft==1 & age>=15, m
*tab year educ_imp if regothft==1 & age>=15, m nofreq row





*** (J) NATIONALITY

tab beh_staat_num, m // there are missing values

gen foreign=.
replace foreign=0 if beh_staat_num==0 // German nationality
replace foreign=1 if ( beh_staat_num>0 & beh_staat_num<=997 ) // foreign nationality  
replace foreign=. if ( beh_staat_num==998 | beh_staat_num==999 ) // unknown nationality

label variable foreign "Foreign Nationality (0=No, 1=Yes)"

label define foreign 0 "0 No" 1 "1 Yes"  
label values foreign foreign

tab foreign, m



*** (K) INDUSTRY ***



*WZ08-5 industries (839 subclasses)

rename wz08_kons_num wz08_5_imp

*tab wz08_5_imp, m 
recode wz08_5_imp (-9=.) (-8=.) (-7=.) (-6=.) (-5=.)

gen wz08_5_imp_miss = (wz08_5_imp==.)
tab year wz08_5_imp_miss
drop wz08_5_imp_miss

quietly do "$prog\WZ08-5.do"
label values wz08_5_imp wz08_5
format %50.0f wz08_5_imp

*tab wz08_5_imp, m


*WZ08-4 industries (615 classes)

gen wz08_4_imp = floor(wz08_5_imp/10)

*tab wz08_4_imp, m


quietly do "$prog\WZ08-4.do"
label values wz08_4_imp wz08_4
format %50.0f wz08_4_imp

*tab wz08_4_imp, m



*WZ08-3 industries (272 groups)

gen wz08_3_imp = floor(wz08_4_imp/10) 

*tab wz08_3_imp, m 


quietly do "$prog\WZ08-3.do"
label values wz08_3_imp wz08_3
format %50.0f wz08_3_imp

*tab wz08_3, m



*WZ08-2 industries (88 divisions)

gen wz08_2_imp = floor(wz08_3_imp/10) 

*tab wz08_2_imp, m 

quietly do "$prog\WZ08-2.do"
label values wz08_2_imp wz08_2
format %50.0f wz08_2_imp

*tab wz08_2_imp, m


*WZ08-1C industries (38 small sections)

gen wz08_1c_imp = . 
replace wz08_1c_imp =  1 if wz08_2_imp>= 1 & wz08_2_imp<= 3 // A
replace wz08_1c_imp =  2 if wz08_2_imp>= 5 & wz08_2_imp<= 9 // B
replace wz08_1c_imp =  3 if wz08_2_imp>=10 & wz08_2_imp<=12 // CA
replace wz08_1c_imp =  4 if wz08_2_imp>=13 & wz08_2_imp<=15 // CB
replace wz08_1c_imp =  5 if wz08_2_imp>=16 & wz08_2_imp<=18 // CC
replace wz08_1c_imp =  6 if wz08_2_imp==19 // CD
replace wz08_1c_imp =  7 if wz08_2_imp==20 // CE
replace wz08_1c_imp =  8 if wz08_2_imp==21 // CF
replace wz08_1c_imp =  9 if wz08_2_imp>=22 & wz08_2_imp<=23 // CG
replace wz08_1c_imp = 10 if wz08_2_imp>=24 & wz08_2_imp<=25 // CH
replace wz08_1c_imp = 11 if wz08_2_imp==26 // CI
replace wz08_1c_imp = 12 if wz08_2_imp==27 // CJ
replace wz08_1c_imp = 13 if wz08_2_imp==28 // CK
replace wz08_1c_imp = 14 if wz08_2_imp>=29 & wz08_2_imp<=30 // CL
replace wz08_1c_imp = 15 if wz08_2_imp>=31 & wz08_2_imp<=33 // CM
replace wz08_1c_imp = 16 if wz08_2_imp==35  // D
replace wz08_1c_imp = 17 if wz08_2_imp>=36 & wz08_2_imp<=39 // E
replace wz08_1c_imp = 18 if wz08_2_imp>=41 & wz08_2_imp<=43 // F
replace wz08_1c_imp = 19 if wz08_2_imp>=45 & wz08_2_imp<=47 // G
replace wz08_1c_imp = 20 if wz08_2_imp>=49 & wz08_2_imp<=53 // H
replace wz08_1c_imp = 21 if wz08_2_imp>=55 & wz08_2_imp<=56 // I
replace wz08_1c_imp = 22 if wz08_2_imp>=58 & wz08_2_imp<=60 // JA
replace wz08_1c_imp = 23 if wz08_2_imp==61 // JB
replace wz08_1c_imp = 24 if wz08_2_imp>=62 & wz08_2_imp<=63 // JC
replace wz08_1c_imp = 25 if wz08_2_imp>=64 & wz08_2_imp<=66 // K
replace wz08_1c_imp = 26 if wz08_2_imp==68 // L
replace wz08_1c_imp = 27 if wz08_2_imp>=69 & wz08_2_imp<=71 // MA
replace wz08_1c_imp = 28 if wz08_2_imp==72 // MB
replace wz08_1c_imp = 29 if wz08_2_imp>=73 & wz08_2_imp<=75 // MC
replace wz08_1c_imp = 30 if wz08_2_imp>=77 & wz08_2_imp<=82 // N
replace wz08_1c_imp = 31 if wz08_2_imp==84 // O
replace wz08_1c_imp = 32 if wz08_2_imp==85 // P
replace wz08_1c_imp = 33 if wz08_2_imp==86 // QA
replace wz08_1c_imp = 34 if wz08_2_imp>=87 & wz08_2_imp<=88 // QB
replace wz08_1c_imp = 35 if wz08_2_imp>=90 & wz08_2_imp<=93 // R
replace wz08_1c_imp = 36 if wz08_2_imp>=94 & wz08_2_imp<=96 // S
replace wz08_1c_imp = 37 if wz08_2_imp>=97 & wz08_2_imp<=98 // T
replace wz08_1c_imp = 38 if wz08_2_imp==99 // U

quietly do "$prog\WZ08-1C.do"
label values wz08_1c_imp wz08_1c
format %50.0f wz08_1c_imp

*tab wz08_1c_imp, m


*WZ08-1B industries (21 sections)

gen wz08_1b_imp = . 
replace wz08_1b_imp =  1 if wz08_2_imp>= 1 & wz08_2_imp<= 3 // A
replace wz08_1b_imp =  2 if wz08_2_imp>= 5 & wz08_2_imp<= 9 // B
replace wz08_1b_imp =  3 if wz08_2_imp>=10 & wz08_2_imp<=33 // C
replace wz08_1b_imp =  4 if wz08_2_imp==35 // D
replace wz08_1b_imp =  5 if wz08_2_imp>=36 & wz08_2_imp<=39 // E
replace wz08_1b_imp =  6 if wz08_2_imp>=41 & wz08_2_imp<=43 // F
replace wz08_1b_imp =  7 if wz08_2_imp>=45 & wz08_2_imp<=47 // G
replace wz08_1b_imp =  8 if wz08_2_imp>=49 & wz08_2_imp<=53 // H
replace wz08_1b_imp =  9 if wz08_2_imp>=55 & wz08_2_imp<=56 // I
replace wz08_1b_imp = 10 if wz08_2_imp>=58 & wz08_2_imp<=63 // J
replace wz08_1b_imp = 11 if wz08_2_imp>=64 & wz08_2_imp<=66 // K
replace wz08_1b_imp = 12 if wz08_2_imp==68 // L
replace wz08_1b_imp = 13 if wz08_2_imp>=69 & wz08_2_imp<=75 // M
replace wz08_1b_imp = 14 if wz08_2_imp>=77 & wz08_2_imp<=82 // N
replace wz08_1b_imp = 15 if wz08_2_imp==84 // O
replace wz08_1b_imp = 16 if wz08_2_imp==85 // P
replace wz08_1b_imp = 17 if wz08_2_imp>=86 & wz08_2_imp<=88 // Q
replace wz08_1b_imp = 18 if wz08_2_imp>=90 & wz08_2_imp<=93 // R
replace wz08_1b_imp = 19 if wz08_2_imp>=94 & wz08_2_imp<=96 // S
replace wz08_1b_imp = 20 if wz08_2_imp>=97 & wz08_2_imp<=98 // T
replace wz08_1b_imp = 21 if wz08_2_imp==99 // U

quietly do "$prog\WZ08-1B.do"
label values wz08_1b_imp wz08_1b
format %50.0f wz08_1b_imp

*tab wz08_1b_imp, m


*WZ08-1A industries (10 large sections)

gen wz08_1a_imp = . 
replace wz08_1a_imp =  1 if wz08_2_imp>= 1 & wz08_2_imp<= 3 // A
replace wz08_1a_imp =  2 if wz08_2_imp>= 5 & wz08_2_imp<=39 // B, C, D & E
replace wz08_1a_imp =  3 if wz08_2_imp>=41 & wz08_2_imp<=43 // F
replace wz08_1a_imp =  4 if wz08_2_imp>=45 & wz08_2_imp<=56 // G, H & I
replace wz08_1a_imp =  5 if wz08_2_imp>=58 & wz08_2_imp<=63 // J
replace wz08_1a_imp =  6 if wz08_2_imp>=64 & wz08_2_imp<=66 // K
replace wz08_1a_imp =  7 if wz08_2_imp==68 // L
replace wz08_1a_imp =  8 if wz08_2_imp>=69 & wz08_2_imp<=82 // M & N
replace wz08_1a_imp =  9 if wz08_2_imp>=84 & wz08_2_imp<=88 // O, P & Q
replace wz08_1a_imp = 10 if wz08_2_imp>=90 & wz08_2_imp<=99 // R, S, T & U

quietly do "$prog\WZ08-1A.do"
label values wz08_1a_imp wz08_1a
format %50.0f wz08_1a_imp

*tab wz08_1a_imp, m



label variable wz08_5_imp "Industrial Subclass (WZ08-5)"
label variable wz08_4_imp "Industrial Class (WZ08-4)"
label variable wz08_3_imp "Industrial Group (WZ08-3)"
label variable wz08_2_imp "Industrial Division (WZ08-2)"
label variable wz08_1c_imp "Small Industrial Section (WZ08-1C)"
label variable wz08_1b_imp "Industrial Section (WZ08-1B)"
label variable wz08_1a_imp "Large Industrial Section (WZ08-1A)"

drop wz08_1c_imp wz08_1b_imp wz08_1a_imp

compress wz08_*





				
				
*** (M) OCCUPATION (KLDB 2010) ***


*KldB10-5 occupations (1,286 occupational types)


rename beh_beruf_kldb10_num kldb10_5_imp

*tab kldb10_5_imp, m
recode kldb10_5_imp (-9=.) (-8=.) (-7=.) (-6=.) (-5=.)

quietly do "$prog\KldB10-5.do"
label values kldb10_5_imp kldb10_5
format %50.0f kldb10_5_imp

*tab kldb10_5_imp, m



*KldB10-4 occupations (700 occupational sub-groups)

gen kldb10_4_imp = floor(kldb10_5_imp/10) 

quietly do "$prog\KldB10-4.do"
label values kldb10_4_imp kldb10_4
format %50.0f kldb10_4_imp

*tab kldb10_4_imp, m



*KldB10-3 occupations (144 occupational groups)

gen kldb10_3_imp = floor(kldb10_4_imp/10) 

quietly do "$prog\KldB10-3.do"
label values kldb10_3_imp kldb10_3
format %50.0f kldb10_3_imp

*tab kldb10_3_imp, m





*KldB10-2 occupations (37 occupational main groups)


gen kldb10_2_imp = floor(kldb10_3_imp/10) 

quietly do "$prog\KldB10-2.do"
label values kldb10_2_imp kldb10_2
format %50.0f kldb10_2_imp

*tab kldb10_2_imp, m



*KldB10-1C occupations (10 occupational areas)


gen kldb10_1c_imp = floor(kldb10_2_imp/10) 

quietly do "$prog\KldB10-1C.do"
label values kldb10_1c_imp kldb10_1c
format %50.0f kldb10_1c_imp

tab kldb10_1c_imp, m




*KldB10-1B occupations (14 occupational segments)


gen kldb10_1b_imp = .
replace kldb10_1b_imp = 11 if ( kldb10_2_imp==11 | kldb10_2_imp==12  ) // agriculture, forestry and horticulture
replace kldb10_1b_imp = 12 if ( kldb10_2_imp==21 | kldb10_2_imp==22 | kldb10_2_imp==23 | kldb10_2_imp==24 | kldb10_2_imp==28 | kldb10_2_imp==93 ) // manufacturing
replace kldb10_1b_imp = 13 if ( kldb10_2_imp==25 | kldb10_2_imp==26 | kldb10_2_imp==27  ) // production technology
replace kldb10_1b_imp = 14 if ( kldb10_2_imp==31 | kldb10_2_imp==32 | kldb10_2_imp==33 | kldb10_2_imp==34 ) // building and interior construction
replace kldb10_1b_imp = 21 if ( kldb10_2_imp==29 | kldb10_2_imp==63  ) // food, gastronomy and tourism
replace kldb10_1b_imp = 22 if ( kldb10_2_imp==81 | kldb10_2_imp==82  ) // health care
replace kldb10_1b_imp = 23 if ( kldb10_2_imp==83 | kldb10_2_imp==84 | kldb10_2_imp==91 | kldb10_2_imp==94 ) // social sector and cultural work 
replace kldb10_1b_imp = 31 if ( kldb10_2_imp==61 | kldb10_2_imp==62  ) // commerce and trade
replace kldb10_1b_imp = 32 if ( kldb10_2_imp==71 ) // business management and organisation
replace kldb10_1b_imp = 33 if ( kldb10_2_imp==72 | kldb10_2_imp==73 | kldb10_2_imp==92 ) // business-related services 
replace kldb10_1b_imp = 41 if ( kldb10_2_imp==41 | kldb10_2_imp==42 | kldb10_2_imp==43 ) // IT and natural sciences
replace kldb10_1b_imp = 51 if ( kldb10_2_imp==53 | kldb10_2_imp== 1 ) // safety and security
replace kldb10_1b_imp = 52 if ( kldb10_2_imp==51 | kldb10_2_imp==52 ) // traffic and logistics
replace kldb10_1b_imp = 53 if ( kldb10_2_imp==54 ) // cleaning

quietly do "$prog\KldB10-1B.do"
label values kldb10_1b_imp kldb10_1b
format %50.0f kldb10_1b_imp

*tab kldb10_1b_imp, m



*KldB10-1A occupations (5 occupational sectors)

gen kldb10_1a_imp = floor(kldb10_1b_imp/10) 

quietly do "$prog\KldB10-1A.do"
label values kldb10_1a_imp kldb10_1a
format %50.0f kldb10_1a_imp

*tab kldb10_1a_imp, m


label variable kldb10_5_imp "Occupational Type (KldB10-5)"
label variable kldb10_4_imp "Occupational Sub-Group (KldB10-4)"
label variable kldb10_3_imp "Occupational Group (KldB10-3)"
label variable kldb10_2_imp "Occupational Main Group (KldB10-2)"
label variable kldb10_1c_imp "Occupational Area (KldB10-1C)"
label variable kldb10_1b_imp "Occupational Segment (KldB10-1B)"
label variable kldb10_1a_imp "Occupational Sector (KldB10-1A)"

drop kldb10_4_imp kldb10_3_imp kldb10_2_imp kldb10_1c_imp kldb10_1b_imp kldb10_1a_imp

compress kldb10_*






*** (N) OCCUPATION (ISCO 08)


*ISCO08-4 occupations (436 occupational unit groups)


preserve // use switching codes to translate KldB10 into ISCO08

	clear 

	import excel using "$orig\BeH\Umsteigeschluessel-KldB2010-ISCO-08.xls", cellrange(A5:F1508) sheet("Umsteiger KldB 2010 auf ISCO")

	rename A kldb10_5_imp 
	drop B
	rename C isco08_4_imp
	drop D
	rename E unambiguous
	rename F priority
	
	drop if _n==1
	
	label variable kldb10_5_imp "Occupational Subclass (KldB10-5)"
	label variable isco08_4_imp "Occupational Class (ISCO08-4)"
	label variable unambiguous "Unambiguous Switch (0=No, 1=Yes)"
	label variable priority "Priority of Switch"
	
	destring kldb10_5_imp isco08_4_imp unambiguous priority, replace
	
	tab priority if unambiguous==0, m // several possibilitites if switch is ambiguous
	tab priority if unambiguous==1, m // exactly one possibility if switch is unambiguous
	
	codebook isco08_4_imp // 420 from 436 ISCO08-4 categories are captured by translation --> 16 categories lost --> reason: rare occupations that are not available in Germany
	
	
	*concept: if switch is ambiguous, use possibility with highest priority
	
	keep if priority==1 // now: unambiguous switch from KldB10 to ISCO08
	
	tab priority, m
	
	drop unambiguous priority
	
	sort kldb10_5_imp
	
	codebook isco08_4_imp // 393 from 436 ISCO08-4 categories are captured by translation --> another 27 cateogires lost --> reason: occupation lost due to using switching codes with highest priority

	
	save "$data\KldB10_ISCO08.dta", replace 

	
restore


merge m:1 kldb10_5_imp using "$data\KldB10_ISCO08.dta", keepusing(isco08_4_imp)
drop if _merge==2 // not all 393 available ISCO08-4 occupations are identified in BeH
drop _merge

quietly do "$prog\ISCO08-4.do"
label values isco08_4_imp isco08_4
format %50.0f isco08_4_imp

*tab isco08_4_imp, m




*ISCO08-3 occupations (130 occupational minor groups)

gen isco08_3_imp = floor(isco08_4_imp/10) 

quietly do "$prog\ISCO08-3.do"
label values isco08_3_imp isco08_3
format %50.0f isco08_3_imp

*tab isco08_3_imp, m





*ISCO08-2 occupations (43 occupational sub-major groups)


gen isco08_2_imp = floor(isco08_3_imp/10) 

quietly do "$prog\ISCO08-2.do"
label values isco08_2_imp isco08_2
format %50.0f isco08_2_imp

*tab isco08_2_imp, m







*ISCO08-1 occupations (10 occupational major groups)


gen isco08_1_imp = floor(isco08_2_imp/10) 

quietly do "$prog\ISCO08-1.do"
label values isco08_1_imp isco08_1
format %50.0f isco08_1_imp

*tab isco08_1_imp, m




label variable isco08_4_imp "Occupational Unit Group (ISCO08-4)"
label variable isco08_3_imp "Occupational Minor Group (ISCO08-3)"
label variable isco08_2_imp "Occupational Sub-Major Group (ISCO08-2)"
label variable isco08_1_imp "Occupational Major Group (ISCO08-1)"


drop kldb10_5_imp isco08_1_imp

*drop if isco08_4_imp==. // do not drop to not bias hirings (when spell is dropped, next year's spell is artificially recognized as hire --> especially relevant for hires in 2012 as occupation is often missing in 2011 due to structural break in occupation variable)

compress isco08_*






**** (O) REGION ***



*NUTS07-3 regions (401 districts)


rename e_krs_schl_ao_akt_num nuts07_3_work // place of work 
rename e_krs_schl_wo_akt_num nuts07_3_home // place of residence

*tab nuts07_3, m
recode nuts07_3_work (-9=.) (-8=.) (-7=.) (-6=.) (-5=.) (20000=.)
recode nuts07_3_home (-9=.) (-8=.) (-7=.) (-6=.) (-5=.) (20000=.)



quietly do "$prog\NUTS07-3.do"
label values nuts07_3_work nuts07_3
format %50.0f nuts07_3_work

quietly do "$prog\NUTS07-3.do"
label values nuts07_3_home nuts07_3
format %50.0f nuts07_3_home

*tab nuts07_3_work, m
*tab nuts07_3_home, m



*functional urban areas (96 FUAs) as well as FUAs + independent NUTS-3 regions (241 regions)

tab e_gem_schl_ao_akt_num if e_gem_schl_ao_akt_num<0, m
tab e_gem_schl_wo_akt_num if e_gem_schl_wo_akt_num<0, m


rename e_gem_schl_ao_akt_num lau17_work
rename e_gem_schl_wo_akt_num lau17_home

recode lau17_work (-9=.) (-8=.) (-7=.) (-6=.) (-5=.) (20000000=.)
recode lau17_home (-9=.) (-8=.) (-7=.) (-6=.) (-5=.) (20000000=.)

drop if lau17_work==.
drop if lau17_home==.

*drop lau17_* // not needed for assignment of FUAs in Germany is based on NUTS-3 regions, needed for commuting distance

rename nuts07_3_work nuts07_3
merge m:1 nuts07_3 using "$data\BeH_FUA.dta", keepusing(nuts07_3_adj fua nuts07_3_fua nuts07_3_fua_adj)
drop _merge
rename nuts07_3 nuts07_3_work 

rename nuts07_3_adj nuts07_3_adj_work
rename fua fua_work
rename nuts07_3_fua nuts07_3_fua_work
rename nuts07_3_fua_adj nuts07_3_fua_adj_work

*tab fua_work, m
*tab nuts07_3_fua_work, m
*tab nuts07_3_fua_adj_work, m


rename nuts07_3_home nuts07_3
merge m:1 nuts07_3 using "$data\BeH_FUA.dta", keepusing(nuts07_3_adj fua nuts07_3_fua nuts07_3_fua_adj)
drop _merge
rename nuts07_3 nuts07_3_home 

rename nuts07_3_adj nuts07_3_adj_home
rename fua fua_home
rename nuts07_3_fua nuts07_3_fua_home
rename nuts07_3_fua_adj nuts07_3_fua_adj_home

*tab nuts07_3_adj_home, m
*tab fua_home, m
*tab nuts07_3_fua_home, m
*tab nuts07_3_fua_adj_home, m



*adjusted NUTS07-3 regions (371 districts)

*tab nuts07_3_adj_work, m
*tab nuts07_3_adj_home, m



*NUTS07-2 regions (38 government regions)

gen nuts07_2_work = floor(nuts07_3_work/100) 
gen nuts07_2_home = floor(nuts07_3_home/100) 


*tab nuts07_2_work, m
*tab nuts07_2_home, m

quietly do "$prog\NUTS07-2.do"
label values nuts07_2_work nuts07_2
format %50.0f nuts07_2_work

quietly do "$prog\NUTS07-2.do"
label values nuts07_2_home nuts07_2
format %50.0f nuts07_2_home

*tab nuts07_2_work, m
*tab nuts07_2_home, m



*NUTS07-1 regions (16 federal states)

gen nuts07_1_work = floor(nuts07_2_work/10) 
gen nuts07_1_home = floor(nuts07_2_home/10) 


*tab nuts07_1_work, m
*tab nuts07_1_home, m

quietly do "$prog\NUTS07-1.do"
label values nuts07_1_work nuts07_1

quietly do "$prog\NUTS07-1.do"
label values nuts07_1_home nuts07_1

*tab nuts07_1_work, m
*tab nuts07_1_home, m



*West/East Germany  (2 territories)


tab ow_knz, m

rename ow_knz east
recode east (1=0) (2=1) (-9=.) (-8=.) (-7=.) (-6=.) (-5=.) (3=.)

tab east, m
label variable east "Workplace in East Germany (incl. East Berlin) (0=No, 1=Yes)"

label define east 0 "0 No" 1 "1 Yes" 
label values east east

*tab east, m


label variable fua_work "Functional Urban Area"
label variable nuts07_3_fua_work "FUA + District (NUTS07-3)"
label variable nuts07_3_fua_adj_work "FUA + District (NUTS07-3)"
label variable nuts07_3_work "District (NUTS07-3)"
label variable nuts07_3_adj_work "District (NUTS07-3)"
label variable nuts07_2_work "Government Region (NUTS07-2)"
label variable nuts07_1_work "Federal State (NUTS07-1)"

label variable fua_home "Functional Urban Area"
label variable nuts07_3_fua_home "FUA + District (NUTS07-3)"
label variable nuts07_3_fua_adj_home "FUA + District (NUTS07-3)"
label variable nuts07_3_home "District (NUTS07-3)"
label variable nuts07_3_adj_home "District (NUTS07-3)"
label variable nuts07_2_home "Government Region (NUTS07-2)"
label variable nuts07_1_home "Federal State (NUTS07-1)"



compress fua_* nuts07_* east

*drop if nuts07_3==. // do not drop to not bias hirings (when spell is dropped, next year's spell is artificially recognized as hire)





*** (P) INFLOW/HIRE ***


sort ieb_fall_id


merge 1:1 ieb_fall_id using "$data\inflow_week_13.dta", keepusing(hire_week_13)
replace hire_week_13 = . if _merge==1 // spells on 31 Dec 2012-2018 that do not include reference period
drop if _merge==2 // years 2010, 2011 and 2019
drop _merge

merge 1:1 ieb_fall_id using "$data\inflow_week_26.dta", keepusing(hire_week_26)
replace hire_week_26 = . if _merge==1 //  spells on 31 Dec 2012-2018 that do not include reference period
drop if _merge==2 // years 2010, 2011 and 2019
drop _merge

merge 1:1 ieb_fall_id using "$data\inflow_week_39.dta", keepusing(hire_week_39)
replace hire_week_39 = . if _merge==1 // spells on 31 Dec 2012-2018 that do not include reference period
drop if _merge==2 // years 2010, 2011 and 2019
drop _merge

merge 1:1 ieb_fall_id using "$data\inflow_week_52.dta", keepusing(hire_week_52)
replace hire_week_52 = . if _merge==1 // spells on 31 Dec 2012-2018 that do not include reference period
drop if _merge==2 // years 2010, 2011 and 2019
drop _merge



merge 1:1 ieb_fall_id using "$data\inflow_month_03.dta", keepusing(hire_month_03)
replace hire_month_03 = . if _merge==1 // spells on 31 Dec 2012-2018 that do not include reference period
drop if _merge==2 // years 2010, 2011 and 2019
drop _merge

merge 1:1 ieb_fall_id using "$data\inflow_month_06.dta", keepusing(hire_month_06)
replace hire_month_06 = . if _merge==1 // spells on 31 Dec 2012-2018 that do not include reference period
drop if _merge==2 // years 2010, 2011 and 2019
drop _merge

merge 1:1 ieb_fall_id using "$data\inflow_month_09.dta", keepusing(hire_month_09)
replace hire_month_09 = . if _merge==1 // spells on 31 Dec 2012-2018 that do not include reference period
drop if _merge==2 // years 2010, 2011 and 2019
drop _merge

merge 1:1 ieb_fall_id using "$data\inflow_month_12.dta", keepusing(hire_month_12)
replace hire_month_12 = . if _merge==1 // spells on 31 Dec 2012-2018 that do not include reference period
drop if _merge==2 // years 2010, 2011 and 2019
drop _merge



merge 1:1 ieb_fall_id using "$data\inflow_year_01.dta", keepusing(hire_year_01)
replace hire_year_01 = . if _merge==1   // spells on 31 Dec 2012-2018 that do not include reference period, here==0 as no spells are dropped in year concept
drop if _merge==2 // years 2010, 2011 and 2019
drop _merge


compress hire_*





*** (Q) FIXED-TERM VS. PERMANENT CONTRACTS FOR HIRES ***



tab beh_befristung, m

rename beh_befristung permanent

recode permanent  (-9=.) (-5=.) (1=1) (2=0)

label variable permanent "Permanent Contract (0=No, 1=Yes)"

label define permanent  0 "0 No"  1 "1 Yes"
label values permanent permanent


tab year permanent, m


label define hire_perm 0 "0 No" 1 "1 Yes"



local flow week_13 week_26 week_39 week_52 month_03 month_06 month_09 month_12 year_01

foreach x of local flow {

	gen hire_`x'_perm = .
	replace hire_`x'_perm = . if hire_`x'==. // hire not defined
	replace hire_`x'_perm = . if hire_`x'==0 // no hire
	replace hire_`x'_perm = 0 if hire_`x'==1 & permanent==0 // hire on fixed-term contract
	replace hire_`x'_perm = 1 if hire_`x'==1 & permanent==1 // hire on permanent contract
	
	label variable hire_`x'_perm "Hire with Permanent Contract (0=No, 1=Yes)"
	
	label values hire_`x'_perm hire_perm
	
}

tab hire_year_01_perm, m
tab hire_year_01_perm

drop permanent





		

*** (S) EMPLOYMENT IN YEAR BEFORE + HIRE ON PERMANENT CONTRACT IN YEAR BEFORE ***



*enrich data with information on employment and hire on permanent contract in year before

sort prs_id year

merge m:1 prs_id year using "$data\LH_Year_Before_1218.dta", keepusing(employment_last_* hire_perm_last_* hire_temp_last_*)
drop if _merge==2
drop _merge
















*** 1.6.7 WAGE IMPUTATION ***


*impute wages above the upper-earnings limit for social security contributions by means of Card et al. (2013/2015)
*source: Ganzer et al. (2020, p. 15 & 111)

*impute by yourself vs. draw imputed wages from FDZ
*in general: impute by yourself and control for variables that are later used in analysis to capture their variation in wages
*however: if reference date of 30 June is relevant and if variation of other variables is not important (e.g. when mean wages are computed), then draw imputed wages from FDZ
*another advantage of drawing imputed wages from FDZ: larger sample for imputation


*here: additional variables (zone, industry) needed in imputation --> impute by yourself


*add upper-earnings limit on social security contributions


preserve // source of yearly SSC limits: https://fdz.iab.de/en/FDZ_Overview_of_Data/working_tools.aspx

	*for West Germany

	import excel using "$orig\BeH\Bemessungsgrenzen_de_en.xls", clear cellrange(A6:J60) sheet("Old (West German) States")

	keep A D J

	rename D limit_ssc
	rename J limit_marginal

	drop if _n<=3
	drop if _n>=28 & _n<=31
	drop if _n==29

	gen year = substr(A,16,4) if _n<=27
	replace year = substr(A,14,4) if _n>=28

	drop A
	order year limit_ssc limit_marginal
	sort year

	destring year limit_ssc limit_marginal, replace

	replace limit_ssc = limit_ssc / 1.95583 if year<=2001 // until 2001: DM, from 2002: Euro
	replace limit_marginal = limit_marginal / 1.95583 if year<=2001 // until 2001: DM, from 2002: Euro

	
	replace limit_ssc = round(limit_ssc, 0.01)
	replace limit_marginal = round(limit_marginal, 0.01)

	
	
	keep if year>=1993
	gen east = 0

	save "$data\LIM_9321.dta", replace


	*for East Germany


	import excel using "$orig\BeH\Bemessungsgrenzen_de_en.xls", clear cellrange(A6:J47) sheet("New (East German) States")

	keep A D J

	rename D limit_ssc
	rename J limit_marginal

	drop if _n<=3
	drop if _n>=15 & _n<=18
	drop if _n==2
	drop if _n==10
	drop if _n==14

	gen year = substr(A,14,4) 

	drop A
	order year limit_ssc limit_marginal
	sort year

	destring year limit_ssc limit_marginal, replace

	replace limit_ssc = limit_ssc / 1.95583 if year<=2001 // until 2001: DM, from 2002: Euro
	replace limit_marginal = limit_marginal / 1.95583 if year<=2001 // until 2001: DM, from 2002: Euro

	replace limit_ssc = round(limit_ssc, 0.01)
	replace limit_marginal = round(limit_marginal, 0.01)

	keep if year>=1993
	gen east = 1

	append using "$data\LIM_9321.dta"

	sort east year
	order east year limit_ssc limit_marginal
	

	save "$data\LIM_9321.dta", replace


restore



merge m:1 year east using "$data\LIM_9321.dta"
tab year _merge, m
*drop if _merge==1 // missing information on "east"
drop if _merge==2 // years before 2012 and after 2018
drop _merge


label variable limit_ssc "Upper Earnings Limit on SSC (Per Day)" 
label variable limit_marginal "Upper Earnings Limit on Marginal Employment (Per Day)" 

drop limit_marginal



*adjust variables for censoring limit

replace limit_ssc = (0.98*limit_ssc) // threshold should be a little smaller than official threshold because there may be censored wages that might be reported below threshold for technical reasons (special payments are sometimes included etc.)
gen ln_limit_ssc = ln(limit_ssc)
label variable ln_limit_ssc "Logarithm of Upper Earnings Limit on SSC (Per Day)" 



*create dummy for censoring

gen censored=.
label variable censored "Censoring (0=No, 1=Yes)" 

*note: necessary to evaluate censoring at monthly/weekly/daily level

replace censored = 0 if beh_tag_entg<limit_ssc
replace censored = 1 if beh_tag_entg>=limit_ssc
replace censored = . if beh_tag_entg==. // no observations


*evaluate degree of censoring

tab censored if regoth==1 & parttime_imp==0, m // 9.70 percent are subject to censoring

tab year censored if regoth==1 & parttime_imp==0, m row nofreq

hist beh_tag_entg if beh_tag_entg<500 & regoth==1 & parttime_imp==0 // censoring is clearly visible (with varying upper earnings limit on SSC per year)


*prepare wage variable

clonevar wage = beh_tag_entg
replace wage = limit_ssc if censored==1
label variable wage "Non-Imputed Gross Daily Wage"

gen ln_wage = ln(wage)
label variable ln_wage "Logarithm of Non-Imputed Gross Daily Wage"
gen ln_wageC = ln_wage if censored==0 // version of the dependent variable where censored observations are reported as missing for the imputation command later on
label variable ln_wageC "Logarithm of Non-Imputed and Censored Gross Daily Wage"


*prepare missing regressors needed for imputation

*principle: all variables that are controlled for in the analyses later on should be in imputation as well!



*- age class

gen age_class_2 = .
replace age_class_2 = 1 if (age>=15 & age<25) // class 1
replace age_class_2 = 2 if (age>=25 & age<35) // class 2 
replace age_class_2 = 3 if (age>=35 & age<45) // class 3 
replace age_class_2 = 4 if (age>=45 & age<55) // class 4
replace age_class_2 = 5 if (age>=55 & age<65) // class 5 
replace age_class_2 = 6 if (age>=65)          // class 6


label define age_class_2 1 "1 15-24 Years" 2 "2 25-34 Years" 3 "3 35-44 Years" 4 "4 45-54 Years" 5 "5 55-64 Years" 6 "6 More than 65 Years" 
label values age_class_2 age_class_2
tab age_class, m // there are no missing values

gen age_class_1 = .
replace age_class_1 = 1 if age_class_2==1 // class 1
replace age_class_1 = 2 if age_class_2==2 // class 2
replace age_class_1 = 3 if age_class_2==3 // class 3
replace age_class_1 = 4 if (age_class_2==4 | age_class_2==5 | age_class_2==6) // class 4-6

label define age_class_1 1 "1 15-24 Years" 2 "2 25-34 Years" 3 "3 35-44 Years" 4 "4 More than 45 Years" 
label values age_class_1 age_class_1
tab age_class_1, m

label variable age_class_2 "Age Class (Narrow Definition)"
label variable age_class_1 "Age Class (Broad Definition)"



*- establishment size and establishment size groups

order betnr year
sort betnr year

by betnr year: gen L = _N

egen L_cens = sum(censored==1), by(betnr year)

egen L_s1 = sum(educ_imp==1), by(betnr year)

egen L_s3 = sum(educ_imp==3), by(betnr year)

egen L_ft = sum(parttime_imp==0), by(betnr year)

gen ln_L = ln(L)

gen ln_L_2 = (ln_L)^2

gen L1 = (L==1)

gen L10_ft = (L_ft>=10)

gen frac_cens=.
replace frac_cens = L_cens/(L-1) if censored==0
replace frac_cens = (L_cens-1)/(L-1) if censored==1
replace frac_cens = 0 if L==1 // according to Johannes Ludsteck 

gen frac_s1 = L_s1/L

gen frac_s3 = L_s3/L

label variable ln_L "Logarithm of Establishment Size"
label variable ln_L_2 "Squared Logarithm of Establishment Size"
label variable L1 "Establishment with One Employee (0=No, 1=Yes)"
label variable L10 "Establishment with More Than 10 Full-Time Employees (0=No, 1=Yes)"
label variable frac_cens "Fraction of Censored Observations Within Establishment (Leave-One-Out)"
label variable frac_s1 "Fraction of Low-Qualified Employees in Establishment"
label variable frac_s3 "Fraction of High-Qualified Employees in Establishment"

drop L L_cens L_s1 L_s3 L_ft


*use "$data\BeH_1218_V3.dta", clear
*append using "$data\BeH_1218_V4.dta"

save "$data\BeH_1218_V4_temp.dta", replace // "preserve" not possible for data storage reasons

*keep only ...
*-persons that do not have a regular/other full-time job --> 1) wages above upper earnings limit on SSC is unlikely, 2) daily wages of those workers would distort wage imputation as hours worked vary  -----> imputation is not necessary (use censored wages instead if there are any)
*-missing information on control variables -----> imputation is not possible (use censored wages instead) 

keep if ( regothft!=1 ) | (age==. | foreign==. | ln_L==. | ln_L_2==. | L1==. | L10_ft==. | frac_cens==. | frac_s1==. | frac_s3==. | nuts07_3_work==. | isco08_4_imp==. )  

save "$data\BeH_1218_V3.dta", replace // append later after wage imputation
			


set seed 1265674183			
		

use "$data\BeH_1218_V4_temp.dta", clear

keep if regothft==1 // keep only regular/other full-time jobs for wage imputation (reason: only daily wages for these workers are comparable due to similar hours worked)
keep if (age!=. & foreign!=. & ln_L!=. & ln_L_2!=. & L1!=. & L10_ft!=. & frac_cens!=. & frac_s1!=. & frac_s3!=. & nuts07_3_work!=. & isco08_4_imp!=. )  // keep only information without missing information on control variable


save "$data\BeH_1218_V4.dta", replace 

erase "$data\BeH_1218_V4_temp.dta"




*define global for control variables
global controls c.age i.foreign c.ln_L c.ln_L_2 i.L1 i.L10_ft c.frac_cens c.frac_s1 c.frac_s3 i.nuts07_3_work i.isco08_4_imp
*global controls c.age i.foreign i.east c.ln_L c.ln_L_2 i.L1 i.L10_ft c.frac_cens c.frac_s1 c.frac_s3





*divide dataset into imputation samples (to reduce data storage and avoid slow "if" commands)

foreach x of numlist 2012/2018 {
	
	foreach y of numlist 0/3 {
		
		foreach z of numlist 0/1 {
			
			
			use "$data\BeH_1218_V4.dta", clear 
			
			keep if year==`x' & educ_imp==`y' & female==`z'
			
			sort betnr year prs_id ieb_fall_id // ensure unique and stable sorting (reason: with different sorting of observations, imputation is not reproducible despite having set a seed in the master file)

			save "$data\BeH_1218_V4_`x'_`y'_`z'.dta", replace
			
			
		}
		
	}
	
}





*ensure that same seed is used

set seed 1265674183

log using "$log\Seed_before_Wage_Imputation_(Step_1)_$cdate.log", replace name(seed)

display runiform() // check if same seed is used: 0.4024475

log close seed




*step 1: imputation with observable characteristics


quietly {
	
	forvalues x = 2012/2018 {
		
		noisily display "Step 1: Year `x'"
		
		
		forvalues y = 0/3 {
		
			noisily display "Step 1: Year `x' and Education `y'"
			
				
			forvalues z = 0/1 {
			
				noisily display "Step 1: Year `x' and Education `y' and Gender `z'"
					
					
				use "$data\BeH_1218_V4_`x'_`y'_`z'.dta", clear
				
				gen lnw_imp=.
				
				intreg ln_wage ln_wageC $controls //  Tobit regression with right-censored data (since ln_wageC has missings)
				global sdi = e(sigma) // save variance of residual from Tobit regression
				predict xb, xb // predict xb from observables
				
				gen eta = (ln_limit_ssc - xb) / $sdi  // eta is a residual with standard normal distribution
				
				gen double lnw_i = ln_wage // take observed wage
				replace lnw_i = xb + /// take xb from regression and add normally distributed random term
					$sdi * invnormal( normal(eta) + runiform()*(1 - normal(eta) )) ///  with s.d.=sigma, that must be larger than social security contribution ceiling
					if censored==1 & eta<5 // replace only censored wage with imputation
				replace lnw_i = xb + /// special case: if eta > 8.292, normal(eta) is saved as 1 for data storage reasons with double type although actual value is 0.99999999... --> this results in invnormal(1)==. (problematic!)
					$sdi * ( - invnormal( normal(-eta) - runiform()*( normal(-eta) - 0 )) ) /// note: the data storage problem is asymmetric --> using double type variables, small values can be better approximated than large values 
					if censored==1 & eta>=5 // solution: instead of formula from above, use "normal(-eta)" instead of "normal(eta)" --> see formula from Botev/L'Ecuyer (2006, p. 2, equation (3)) "1 - normal(-eta)" if eta>5 (this approach works as long as eta<37)
				replace lnw_imp=lnw_i // gradually fill imputation variable over Tobit samples (every observation should be included in one sample!)
				
				*count if lnw_imp < ln_wage  // make sure that imputation produces no values below social security contribution ceiling
				*if r(N)>0 noisily display in red r(N) " Imputed Wage(s) below Censoring Limit in Year `x' and Education `y' and Gender `z' "
				drop xb eta lnw_i
				
				save "$data\BeH_1218_V5_`x'_`y'_`z'.dta", replace

				
			}	
		}
	}
}
	

*create overall dataset including all imputation samples	
	
clear

foreach x of numlist 2012/2018 {
	
	foreach y of numlist 0/3 {
		
		foreach z of numlist 0/1 {	
	
			append using "$data\BeH_1218_V5_`x'_`y'_`z'.dta"
			
			erase "$data\BeH_1218_V5_`x'_`y'_`z'.dta"
						
		}
	}
}	



	
*intermediate step: obtain LEAVE-ONE-OUT means (loom) of imputed wages for establishments

replace lnw_imp = ln_wage if lnw_imp==. // use original value if step 1 was unsuccessful (due to missing control variables)

bysort year betnr: gen N = _N // number of spells per establishment and year (for which step 1 was successful)
by year betnr: egen wsum = total(lnw_imp) // wage bill over all spells per establishment and year

gen lnw_loom = .
replace lnw_loom = ( wsum - lnw_imp )/( N - 1 ) // leave-one-out mean , i.e. subtract wage of respective worker (leave-one-out) and divide by number of other spells
drop N wsum

gen lnw_loom1 = missing(lnw_loom) // dummy=1 if worker is establishment's only employee; in this case: above formula has yielded 0/0=.
by year: egen smean = mean(lnw_imp)
replace lnw_loom = smean if missing(lnw_loom) // set mean to sample mean if worker is firm's only employee
drop smean


save "$data\BeH_1218_V5.dta", replace 
 




*divide dataset into imputation samples (to reduce data storage and avoid slow "if" commands)

foreach x of numlist 2012/2018 {
	
	foreach y of numlist 0/3 {
		
		foreach z of numlist 0/1 {
			
			
			use "$data\BeH_1218_V5.dta", clear 
			
			keep if year==`x' & educ_imp==`y' & female==`z'
			
			sort betnr year prs_id ieb_fall_id // ensure unique and stable sorting (reason: with different sorting of observations, imputation is not reproducible despite having set a seed in the master file)

			save "$data\BeH_1218_V5_`x'_`y'_`z'.dta", replace
			
			
		}
		
	}
	
}





*ensure that same seed is used

log using "$log\Seed_before_Wage_Imputation_(Step_2)_$cdate.log", replace name(seed)

display runiform() // check if same seed is used: 0.18985091

log close seed

	
	
	
*step 2: imputation with observable characteristics	and leave-one-out mean


	


quietly {
	
	forvalues x = 2012/2018 {
		
		noisily display "Step 2: Year `x'"
		
		forvalues y = 0/3 {
			
			noisily display "Step 2: Year `x' and Education `y'"
			
			forvalues z = 0/1 {
			
			noisily display "Step 2: Year `x' and Education `y' and Gender `z'"

			
				use "$data\BeH_1218_V5_`x'_`y'_`z'.dta", clear

				gen lnw_imp2=.
				gen xb0=.
				gen eta0=.

				intreg ln_wage ln_wageC $controls lnw_loom lnw_loom1 // Tobit regression with right-censored data (since ln_wageC has missings)
				global sdi = e(sigma) // save variance of residual from Tobit Regression
				predict xb, xb  // predict xb from observables
				
				gen eta = (ln_limit_ssc - xb) / $sdi // eta is a residual with standard normal distribution
				
				gen double lnw_i = ln_wage  // take observed wage
				replace lnw_i = xb + /// take xb from regression and add normally distributed random term
					$sdi * invnormal( normal(eta) + runiform()*(1 - normal(eta) )) ///  with s.d.=sigma, that must be larger than social security contribution ceiling
					if censored==1 & eta<5 // replace only censored wage with imputation
				replace lnw_i = xb + /// special case: if eta > 8.292, normal(eta) is saved as 1 for data storage reasons with double type although actual value is 0.99999999... --> this results in invnormal(1)==. (problematic!)
					$sdi * ( - invnormal( normal(-eta) - runiform()*( normal(-eta) - 0 )) ) /// note: the data storage problem is asymmetric --> using double type variables, small values can be better approximated than large values 
					if censored==1 & eta>=5 // solution: instead of formula from above, use "normal(-eta)" instead of "normal(eta)" --> see formula from Botev/L'Ecuyer (2006, p. 2, equation (3)) "1 - normal(-eta)" if eta>5 (this approach works as long as eta<37)
				replace lnw_imp2=lnw_i // gradually fill imputation variable over Tobit samples (every observation should be included in one sample!)
				replace xb0 = xb
				replace eta0 = eta
				
				*count if lnw_imp2 < ln_wage// make sure that imputation produces no values below social security contribution ceiling
				*if r(N)>0 noisily display in red r(N) " Imputed Wage(s) below Censoring Limit in Year `x' and Education `y' and Gender `z' "
				drop xb eta lnw_i
				
				
				save "$data\BeH_1218_V6_`x'_`y'_`z'.dta", replace

			}
		}
		
	}
}



*create overall dataset including all imputation samples	
	
clear

foreach x of numlist 2012/2018 {
	
	foreach y of numlist 0/3 {
		
		foreach z of numlist 0/1 {	
	
			append using "$data\BeH_1218_V6_`x'_`y'_`z'.dta"
				
			erase "$data\BeH_1218_V6_`x'_`y'_`z'.dta"	
			
		}
	}
}	


drop wage ln_wage ln_wageC 


rename beh_tag_entg wage // without imputation
gen wage_inter = exp(lnw_imp) // with imputation: only step 1
gen wage_imp = exp(lnw_imp2) // with imputation: both step 1 and step 2


label variable wage "Gross Daily Wage"
label variable wage_inter "Imputed Gross Daily Wage (Only Step 1)"
label variable wage_imp "Imputed Gross Daily Wage"


sort betnr year prs_id ieb_fall_id
  
save "$data\BeH_1218_V6.dta", replace


 
use "$data\BeH_1218_V6.dta", replace 




format wage %9.0g // only some minor deviations due to format


count if abs(wage - wage_imp)>0.01 & censored==0 & wage_imp!=. // 0 



*** imputation failed

count if wage_imp==. // 0 observations without imputation = 0 (stage 1 failed) + 0 (stage 2 failed)
count if wage_imp==. & censored==1 // 0 censored observations without imputation = 0 (stage 1 failed) + 0 (stage 2 failed) --> problematic


*** reason 1: first stage failed due to missing information on control variables

*irrelevant as observations with missing were excluded from imputation samples

*count if wage_imp==. & (age==. | foreign==. | ln_L==. | ln_L_2==. | L1==. | L10_ft==. | frac_cens==. | frac_s1==. | frac_s3==. | lnw_loom==. | lnw_loom1==. | nuts07_3_work==. | isco08_4_imp==.  ) // 0
*count if wage_imp==. & (age==. | foreign==. | ln_L==. | ln_L_2==. | L1==. | L10_ft==. | frac_cens==. | frac_s1==. | frac_s3==. | lnw_loom==. | lnw_loom1==. | nuts07_3_work==. | isco08_4_imp==.  ) & censored==1 // problematic for 0 observations due to censoring

*gen stage1 = 0
*replace stage1 = 1 if wage_imp==. & (age==. | foreign==. | ln_L==. | ln_L_2==. | L1==. | L10_ft==. | frac_cens==. | frac_s1==. | frac_s3==. | lnw_loom==. | lnw_loom1==. | nuts07_3_work==. | isco08_4_imp==.  ) 

*replace wage_imp = wage if stage1==1 // use censored wage
*drop stage1



*** reason 2: second stage failed due to data storage problem for large eta



*br if wage_imp==. & (educ_imp!=. & female!=. & age!=. & foreign!=. & east!=. & ln_L!=. & ln_L_2!=. & L1!=. & L10_ft!=. & frac_cens!=. & frac_s1!=. & frac_s3!=. & lnw_loom!=. & lnw_loom1!=. & zone!=. & w08_2_gen!=. ) & censored==1 

count if wage_imp==. & (age!=. & foreign!=. & ln_L!=. & ln_L_2!=. & L1!=. & L10_ft!=. & frac_cens!=. & frac_s1!=. & frac_s3!=. & lnw_loom!=. & lnw_loom1!=. & nuts07_3_work!=. & isco08_4_imp!=.  ) // 0
count if wage_imp==. & (age!=. & foreign!=. & ln_L!=. & ln_L_2!=. & L1!=. & L10_ft!=. & frac_cens!=. & frac_s1!=. & frac_s3!=. & lnw_loom!=. & lnw_loom1!=. & nuts07_3_work!=. & isco08_4_imp!=.  ) & censored==1 // problematic for 0 observations due to censoring



gen stage2 = 0
replace stage2 = 1 if wage_imp==. & ( age!=. & foreign!=. & east!=. & ln_L!=. & ln_L_2!=. & L1!=. & L10_ft!=. & frac_cens!=. & frac_s1!=. & frac_s3!=. & lnw_loom!=. & lnw_loom1!=. & nuts07_3_work!=. & isco08_4_imp!=. ) // for observations where first step does not work (reason: large eta not compatible with normal(.))

gen double norm = normal(eta0)
format norm %20.0g
*gen uniform = uniform()
*format uniform %20.0g
*gen double invnormal_arg = normal(eta0) + ( uniform * (1-normal(eta0)))
*format invnormal_arg %20.0g
*gen double invnormal = invnormal( normal(eta0) + ( uniform * (1-normal(eta0))))
*format invnormal %20.0g

*br if wage_imp==. & (educ_imp!=. & female !=. & age!=. & foreign!=. & east!=. & ln_L!=. & ln_L_2!=. & L1!=. & L10_ft!=. & frac_cens!=. & frac_s1!=. & frac_s3!=. & lnw_loom!=. & lnw_loom1!=. & nuts07_3_work!=. & isco08_4_imp!=. ) & censored==1 





 
*** reason 2a: eta>8.292 & threshold irrelevant

display %20.0g normal(8.292) // .999999999999999889
display %20.0g normal(8.293) // 1

display %20.0g invnormal(0.999999999999999889 + 0) // 8.20953615160138561
display %20.0g invnormal(1 + 0) // .

gen stage2a = 0
replace stage2a = 1 if stage2==1 & norm==1 // 0/0 problems explained


*** reason 2b: 5 ~< eta < 8.292 with uniform>threshold=f(eta) --> the higher normal(eta), the lower the threshold

display %20.0g ( normal(5.5) + ( 0.999999999 * ( 1 - normal (5.5)) )) //  1

display %20.0g ( normal(6.0) + ( 0.9999999 * ( 1 - normal (6.0)) )) //  1

display %20.0g ( normal(6.5) + ( 0.999999 * ( 1 - normal (6.5)) )) //  1

display %20.0g ( normal(7.0) + ( 0.99999 * ( 1 - normal (7.0)) )) //  1

display %20.0g ( normal(7.7) + ( 0.999 * ( 1 - normal (7.7)) )) //  1

display %20.0g ( normal(7.8) + ( 0.95 * ( 1 - normal (7.8)) )) // 0.999999999999999889
display %20.0g ( normal(7.8) + ( 0.99 * ( 1 - normal (7.8)) )) // 1

display %20.0g ( normal(8.0) + ( 0.90 * ( 1 - normal (8.0)) )) // 0.999999999999999889
display %20.0g ( normal(8.0) + ( 0.95 * ( 1 - normal (8.0)) )) // 1

display %20.0g ( normal(8.2) + ( 0.40 * ( 1 - normal (8.2)) )) // 0.999999999999999889
display %20.0g ( normal(8.2) + ( 0.50 * ( 1 - normal (8.2)) )) // 1


display %20.0g invnormal(0.999999999999999889) // 8.20953615160138561
display %20.0g invnormal(1) // .

gen stage2b = 0
replace stage2b = 1 if stage2==1 & norm>0.999 & stage2a!=1 // 0/0 problems explained



 
replace wage_imp = wage_inter if stage2==1 // use imputation from first stage

drop xb0 eta0 stage2 norm stage2a stage2b 


count if wage_imp==. // 0



/*
*show histograms for imputation (West Germany, 2015)

twoway__histogram_gen wage if year==2015 & east==0, freq start(0) width(5) gen(bar_y1 bar_x1)
twoway__histogram_gen wage_imp if year==2015 & east==0, freq start(0) width(5) gen(bar_y2 bar_x2)

twoway ///
	(bar bar_y1 bar_x1 if inrange(bar_x1,0,300), barwidth(5) fcolor(sand) lcolor(black)) ///
	(bar bar_y2 bar_x2 if inrange(bar_x2,0,300), barwidth(5) fcolor(none) lcolor(cyan)) ///
	, xlabel(0(50)300) legend(rows(1) order(1 "Without Imputation" 2 "With Imputation" )) title("Wage Distribution (West Germany, 2015)") xtitle("Wage")
  
graph export "$fig\Imputation_(West_Germany,_2015).png", replace


 

twoway__histogram_gen wage_imp if year==2015 & east==0 & !missing(wage_imp), freq start(0) width(5) gen(bar_y3 bar_x3)
twoway__histogram_gen wage_imp if year==2015 & east==0 & !missing(wage_imp) & censored==1, freq start(0) width(5) gen(bar_y4 bar_x4)

twoway ///
	(bar bar_y3 bar_x3 if inrange(bar_x3,0,300), barwidth(5) fcolor(sand) lcolor(black) yscale(range(0 0.025))) ///
	(bar bar_y4 bar_x4 if inrange(bar_x4,0,300), barwidth(5) fcolor(cyan) lcolor(black) yscale(range(0 0.025))) ///
	, xlabel(0(50)300) legend(rows(1) order(1 "Not Imputed" 2 "Imputed" )) title("Wage Distribution (West Germany, 2015)") xtitle("Wage")
  
graph export "$fig\Censored_vs_Uncensored_Wages_(West_Germany,_2015).png", replace

drop bar_x1 bar_y1 bar_x2 bar_y2 bar_x3 bar_y3 bar_x4 bar_y4
*/

*re-load part-timers and workers with non-standard contract 

append using "$data\BeH_1218_V3.dta"   

replace wage_imp = wage if ( regothft!=1 )  // raw wages for observations that do not represent regular/other full-time workers
replace wage_imp = wage if ( age==. | foreign==. | ln_L==. | ln_L_2==. | L1==. | L10_ft==. | frac_cens==. | frac_s1==. | frac_s3==. | nuts07_3_work==. | isco08_4_imp==. )  // raw wages for observations that cannot be imputed due to missing values

drop wage wage_inter






*rename variables

rename wage_imp wage_day_imp
*rename beh_entgelt wage_spell


label variable wage_day_imp "Daily Gross Wage"
*label variable wage_spell "Gross Wage during Spell"


drop beh_tag_entg ln_wage ln_wageC ln_limit_ssc censored geb_dat age_class_1 age_class_2 ln_L ln_L_2 L1 L10_ft frac_cens frac_s1 frac_s3 lnw_imp lnw_loom lnw_loom1 lnw_imp2


sort prs_id year betnr ieb_fall_id


save "$data\BeH_1218_V7.dta", replace 
*use "$data\BeH_1218_V7.dta", clear 







	  



*** 1.6.8 RELEVANT EMPLOYMENT SPELLS ***




*when using hourly gross wages (after 1999):
*not relevant here

*when using hourly gross wages (before 1999):
*restrict to workers (FT & PT) in regular/other employment, apprentices and in partial retirement
*not relevant here

*when using daily gross wages: 
*further restrict to full-time workers in regular/other employment
*not relevant here

tab type, m
tab type parttime_imp, m

*keep if (type==1 | type==2 | type==3 | type==4 | type==5 | type==6 | type==7 | type==. )

*keep if regoth==1
*keep if regothft==1

*note: marginal employment is only recorded since 04/1999



*drop if duration<30 // delete spells shorter than 30 days

*drop if parttime_imp==.

drop if type == .




*drop if wz08_2_imp==.


tab wz08_2_imp, m
keep if (wz08_2_imp>=5 & wz08_2_imp<=82) | wz08_2_imp==90 | (wz08_2_imp>=92 & wz08_2_imp<=96)  // keep only non-agricultural business sector


tab wz08_2_imp, m


*drop if isco08_2_imp==.
*drop if isco08_3_imp==.
gen isco08_4_imp_miss = (isco08_4_imp==.)
tab year isco08_4_imp_miss, m 
drop isco08_4_imp_miss

drop if isco08_4_imp==.


drop if nuts07_3_work==.
*drop if fua_work==. // do not delete --> many municipalities without FUA
*drop if nuts07_3_fua_work==.  

drop if nuts07_3_home==.
*drop if fua_home==. // do not delete --> many municipalities without FUA
*drop if nuts07_3_fua_home==.  


keep prs_id year betnr ieb_fall_id wz08_* isco08_* nuts07_3_* fua_* nuts07_3_fua_* nuts07_3_fua_adj_* east date duration type parttime_imp all reg mar app ret oth regoth regft regothft regothpt female age educ_imp educ2_imp foreign employment_last_* hire_perm_last_* hire_temp_last_* hire_week_13 hire_week_26 hire_week_39 hire_week_52 hire_month_03 hire_month_06 hire_month_09 hire_month_12 hire_year_01 wage_day_imp hire_*_perm 


sort prs_id year betnr ieb_fall_id
order prs_id year betnr ieb_fall_id wz08_* isco08_* nuts07_3_* fua_* nuts07_3_fua_* nuts07_3_fua_adj_* east date duration type parttime_imp all reg mar app ret oth regoth regft regothft regothpt female age educ_imp educ2_imp foreign employment_last_* hire_perm_last_* hire_temp_last_* hire_week_13 hire_week_26 hire_week_39 hire_week_52 hire_month_03 hire_month_06 hire_month_09 hire_month_12 hire_year_01 wage_day_imp hire_*_perm 

compress
 
save "$data\BeH_1218.dta", replace 








*** 1.7 OCCUPATIONAL SHARES IN YEARLY HIRES ***




foreach x of numlist 2/4 {
    
	display "ISCO08-`x'"
	
	quietly {
    
		use "$data\BeH_1218.dta", clear
		
		keep if hire_year_01==1 // only hires
		
		gen n=1
		
		collapse (sum) n, by(isco08_`x'_imp year)
		
		egen N = total(n), by (year)
		
		order isco08_* year
		sort isco08_* year
		
		gen share_isco08_`x'_ot = n / N
		drop n N
		
		label variable share_isco08_`x'_ot "Occupational Share in Yearly Hires"
		
		save "$data\Share_ISCO08_`x'.dta", replace
		
	}
	
	
}









*** 1.8 IAB ESTABLISHMENT PANEL: COLLECTIVE BARGAINING ***



*** 1.8.1 CREATION OF PANEL DATASET FROM CROSS-SECTIONS ***


*already executed via code from Umkehrer (2017): "BP_panelgen_9320_v1.do" 
*panel data set saved as "BP_panelgen_9320_v1.dta"
*source: https://fdz.iab.de/187/section.aspx/Publikation/k180109301


use "$orig\IAB_Establishment_Panel\BP_panelgen_9320_v1.dta", clear


merge 1:1 idnum jahr using "$orig\IAB_Establishment_Panel\iabbp_9320_v1_bhp_7520_m06_wgen_w08_v1.dta", keepusing(w08_3_gen)

tab jahr _merge, m

keep if _merge==3
drop _merge




rename jahr year
tab year, m


label variable idnum "Establishment"
label variable year "Year"




*19 sectors

gen wz08_2_imp = floor(w08_3_gen/10) 


quietly do "$prog\WZ08-2.do"
label values wz08_2_imp wz08_2
format %50.0f wz08_2_imp

tab wz08_2_imp, m


label variable wz08_2_imp "Industrial Division (WZ08-2)"



gen sec = .

replace sec = 1 if inrange(wz08_2_imp, 1,3)
replace sec = 2 if inrange(wz08_2_imp, 5,9) | inrange(wz08_2_imp, 35,39)
replace sec = 3 if inrange(wz08_2_imp, 10,12)
replace sec = 4 if inrange(wz08_2_imp, 13,18)
replace sec = 5 if inrange(wz08_2_imp, 19,24)
replace sec = 6 if inrange(wz08_2_imp, 25,33)
replace sec = 7 if inrange(wz08_2_imp, 41,43)
replace sec = 8 if inrange(wz08_2_imp, 45,46)
replace sec = 9 if wz08_2_imp==47
replace sec = 10 if inrange(wz08_2_imp, 49,53)
replace sec = 11 if inrange(wz08_2_imp, 58,63)
replace sec = 12 if inrange(wz08_2_imp, 55,56)
replace sec = 13 if inrange(wz08_2_imp, 64,66)
replace sec = 14 if inrange(wz08_2_imp, 68,82)
replace sec = 15 if wz08_2_imp==85
replace sec = 16 if inrange(wz08_2_imp, 86,88)
replace sec = 17 if inrange(wz08_2_imp, 90,93) | inrange(wz08_2_imp, 95,96)
replace sec = 18 if wz08_2_imp==94
replace sec = 19 if wz08_2_imp==84


drop if inlist(wz08_2_imp,97,99)
drop if wz08_2_imp==.


count if sec==.



label define sec ///
	1  "1 Agriculture, Forestry and Fishing" ///
	2  "2 Mining and Quarrying; Electricity, Gas, and Water Supply; Sewerage and Waste Mangement" ///
	3  "3 Food Products, Beverages and Tobacco" ///
	4  "4 Consumer Products" ///
	5  "5 Industrial Goods" ///
	6  "6 Capital and Consumer Goods" ///
	7  "7 Construction" ///
	8  "8 Wholesale, Sale and Repair of Motor Vehicles" ///
	9  "9 Retail" ///
	10 "10 Transport and Warehousing" ///
	11 "11 Information and Communication" ///
	12 "12 Hotels and Restaurants" ///
	13 "13 Financial and Insurance Services" ///
	14 "14 Economic, Scientific and Freelance Services" ///
	15 "15 Education" ///
	16 "16 Health and Social Services" ///
	17 "17 Other Services" ///
	18 "18 Representation of Interests" ///
	19 "19 Public Administration, Defence, Social Security" 

label values sec sec	


label variable sec "Sector (19 Categories)"


tab sec, m




*cross-sectional weight (at individual level)


gen ecross_c_L = ecross_c * decnud_c

label variable ecross_c_L "Cross-Sectional Weights (at Individual Level)"




*keep necessary information



keep idnum year ecross_c_L sec wagree_d orstd_b wcounc_b 

order idnum year ecross_c_L sec wagree_d orstd_b wcounc_b
sort idnum year

keep if year>=2012 & year<=2018

tab year, m


tab sec, m




*** 1.8.2 COLLECTIVE BARGAINING AGREEMENTS ***



codebook wagree_d
recode wagree_d (-9=.)

codebook orstd_b
recode orstd_b (-9=.)


tab wagree_d, m
tab year wagree_d, m 

tab orstd_b, m
tab year orstd_b, m 



tab wagree_d orstd_b, m // orstd_b is always missing when there is commitment to CBA
replace orstd_b = 1 if wagree_d==1 | wagree_d==2 | wagree_d==4
tab wagree_d orstd_b, m // now: orientation only relevant for establishments not binded to CBA



gen wagree=.
replace wagree = . if wagree_d==. & orstd_b==. // unknown
replace wagree = 0 if wagree_d==3 & orstd_b==2 // no CBA, no orientation
replace wagree = 0 if wagree_d==3 & orstd_b==. // no CBA, unknown orientation
replace wagree = 0 if wagree_d==. & orstd_b==2 // unknown CBA, no orientation
replace wagree = 1 if wagree_d==3 & orstd_b==1 // no CBA, but orientation
replace wagree = 1 if wagree_d==. & orstd_b==1 // unknown CBA, but orientation
replace wagree = 2 if wagree_d==1 // industry-level CBA 
replace wagree = 3 if wagree_d==2 // firm-level CBA
replace wagree = 4 if wagree_d==4 // either industry- or firm-level CBA

label define wagree 0 "0 Neither CBA nor Orientation" 1 "1 Orientation at CBA"  2 "2 Industry-Level CBA"  3 "3 Firm-Level CBA"  4 "4 Industry- or Firm-Level CBA"
label values wagree wagree


label variable wagree "Collective Bargaining Agreement"

drop wagree_d orstd_b


tab wagree, m

drop if wagree==.

tab wagree, m
tab year wagree, m nofreq row



gen wagree_1 = ( wagree==2 | wagree==3 )
label variable wagree_1 "Collective Bargaining Agreement (0=No, 1=Yes)"
label define wagree_1 0 "0 No" 1 "1 Yes" 
label values wagree_1 wagree_1
tab wagree_1, m
tab year wagree_1, m


gen wagree_2 = ( wagree==2 )
label variable wagree_2 "Collective Bargaining Agreement at Industry Level (0=No, 1=Yes)"
label define wagree_2 0 "0 No" 1 "1 Yes" 
label values wagree_2 wagree_2
tab wagree_2, m
tab year wagree_2, m


gen wagree_3 = ( wagree==1 | wagree==2 | wagree==3 )
label variable wagree_3 "Collective Bargaining Agreement or Orientiation (0=No, 1=Yes)"
label define wagree_3 0 "0 No" 1 "1 Yes" 
label values wagree_3 wagree_3
tab wagree_3, m
tab year wagree_3, m


gen wagree_4 = ( wagree==1 | wagree==2 )
label variable wagree_4 "Collective Bargaining Agreement at Industry Level or Orientation (0=No, 1=Yes)"
label define wagree_4 0 "0 No" 1 "1 Yes" 
label values wagree_4 wagree_4
tab wagree_4, m
tab year wagree_4, m



gen wagree_5 = ( wagree==3 )
label variable wagree_5 "Collective Bargaining Agreement at Firm Level (0=No, 1=Yes)"
label define wagree_5 0 "0 No" 1 "1 Yes" 
label values wagree_5 wagree_5
tab wagree_5, m
tab year wagree_5, m


gen wagree_6 = ( wagree==1 | wagree==3 )
label variable wagree_6 "Collective Bargaining Agreement at Firm Level or Orientation (0=No, 1=Yes)"
label define wagree_6 0 "0 No" 1 "1 Yes" 
label values wagree_6 wagree_6
tab wagree_6, m
tab year wagree_6, m





*** 1.8.3 WORK COUNCIL ***



codebook wcounc_b
recode wcounc_b (-9=.) (2=0) 

label values wcounc_b .

rename wcounc_b wcounc

label define wcounc 0 "0 No" 1 "1 Yes"
label values wcounc wcounc

label variable wcounc "Work Council (0=No, 1=Yes)"

tab wcounc, m
tab year wcounc, m nofreq row



*** 1.8.4 TABULATION AT ECONOMY LEVEL ***



*Table 1.2

tab wagree [iweight=ecross_c_L] if year==2015, m // firm-level CBA = 10%, sector-level CBA = 51%, no CBA = 39%




*** 1.8.5 COLLAPSE AT SECTORAL LEVEL ***



collapse (mean) wagree_* wcounc [pweight=ecross_c_L], by(sec year)



collapse (mean) wagree_* wcounc, by (sec)



foreach x of numlist 1/6 {

	gen CBA_`x' = .

	_pctile wagree_`x' , nquantiles(2) // save median
	return list
	
	global CBA_median = r(r1)
	di $CBA_median

	replace CBA_`x' = ( wagree_`x' > $CBA_median )


}





label variable wagree_1 "Share in CBA"
label variable wagree_2 "Share in CBA at Industry Level"
label variable wagree_3 "Share in CBA or Orientiation"
label variable wagree_4 "Share in CBA at Industry Level or Orientation"
label variable wagree_5 "Share in CBA at Firm Level"
label variable wagree_6 "Share in CBA at Firm Level or Orientation"


label variable CBA_1 "Share in CBA Above Median (0=No, 1=Yes)"
label variable CBA_2 "Share in CBA at Industry Level Above Median (0=No, 1=Yes)"
label variable CBA_3 "Share in CBA or Orientiation Above Median (0=No, 1=Yes)"
label variable CBA_4 "Share in CBA at Industry Level or Orientation Above Median (0=No, 1=Yes)"
label variable CBA_5 "Share in CBA at Firm Level Above Median (0=No, 1=Yes)"
label variable CBA_6 "Share in CBA at Firm Level or Orientation Above Median (0=No, 1=Yes)"

label variable wcounc "Share in Work Council "

order sec wagree_* CBA_* wcounc



describe

list

correlate wagree_1 wagree_2 wagree_3 wagree_4 wagree_5 wagree_6 wcounc




export excel using "$data/CBA_1218.xlsx", replace firstrow(variables) keepcellfmt


save "$data\CBA_1218.dta", replace 



















*** 1.9 LINKAGE ***



use "$data\BeH_1218.dta", clear 

tab year, m // about 27 mio workers per year 


*enrich with HHI at workplace


merge m:1 isco08_4_imp nuts07_3_fua_adj_work year using "$data\LMC_4_4_1218.dta", keepusing(HHI_week_13_4_4 HHI_week_26_4_4 HHI_week_39_4_4 HHI_week_52_4_4 HHI_month_03_4_4 HHI_month_06_4_4 HHI_month_09_4_4 HHI_month_12_4_4 HHI_year_01_4_4 ln_HHI_loom_year_01_4_4 ln_INS_loom_week_13_4_4 ln_INS_loom_week_26_4_4 ln_INS_loom_week_39_4_4 ln_INS_loom_week_52_4_4 ln_INS_loom_month_03_4_4 ln_INS_loom_month_06_4_4 ln_INS_loom_month_09_4_4 ln_INS_loom_month_12_4_4 ln_INS_loom_year_01_4_4 H_year_01_4_4 L_year_01_4_4)
drop if _merge==2 // certain industries with no match in individual data (reason: labor markets without employment at all (H=L=0 --> HHI=.) or with employment during the year but no employment on 31 December (L>0, H>=0 --> HHI==. or HHI!=.))drop _merge
drop _merge

merge m:1 isco08_4_imp fua_work year using "$data\LMC_4_1_1218.dta", keepusing(HHI_year_01_4_1 ln_INS_loom_year_01_4_1)
drop if _merge==2 // certain industries with no match in individual data (reason: labor markets without employment at all (H=L=0 --> HHI=.) or with employment during the year but no employment on 31 December (L>0, H>=0 --> HHI==. or HHI!=.))
drop _merge


merge m:1 isco08_4_imp nuts07_3_fua_work year using "$data\LMC_4_2_1218.dta", keepusing(HHI_year_01_4_2 ln_INS_loom_year_01_4_2)
drop if _merge==2 // certain industries with no match in individual data (reason: labor markets without employment at all (H=L=0 --> HHI=.) or with employment during the year but no employment on 31 December (L>0, H>=0 --> HHI==. or HHI!=.))drop _merge
drop _merge

merge m:1 isco08_4_imp nuts07_3_work year using "$data\LMC_4_3_1218.dta", keepusing(HHI_year_01_4_3 ln_INS_loom_year_01_4_3)
drop if _merge==2 // certain industries with no match in individual data (reason: labor markets without employment at all (H=L=0 --> HHI=.) or with employment during the year but no employment on 31 December (L>0, H>=0 --> HHI==. or HHI!=.))drop _merge
drop _merge

merge m:1 isco08_4_imp nuts07_3_adj_work year using "$data\LMC_4_5_1218.dta", keepusing(HHI_year_01_4_5 ln_INS_loom_year_01_4_5)
drop if _merge==2 // certain industries with no match in individual data (reason: labor markets without employment at all (H=L=0 --> HHI=.) or with employment during the year but no employment on 31 December (L>0, H>=0 --> HHI==. or HHI!=.))drop _merge
drop _merge



merge m:1 isco08_3_imp nuts07_3_fua_adj_work year using "$data\LMC_3_4_1218.dta", keepusing(HHI_year_01_3_4 ln_INS_loom_year_01_3_4)
drop if _merge==2 // certain industries with no match in individual data (reason: labor markets without employment at all (H=L=0 --> HHI=.) or with employment during the year but no employment on 31 December (L>0, H>=0 --> HHI==. or HHI!=.))drop _merge
drop _merge

merge m:1 isco08_2_imp nuts07_3_fua_adj_work year using "$data\LMC_2_4_1218.dta", keepusing(HHI_year_01_2_4 ln_INS_loom_year_01_2_4)
drop if _merge==2 // certain industries with no match in individual data (reason: labor markets without employment at all (H=L=0 --> HHI=.) or with employment during the year but no employment on 31 December (L>0, H>=0 --> HHI==. or HHI!=.))drop _merge
drop _merge


merge m:1 isco08_4_imp nuts07_3_fua_adj_work year using "$data\LMC_L_4_4_1218.dta", keepusing(HHI_L_week_13_4_4 HHI_L_week_26_4_4 HHI_L_week_39_4_4 HHI_L_week_52_4_4 HHI_L_month_03_4_4 HHI_L_month_06_4_4 HHI_L_month_09_4_4 HHI_L_month_12_4_4 HHI_L_year_01_4_4 ln_HHI_L_loom_year_01_4_4 ln_INS_L_loom_week_13_4_4 ln_INS_L_loom_week_26_4_4 ln_INS_L_loom_week_39_4_4 ln_INS_L_loom_week_52_4_4 ln_INS_L_loom_month_03_4_4 ln_INS_L_loom_month_06_4_4 ln_INS_L_loom_month_09_4_4 ln_INS_L_loom_month_12_4_4 ln_INS_L_loom_year_01_4_4)
drop if _merge==2 // certain industries with no match in individual data (reason: labor markets without employment at all (H=L=0 --> HHI=.) or with employment during the year but no employment on 31 December (L>0, H>=0 --> HHI==. or HHI!=.))drop _merge
drop _merge


merge m:1 isco08_4_imp nuts07_3_fua_adj_work year using "$data\LMC_Arn_4_4_1218.dta", keepusing(HHI_L_Arn_year_01_4_4 INS_L_Arn_year_01_4_4 ln_INS_L_Arn_loom_year_01_4_4 ln_HHI_L_Arn_loom_year_01_4_4 L_Arn_year_01_4_4)
drop if _merge==2 // certain industries with no match in individual data (reason: labor markets without employment at all (H=L=0 --> HHI=.) or with employment during the year but no employment on 31 December (L>0, H>=0 --> HHI==. or HHI!=.))drop _merge
drop _merge



*enrich with occupational shares


merge m:1 isco08_2_imp year using "$data\Share_ISCO08_2.dta", keepusing(share_isco08_2)
replace share_isco08_2=0 if _merge==1 // occupations with zero hirings in a certain year
drop if _merge==2
drop _merge

merge m:1 isco08_3_imp year using "$data\Share_ISCO08_3.dta", keepusing(share_isco08_3)
replace share_isco08_3=0 if _merge==1 // occupations with zero hirings in a certain year
drop if _merge==2
drop _merge

merge m:1 isco08_4_imp year using "$data\Share_ISCO08_4.dta", keepusing(share_isco08_4)
replace share_isco08_4=0 if _merge==1 // occupations with zero hirings in a certain year
drop if _merge==2
drop _merge






*enrich with information on collective bargaining from IAB Establishment Panel



gen sec = .

replace sec = 1 if inrange(wz08_2_imp, 1,3)
replace sec = 2 if inrange(wz08_2_imp, 5,9) | inrange(wz08_2_imp, 35,39)
replace sec = 3 if inrange(wz08_2_imp, 10,12)
replace sec = 4 if inrange(wz08_2_imp, 13,18)
replace sec = 5 if inrange(wz08_2_imp, 19,24)
replace sec = 6 if inrange(wz08_2_imp, 25,33)
replace sec = 7 if inrange(wz08_2_imp, 41,43)
replace sec = 8 if inrange(wz08_2_imp, 45,46)
replace sec = 9 if wz08_2_imp==47
replace sec = 10 if inrange(wz08_2_imp, 49,53)
replace sec = 11 if inrange(wz08_2_imp, 58,63)
replace sec = 12 if inrange(wz08_2_imp, 55,56)
replace sec = 13 if inrange(wz08_2_imp, 64,66)
replace sec = 14 if inrange(wz08_2_imp, 68,82)
replace sec = 15 if wz08_2_imp==85
replace sec = 16 if inrange(wz08_2_imp, 86,88)
replace sec = 17 if inrange(wz08_2_imp, 90,93) | inrange(wz08_2_imp, 95,96)
replace sec = 18 if wz08_2_imp==94
replace sec = 19 if wz08_2_imp==84


/*
label define sec ///
	1  "1 Agriculture, Forestry and Fishing" ///
	2  "2 Mining and Quarrying; Electricity, Gas, and Water Supply; Sewerage and Waste Mangement" ///
	3  "3 Food Products, Beverages and Tobacco" ///
	4  "4 Consumer Products" ///
	5  "5 Industrial Goods" ///
	6  "6 Capital and Consumer Goods" ///
	7  "7 Construction" ///
	8  "8 Wholesale, Sale and Repair of Motor Vehicles" ///
	9  "9 Retail" ///
	10 "10 Transport and Warehousing" ///
	11 "11 Information and Communication" ///
	12 "12 Hotels and Restaurants" ///
	13 "13 Financial and Insurance Services" ///
	14 "14 Economic, Scientific and Freelance Services" ///
	15 "15 Education" ///
	16 "16 Health and Social Services" ///
	17 "17 Other Services" ///
	18 "18 Representation of Interests" ///
	19 "19 Public Administration, Defence, Social Security" 
*/
	
	
label values sec sec	


label variable sec "Sector (19 Categories)"

merge m:1 sec using "$data\CBA_1218.dta", keepusing(CBA_* wagree_* wcounc)
drop if _merge==2
drop _merge






sort prs_id year betnr ieb_fall_id
order prs_id year betnr ieb_fall_id wz08_* sec isco08_* nuts07_3_* fua_* nuts07_3_fua_* nuts07_3_fua_adj_* east date duration type parttime_imp all reg mar app ret oth regoth regft regothft regothpt female age educ_imp educ2_imp foreign employment_last_* hire_perm_last_* hire_temp_last_* hire_week_13 hire_week_26 hire_week_39 hire_week_52 hire_month_03 hire_month_06 hire_month_09 hire_month_12 hire_year_01 wage_day_imp hire_*_perm HHI_* HHI_L_* ln_HHI_loom_* ln_INS_loom_* ln_HHI_L_loom_* ln_INS_L_loom_* H_* L_* share_isco08_* CBA_* wagree_* wcounc 


save "$data\Final.dta", replace // around 100 GB


